
;============================== TEDZAKKER ==============================
;A music creation tool for the TED chip of the Commodore Plus/4 computer
;2015 Hermit Software Hungary (Mihaly Horvath)
;=======================================================================

Year=2015
Version="1.0"

selfmod=0 ;self-modified code default value
selfmodA=$1111 ;self-modified address default value
cmd_rts=$60 ;for self-modified code (player-handling)
cmd_nop=$EA 


;machine-info ---------------------------------------------------------
.weak
;MACHINE=1 ;set in player ;0:C16(too small memory for the whole program, simplifications), 1:plus4, 2:C64(TED-emulation on SID)
;VIDEO_STANDARD=0 ;PAL or NTSC (Plus4/C16 can be both)
HORIZONTAL_ORDERLIST = 0 ;0:vertical 1:horizontal
.endweak
;features to have (especially needed to disable memory-hungry parts on Commodore16)
.if (MACHINE==0) ;C16
MENU_SUPPORT=0 ;if no menu, C=+L and C=+S can be used as Load/Save commands (, C=+D as disk-directory command, C=+E to export PRG)
TUNEINIT_SUPPORT=0 ;clear ins./tune, set global patt.length
COLOR_SUPPORT=0
INFOBAR_SUPPORT=0
COPYPASTE_SUPPORT=0
HELPTEXT_SUPPORT=0
FILEDIALOG_SUPPORT=0
EXAMPLE_TUNE_SUPPORT=0
PLAYABLE_EXPORT_SUPPORT=0
;PLAYABLE_IMPORT_SUPPORT=0
 RELOCATION_SUPPORT=0 ;depends on PLAYABLE_EXPORT_SUPPORT ; required by RUNNABLE_EXPORT_SUPPORT
RUNNABLE_EXPORT_SUPPORT=0
INSTRUMENT_LOADSAVE_SUPPORT=0
TED_EMULATION_BY_SID_SUPPORT=0
TED_SOUND_SUPPORT=1 ;of course use TED on TED-machines :)... if SID-card is used, TEDzakker is not the best one to compose.
HERMIDI_SUPPORT=0

.elsif (MACHINE==1) ;Plus4
MENU_SUPPORT=1
TUNEINIT_SUPPORT=1 ;clear ins./tune, set global patt.length
COLOR_SUPPORT=1
INFOBAR_SUPPORT=1
COPYPASTE_SUPPORT=1
HELPTEXT_SUPPORT=1
FILEDIALOG_SUPPORT=1
EXAMPLE_TUNE_SUPPORT=1
PLAYABLE_EXPORT_SUPPORT=1
;PLAYABLE_IMPORT_SUPPORT=0 ;unimplemented yet; kinda goes together with PLAYABLE_EXPORT_SUPPORT and RUNNABLE_EXPORT_SUPPORT (in-place decompression of them)
 RELOCATION_SUPPORT=1
RUNNABLE_EXPORT_SUPPORT=1
INSTRUMENT_LOADSAVE_SUPPORT=1
TED_EMULATION_BY_SID_SUPPORT=0
TED_SOUND_SUPPORT=1
HERMIDI_SUPPORT=1

.elsif (MACHINE==2) ;C64
MENU_SUPPORT=1
TUNEINIT_SUPPORT=1 ;clear ins./tune, set global patt.length
COLOR_SUPPORT=1
INFOBAR_SUPPORT=1
COPYPASTE_SUPPORT=1
HELPTEXT_SUPPORT=1
FILEDIALOG_SUPPORT=1
EXAMPLE_TUNE_SUPPORT=1
PLAYABLE_EXPORT_SUPPORT=1
;PLAYABLE_IMPORT_SUPPORT=0
 RELOCATION_SUPPORT=1
RUNNABLE_EXPORT_SUPPORT=1
INSTRUMENT_LOADSAVE_SUPPORT=1
TED_EMULATION_BY_SID_SUPPORT=1 ;by default it makes sound on SID and TED at the same time
TED_SOUND_SUPPORT=0 ;the motivation behind this is to disable TED-writing if wished to avoid writing to $FF0E..$FF12 mem.addresses
HERMIDI_SUPPORT=1
.fi


;machtype=0 ;0:PAL,1:NTSC  ; PAL crystal-osc.frequency: 17.734470MHz, divided by 20 -> mainboard-bus clock: 0.886MHz
TED_PAL_CLOCKFREQ=17734470.00 ;Hz
TED_NTSC_CLOCKFREQ=14318180.00 ;Hz
BUS_PAL_CLOCKFREQ=TED_PAL_CLOCKFREQ/20.00 ;Hz (886723.5Hz)
BUS_NTSC_CLOCKFREQ=TED_NTSC_CLOCKFREQ/20.00 ;Hz (715909Hz)

;Cplus4 info (sound-related are in the player)
.if(MACHINE<2)
ROMoff=$ff3f ;(writing anything to $ff3f disables ROMs)   banksel=$fdd0 ;RAM/ROM banking (?)
ROMon=$ff3e
.else
banksel=$01
.fi
;TED: (sound-related is in player-code)
TED=$FF00 
.if (MACHINE==2)
VIC=$D000
SID=$D400
CIA1=$DC00
CIA2=$DD00
.fi
vmodeyscroll=(MACHINE<2)?  TED+6:VIC+17
cmodexscroll=(MACHINE<2)?  TED+7:VIC+22
keylatch =   (MACHINE<2)?  TED+8:CIA1+1  ;keyboard/joystick input-latch
keymatrix=   (MACHINE<2)?  $fd30:CIA1+0 ;needed to scan keys, not just joysticks
irqstatus=   (MACHINE<2)?  TED+9:VIC+25 ;to refresh in raster-IRQ
irqctrl=     (MACHINE<2)? TED+10:VIC+26 ;default value: $A2, rastercomparator-MSB:bit0, raster-IRQ:bit1, timer-IRQ:bit3/4/6
rasterIRQenable=(MACHINE<2)? $A2:1
rasterIRQdisable=(MACHINE<2)?$A0:0
rastercmp=   (MACHINE<2)? TED+11:VIC+18 ;raster-counter(read) / raster-comparator(write)
.if(MACHINE<2)
curposhi=TED+12
curposlo=TED+13
bitmapaddr=   TED+18
chsetaddr1MHz=TED+19
VRAMaddr=     TED+20
VRAMposhi=    TED+26
VRAMposlo=    TED+27
cursorflashcnt=TED+31
.else
VICbank=CIA2+0
vid_ch_pos=VIC+24
.fi
bgcol    =   (MACHINE<2)? TED+21:VIC+33 ;21...24: background colours 0..3
ECMcapcol=   (MACHINE<2)? TED+22:VIC+34 ;background colour in ECM mode for capital characters
ECMinvcol=   (MACHINE<2)? TED+23:VIC+35 ;background colour in ECM mode for inverted characters
bordcol  =   (MACHINE<2)? TED+25:VIC+32 ;border-colour
vscanpos8=   (MACHINE<2)? TED+28:vmodeyscroll
vscanpos =   (MACHINE<2)? TED+29:rastercmp ;vertical scan-position

tapebuffer=(MACHINE<2)? $0332:$0334
tapebuffer_end=(MACHINE<2)? $03F2:$03FF
instemp=tapebuffer ;temporary place for packed instrument before load/save operation
insnametemp=VRAM+0 ;temporary place for all instrument-names (needed when exporting playable/runnable)

VRAM=(MACHINE<2)? $0C00:$0400 
CRAM=(MACHINE<2)? VRAM-$400:$D800 ;color-RAM and attributes (blink)
ROMstart=(MACHINE<2)? $8000:$A000
rowlen=40
lastcolumn=rowlen-1
rowamount=25
lastrow=rowamount-1

PAL_SCANLINES=$138
NTSC_SCANLINES=$106
singlerast=(MACHINE<2)? $0D0:$0FC


;ZEROPAGE (free areas not used by KERNEL: $D1..$E8) -------------------
devnum_zp = (MACHINE<2)? $AE:$BA

;zp_min=$D1     ;($f9 serial/parallel IEC-flag is used by the loader, altering it causes freezes)
;zeropage locations used by main loop (display/menu/filedialog):
compzp=$D1
datzp=$D3
tempzp=$D5
diszp=$D7
colorzp=$D9
rowzp=$DB
divzp=rowzp
columnzp=$DC
;zeropage used by filedialog only:
filercolumnzp=$DD
filerlenzp=$DE
filerposzp=$DF

;zeropage to be used by IRQ:
idatzp=$E0
keyzp1=$E2
keyzp2=$E3

;player-routine zeropage pointer (the last zeropage never used by KERNEL, so music-routine can be used beside BASIC-prompt)
playzp=$E6 ;($FE would be the last zeropage, but it's cursor-handling work-areas, $FF is ASC/floating work-area)

;packer/relocator zeropage-pointers:
ptnptloadd=$58 ;$57..$70 is used by BASIC-ROM only (for floating point)
ptnpthiadd=$5A
ptninsindexadd=$5C
ptnfxindexadd=$5E
insptloadd=$60
inspthiadd=$62
.if (SUBTUNE_SUPPORT!=0)
seqptloadd=$64
seqpthiadd=$66
.else
orderlistadd=$64
.fi
tunebaseptr=$68
tuneendptr=$6A ;ptrzp=$D0
basediff=$6C

;zeropage for TED-simulations
.if(MACHINE==2)
cposx=$6E
cposy=$6F
cursorflashcnt=$70
.fi
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
inametmptr=$71
.fi


;player & editor - settings -------------------------------------------
;PLAYERADDR=$1800 ;default player address of exported tune - better being automatic
CHANNELAMOUNT=2
repdelay=$d
repspeed=2
pageupdn=8
maxframespeed=8
maxoctave=9
maxnotenum=(maxoctave+1)*12+1
defptnlen=$20 ;(maxptnlen>=$40)? $40: (maxptnlen>=$20)? $20: $10 ;(MACHINE>0)? $40:$20


;settings/theme/config ------------------------------------------------
.if (MACHINE<2)
flashspeed_edit=1 ;20
;flashspeed_jam=0
.fi
bordercolor=(MACHINE<2)? $00:$00
bgcolor=    (MACHINE<2)? $01:$0B
fgcolor=    (MACHINE<2)? $41:$0F
tuneplaybarcol=(MACHINE<2)? $33:$03
pattplaybarcol=(MACHINE<2)? $44:$04
jamplaybarcol= (MACHINE<2)? $22:$02
mulbarcol=     (MACHINE<2)? $03:$06
pattposx=(HORIZONTAL_ORDERLIST>0)? 2:7 ;pattern-editor dimensions
pattposy=2
pattheight=rowamount-(HORIZONTAL_ORDERLIST*(CHANNELAMOUNT+1))-pattposy-1 ;19
trkposy=0
trkwidth=(HORIZONTAL_ORDERLIST>0)? 11:10 ;track-dimensions
trkcurcolumns=5
trkgapx=(HORIZONTAL_ORDERLIST>0)? 1:0
notecolumnx=2
playposcolumnx=notecolumnx+notewidth
instcolumnx=6
fxcolumnx=(HORIZONTAL_ORDERLIST>0)? 9:8
pnotesubpos=0
pinstsubpos=1
pfxsubpos=3
poscolor= (MACHINE<2)? $21:$0C
playposcolor=(MACHINE<2)? $6D:$0E
notecolor=(MACHINE<2)? $71:$01
mutecolor=(MACHINE<2)? $31:$0C
inscolor= (MACHINE<2)? $51:$0F
fxcolor=  (MACHINE<2)? $4C:$03
wfcolor= (MACHINE<2)? $63:$0F
frqcolor=(MACHINE<2)? $61:$0F
volcolor=(MACHINE<2)? $6D:$0F
olicolor=      (MACHINE<2)? $4E:$0F
seqplayposcol= (MACHINE<2)? $77:$01
seqplaymarkcol=(MACHINE<2)? $62:$0D
.if (HORIZONTAL_ORDERLIST==0)
olicolor2=      (MACHINE<2)? $4D:$0F
seqplayposcol2= (MACHINE<2)? $71:$01
seqplaymarkcol2=(MACHINE<2)? $64:$0D
.fi
datacolor=     (MACHINE<2)? $61:$01
notewidth=3
oliposx=(HORIZONTAL_ORDERLIST>0)? 1:0 ;orderlist
oliposy=(HORIZONTAL_ORDERLIST>0)? pattposy+pattheight+1 : pattposy
.if (HORIZONTAL_ORDERLIST>0)
oliwidth=rowlen-2
seqdilen=(HORIZONTAL_ORDERLIST>0)? oliwidth/3+1 : oliheight
.else
oliwidth=2+CHANNELAMOUNT+1
oliheight=pattheight
seqdilen=oliheight
.fi

instbwidth=12
instbcurcolumns=6
instbposx=(HORIZONTAL_ORDERLIST>0)? rowlen-instbwidth-1 : rowlen-instbwidth
instbposy=pattposy
instbaddy=4
instbheight=pattheight-4
iwfcolumnx=3
ifreqcolumnx=6
instb_max_note=$80+maxnotenum
ivolcolumnx=10
iwfsubpos=0
inotesubpos=2
ivolsubpos=4
mainhdwidth=(HORIZONTAL_ORDERLIST>0)? 14:18
mainhdposx=(HORIZONTAL_ORDERLIST>0)? rowlen-mainhdwidth : rowlen-19
mainhdposy=0

menufgcol=    (MACHINE<2)? $65:$03
menubgcol=    (MACHINE<2)? $00:$00
menuhelpcol=  (MACHINE<2)? $11:$0B
menubarcol=   (MACHINE<2)? $13:$06
menuactivecol=(MACHINE<2)? $75:$0D

helpfgcol=(MACHINE<2)? $45:$0D
helpbgcol=(MACHINE<2)? $15:$05

filerfgcol=    (MACHINE==2)? $03: (MACHINE>0)? $63:$61
filerbgcol=    (MACHINE==2)? $06: (MACHINE>0)? $1D:$00
filerbordercol=(MACHINE==2)? $00:$00
extlen=3
maxfilenamelen=16

exefgcol=(MACHINE<2)? $51:$0C
exebgcol=(MACHINE<2)? $00:$00
exebordcol=exebgcol
exebarcol=(MACHINE<2)? $16:$06
exerast1=(MACHINE<2)? $0CC:$0FE ;single-speed raster-row for executable export

stopmode=0
tuneplaymode=1
pattplaymode=2
fastfwdspeed=6

exitmode_noexit=0
exitmode_justlaunch=1
exitmode_softrestart=2
exitmode_restart=3

reloc_hi_min=$02
reloc_hi_max=$FC




;========================== BASIC STARTER-CODE =========================
BASIC_START=(MACHINE<2)? $1001: $0801

        *=BASIC_START
        .word ss,Year
        .null $9e,^start ;SYS command
ss        .word 0

;============================== START ==================================
start   sei
        ;lda devnum_zp ;store used device and put it between 8..15
        ;ora #$08
        lda #ddevice ;and #$0F ;exomizer destroys the drive-number information unfortunately
        sta devicen+1
        sta devnum_zp
        lda #PLAYERTYPE
        sta tuneheader.playertype ;this must be done by code, byte literal didn't work
        jsr ROMdisa
        .if (MACHINE==2)
        lda #3
        sta VICbank
        .fi
        jsr setirq
.if (MENU_SUPPORT>0)
        lda #keymode_menu ;keymode_editor ;starting with menu for the 1st time make sense
        sta keyermode  ;sta menusig+1 ;start with editor, not menu
        lda #0
        sta menupoint
        sta cursubtune
        jsr player.initzak ;INIT, subtune in Accu
        jmp menu
.fi
restart ;sei
        jsr ROMdisa
        lda #0
        sta cursubtune
        sta playmark+0
        sta playmark+1
        jsr setsubt ;jsr player.initzak ;INIT, subtune in Accu
        lda #1
        sta currins
        lda #$FF
        sta mutesolo+0
        sta mutesolo+1
restrt1 ;sei
        jsr ROMdisa
        lda #stopmode
        sta playmode
        lda #1
        sta jammode
        lda #0
        sta player.currnote+0
        sta player.currnote+1
        jsr player.softini ;jsr player.silence
launche ;sei
        jsr ROMdisa
        jsr iniscrn
        jsr waitkeyrelease
        lda #keymode_editor
        sta keyermode
        lda #exitmode_noexit
        sta exitsig
        jsr setirq
        cli


;============================ MAIN LOOP ================================
mainloop
menusig lda keyermode ;lda #selfmod
        cmp #keymode_menu
        bne refresh
 .if (HERMIDI_SUPPORT>0)
        sei
        lda HerMIDIswitch
        beq gomenu
        ;lda HerMIDI.StatusByte
        ;bne gomenu
        jsr HerMIDI.PowrOFF
        lda #0
        sta MIDIsig+1
 .fi 
gomenu  jmp menu
refresh jsr display
chexits lda exitsig
        ;cmp #exitmode_noexit
        beq mainloop
        cmp #exitmode_justlaunch ;e.g. exiting from help / menu
        beq launche
        cmp #exitmode_softrestart ;e.g. loading new instrument or partial musicdata-deletion (ins/tune) -> stop playback
        beq restrt1
        cmp #exitmode_restart ;e.g. loading new tune
        beq restart
        jmp restart


.if (MACHINE==2)
.align $40
cursprite
    .byte %01111111,%10000000,%00000000
   .for i=0,i<7,i=i+1
    .byte %10000000,%01000000,%00000000
   .next
    .byte %01111111,%10000000,%00000000
   .fill (21-9)*3+1
.fi



;=======================================================================
;file-dialog and saver/loader routines should be in the lower memory area to avoid clash with ROM/RAM-on/off banking
;due to the lack of individual BASIC/KERNAL ROM/RAM switching, saver routines should turn ROM on/off for each bytes/blocks to transfer
;ROM routine jumptable addresses
KERNAL .block
.if (MACHINE<2)
 IRQ = $FCB3
 SCREENPOS = $D839 ;read/write current screen/cursor position ; input: Carry=0:set, Carry=1:get, input/output: Y-register: X-coordinate, X-register: Y coordinate
 CURSORLEFT= $DD1C ;step cursor left
 GETIN = $EBD9 ;get character from keyboard
 CHKRUNSTOP = $FFE1 ;returns 0 (Z-flag=1) if RUNSTOP is pressed
.fi
SETNAM = $FFBD ;Set file name parameters. Input: A = File name length; X/Y = Pointer to file name. (Real address: $FDF9)
SETLFS = $FFBA ;Set file parameters. Input: A = Logical number; X = Device number; Y = Secondary address. (Real address: $FE00)
OPEN   = $FFC0 ;Open file. (Must call SETLFS and SETNAM beforehands.) Used registers: A, X, Y. (Real address: ($031A), $F34A)
CLOSE  = $FFC3 ;Close file. Input: A = Logical number. Used registers: A, X, Y. (Real address: ($031C), $F291.)
CHKIN  = $FFC6 ;Define file as default input. (Must call OPEN beforehands.) Input: X = Logical number. Used registers: A, X. (Real address: ($031E), $F20E)
CHRIN  = $FFCF ;(BASIN)Read byte from default input (for keyboard, read a line from the screen). (If not keyboard, must call OPEN and CHKIN beforehands.) Output: A = Byte read. Used registers: A, Y. (Real address: ($0324), $F157.)
CHKOUT = $FFC9 ;Open a channel for output (Registers affected:  A, X), input: A=data, X = logical file number , Real address: ($0320), $F250.
CHROUT = $FFD2 ;(BSOUT) Write byte to default output. (If not screen, must call OPEN and CHKOUT beforehands.) Input: A = Byte to write. (Real address: ($0326), $F1CA)
CLRCHN = $FFCC ;Close default input/output files (for serial bus, send UNTALK and/or UNLISTEN); restore default input/output to keyboard/screen. Used registers: A, X. (Real address: ($0322), $F333)
SCINIT = $FF81 ;Initialize VIC; restore default input/output to keyboard/screen; clear screen; set PAL/NTSC switch and interrupt timer. Used registers: A, X, Y. (Real address: $FF5B.)
SAVE   = $FFD8 ;SAVE. Save file. (Must call SETLFS and SETNAM beforehands.) Input: A = Address of zero page register holding start address of memory area to save; 
               ;X/Y = End address of memory area plus 1. Output: Carry: 0 = No errors, 1 = Error; A = KERNAL error code (if Carry = 1). (Real address: $F5DD.)
LOAD   = $FFD5 ;LOAD. Load or verify file. (Must call SETLFS and SETNAM beforehands.) Input: A: 0 = Load, 1-255 = Verify; X/Y = Load address (if secondary address = 0).
               ;Output: Carry: 0 = No errors, 1 = Error; A = KERNAL error code (if Carry = 1); X/Y = Address of last byte loaded/verified (if Carry = 0). Used registers: A, X, Y. (Real address: $F49E.)  
READST = $FFB7 ;Fetch status of current device, value of ST variable. (For RS232, status is cleared.),No Input , Output: A = Device status., Used registers: A.,Real address: $FE07.
.bend

ddevice=8 ;default disk device

filedialog	.proc			;input:Accu - extension read directory, typing filename, return filename in 'namebuf'
maxnamelen=12 ;maximum filename-length to display
extlen = 4 ;extension-length (with dot)
namesep= $22 ; " filename-delimiter character code
RETURNcode=13 ;return/enter (carreturn) charactercode  (signs end of directory)
dirname .byte $24		;.asc "$" ;$ is the name of disk-directory


.if (FILEDIALOG_SUPPORT>0)

dirxpos= 1 ;filelist X screen position
dirypos= 4 ;filelist Y screen position
namecolums= 3 ;number of filename-columns (screenwidth divided by max. filename-length
dirvmem= VRAM+dirypos*40+dirxpos ;Video-RAM base memory address of filelist
disknam= VRAM+40*24+5 ;Video-RAM place of diskname $ disk-ID (disk-header)
diskfree=VRAM+40*24+35 ;place of free disk-place display
filenamp=VRAM+10 ;filename-position on screen
authorip=VRAM+40*2 ;author-info screen-position
filelistheight=19 ;height of file-lister/selector subwindow
filelstmax= filelistheight*namecolums ;maximum length of filelist that can be displayed on 1 screen

fdialog jsr initfiler ;this entry point doesn't pull the directory in automatically, need to press F1 for that
        jsr clrfsel ;sets filecnt to 0, so F3 won't run anything if no F1 pressed before
        jmp typesel 

reredir jsr initfiler

readdir lda #$01		;	filename-length is 1
		ldx #<dirname	;	lo byte pointer to file name. ("$")
		ldy #>dirname	;	hi byte pointer to file name. ("$")
		jsr inifnam		;init filename memory position and length
		jsr KERNAL.OPEN		; - call open
		bcs NOredir		;if error
		jsr KERNAL.READST
		bne NOredir		;if error
		ldx #$01		;	file #1 ;if no error (device is present), just go forward
		jsr KERNAL.CHKIN		; - call chkin to set input file #.
;read and display disk-header
		jsr KERNAL.CHRIN
		cmp #$C3		;normally first byte is $01, VICE gives $C3 if device is not present
		bne +			;if Carry remained set, no device is present
NOredir	jsr nodevic		;if error opening device, notify user
		jmp typesel		;and skip filelist-making, still give a chance to return to e.g. editor and change drive-number
+		ldx #6
-		jsr KERNAL.CHRIN		;read through some unneeded characters (amount given in X)
		dex
		bne -
		ldx #0			;read diskname & ID
		stx dirready	;signs if directory fully read
-		jsr KERNAL.CHRIN
		beq listfil
        cmp #$60
        bcc +
        and #$1F
+		ora #$80
		cpx #24			;don't allow too long diskheader to be displayed (crop beginning to max. length)
		bpl +
		sta disknam,x	;standard 'jsr CHROUT' is not good for special display modes
+		inx
		bne -
;parse and display directory for filesizes and names
listfil jsr clrfsel		;clear file-selector area, init file-listing variables
flistlo ldx #3			;file-lister loop
-		jsr KERNAL.CHRIN		;get filesize (last one will be filesize in blocks)
		sta sizebuf,x	;sizebuf might be displayed or filesizes stored in a filesize-list to help user calculate
		dex
		bpl -
-		jsr KERNAL.CHRIN		;check for beginning of filename (1st " delimiter)
		cmp #RETURNcode ;return/enter signal - check for end of dir/filelist
		beq closdir		;if end of filelist, close device
		cmp #namesep
		bne -			;search for left " filename-delimiter
		ldy #0			;start checking&copying filename
-		jsr KERNAL.CHRIN
		cmp #RETURNcode ;return/enter signal - check for end of dir/filelist
		beq closdir		;if end of filelist, close device
		cmp #namesep	;check for filename end (right " filename-delimiter)
		beq frowend		;find $00 row-delimiter
		sta namebuf,y	;loads actual filename to buffer
		iny
		cpy #17			;maximum allowed filename-length for C64/Plus4 devices
		bne -
frowend jsr KERNAL.CHRIN		;check for $00 - end of line of filename, then comes beginning of next line pointer and filesize/freeblocks info
		bne frowend
chekext lda filecnt
		cmp #filelstmax ;check displayable filelist max. length
		bcs typesel		;if reached all displayable content, go to type/select name or read next dir. page
		;or bcs flistlo ;if reached, no further displaying, just checking rows for filesizes, etc.
		dey				;check name for .SWM/.SWI extension
		ldx #extlen-1	;check 4 character long (with dot) filename-extension to filter on filetypes (.SWM/.SWI)
-		lda namebuf,y
		cmp tzftype,x
		bne flistlo		;if there was any difference between extension and end of filename-string, don't display filename
		dey
		bmi flistlo		;if filename is empty (only extension), no point to display
		dex
		bpl -
dispnam lda namebuf,y
		cmp #$20		;is last character SPACE? -then sign it with a delimiter character
		bne dispnlp		;if not SPACE, simply display filename
		lda #$20+$40	;the invisible space will sign real end of 'space-ended' filename to loader/saver routine
		bne +			;jump
dispnlp lda namebuf,y	;filename-displayer loop
+		sta (diszp),y
		dey
		bpl dispnlp
		inc filecnt		;count displayed filenames
nextrow jsr cycfcol		;cycle filer-column counter, Y output is tabbing amount ;go to next screenplace for next filename
		jmp flistlo		;back to read next line

closdir inc dirready	;sign that directory fully read
		lda sizebuf+1	;display free kilobytes on disk in decimal format (divide blocks by 4)
		lsr sizebuf+0	;divide by 2
		ror
		lsr sizebuf+0	;divide by 2 (4 in sequence)
		ror
		ldx #100		;convert
		jsr divideX
		sty diskfree+0
		ldx #10
		jsr divideX
		sty diskfree+1
		tax
		lda hexdigi,x
		sta diskfree+2
		jsr clsfile

;-------type filename or author info / select file to load/save--------------
typesel ;sei				;type/select filename & description
        jsr ROMdisa
        jsr waitkeyrelease
		lda #keymode_filer	;set filename-typer mode in key-handler
		sta keyermode
defawin lda #0			;self-written - default filer-window (selector is preferred in case of loader)
		beq +
		jsr setsele		;set filename-selector subwindow as default for loader
		jmp fkeylop
+		jsr setfnam		;set filename-typer subwindow by default
fkeylop lda #$CC
		cmp vscanpos    ;constant 50Hz timing loop for keyboard-handler and cursor-displayer
		bne *-3
		lda #0
		sta fkeybout	;reset keyhandler output
		jsr keyer   	;handles key-repeating and name-mode
		jsr disfcur		;display filer-cursors
		lda fkeybout	;keyhandler-output
		cmp #keychr.fdir ;$f8	;F1 key check
		bne +			;if F1 pressed, re-read directory
		jsr regauth		;clsfile ;close dir., save typed author-info to re-read filelist
		jmp reredir		;readdir ;re-read directory/file-list
+		cmp #keychr.fpdn ;$f9		;F3/UP(PageDown) key check
		bne +			;if F3/Pagedown pressed, flip to next page of disk-directory (if exists)
		lda dirready	;check, if directory fully read
		bne lopover		;if directory read entirely, no further paging
        lda filecnt
        beq + ;no F1 pressed before or no filelist -> F3 shouldn't take effect
		jmp listfil		;further read filelist
+		cmp #keychr.fexi ;$fe		;if stop/esc pressed, returning to editor (abort file-operation)
		bne +			;$fe/$ff
		jsr regauth		;clsfile ;close directory-file - register author-text
        jsr ROMdisa
        lda #keymode_menu
        sta keyermode
		sec				;cause file-dialog abort in main routine (restart editor)
		rts
+		cmp #keychr.facc ;$ff		;if RETURN/Enter pressed, take action (load/save)
		bne lopover
		ldy filerwindow
		cpy #1
		beq +
		jsr regname		;register filename in 'namebuf' and author-info
        jsr ROMdisa
        lda #keymode_menu
        sta keyermode
		clc				;cause load/save in main routine, if return pressed window 1 or 2 (filename/file-selector)
		rts
+		jsr setfnam		;if window 1, go back to filename-typer
lopover jmp fkeylop

;-----------------------------------------------------------------------
initfiler
        sei				;init ROM $ VICbank and read disk directory to the screen
        lda #$1b        ;leave extended-colour mode
        sta vmodeyscroll
        lda #filerfgcol
        jsr clearscrn
        lda #filerbgcol
        sta bgcol
        lda #filerbordercol
        sta bordcol
        jsr ROMena
        lda #rasterIRQdisable
        sta irqctrl ;disable raster-IRQ
		ldy #rowlen-1	;draw UI base
-		lda filetx1,y
		sta VRAM+0,y;filename and type (extension)
		lda #$62+$80	;$78  ;$71 ;$68
		sta VRAM+rowlen,y;separator line 1
		sta VRAM+rowlen*3,y;separator line 2
		sta VRAM+rowlen*23,y;separator line 3
		lda authorinfo,y
skipaut sta authorip,y	;author info and title
		lda filetx2,y
		sta VRAM+rowlen*lastrow,y;diskname and free space
		dey
		bpl -
        jmp smallch

;----------------------------------file-dialog subroutines----------------------------------
filenamer				;handles filename-typing/selection (called from keyer/nametyper routine in keyhandler.inc, char passed in Accu, keycode in Y)
		sta fkeybout	;for main routine
		cmp #$fa		;Control/TAB keys - cycle filer sub-windows
		bne filkeys
		ldy filerwindow
		bne +			;if filename-subwindow
		iny				;set Y to 1
		lda editauth	;if loader, no author-info editing, skipping that
		beq setsele		;if player.authorinfo editing disabled (=0) go straight to selector
		lda #authorinfo_len-1
		sta filerlenzp	;length of input-field
		lda #<authorip
		ldx #>authorip
		jmp setyfld		;set typer field
+		cpy #1
		beq setsele		;if 1 set filename-selector subwindow
		clc
		jsr diselcu		;first clear selector-cursor
		jmp setfnam		;then cycle back to filename-typer window
setsele lda filecnt		;set file-selector
		beq setfnam		;if filelist is empty, don't go to selector, go back to / stay at filename-typer instead
		lda #<dirvmem
		ldx #>dirvmem
		jsr inicptr		;set video-pointers
		sec				;set display-mode for cursor
		jsr diselcu		;display file-selector cursor
		ldy #2			;set to 2
		bne setyfld		;jump
setfnam lda #maxnamelen-1
		sta filerlenzp	;length of input-field
		lda #<filenamp
		ldx #>filenamp
		ldy #0
setyfld sty filerwindow ;branched to here if filer-window was 2
setyfl2 jsr inidptr		;takes A , X
		lda #0
		sta filerposzp	;reset cursor-position
		sta filercolumnzp	;counts filename-selector columns
		rts

filkeys ldx filerwindow ;handle keys depending on subwindow---------------------------------
		cpx #2
		bne typefld		;if not file-selector window, go to typer ;if file-selector subwindow, use cursor keys and Return only
        cmp #keychr.fcdn ;$81
        beq fiselUD
		cmp #keychr.fcup ;$82		;cursor up/down
		bne +
fiselUD	jsr fiselLR		;3 columns
		jsr fiselLR
		jmp fiselLR
+		cmp #keychr.fcle ;$83		;cursor left/right
		beq fiselLR
        cmp #keychr.fcri ;$84
        bne endfiln
fiselLR clc				;clear cursor
		jsr diselcu		;clear file-selector-cursor
		jsr fiselec		;change cursor-pointer if possible
		sec				;draw cursor
		jmp diselcu		;draw file-selector-cursor
fiselec .if (MACHINE<2)
        lda fkeybout	;the effective algorithm itself to select file
        cmp #keychr.fcle ;$83
		beq fselbwd
        cmp #keychr.fcup ;$82
        beq fselbwd
        .else
        lda shiftsig
        bne fselbwd
        .fi
fselfwd ldy filerposzp
		iny
		cpy filecnt
		bcs endfiln
		inc filerposzp

cycfcol inc filercolumnzp	;column-tabbing counter
		ldx filercolumnzp
		cpx #namecolums
		bne +
		ldx #0
		stx filercolumnzp
+		ldy colutab,x
		jmp incompt

fselbwd lda filerposzp	;filename-count
		beq endfiln
		dec filerposzp
		ldx filercolumnzp
		ldy colutab,x
		dec filercolumnzp	;cycle filer-column counter
		bpl +			;if column-turnaround, compensate non-integer divisibility of screen width per filename-columns
		ldx #namecolums-1
		stx filercolumnzp
+		jmp decptrs

typefld ldy filerposzp	;handle typing fields------------------------------------------------
		cmp #keychr.fhom ;$85
		bne +			;Home-key?
		lda #0
		sta filerposzp
		rts
+		cmp #keychr.fins ;$86		;insert?
		beq +
		cmp #keychr.fdel ;$80		;backspace?
		bne cursidw
		lda shiftsig	;Insert? (Shift+Backspace)
		beq bkspclp
+		ldy filerlenzp
-		cpy filerposzp
		beq clrcurp
		dey
		lda (datzp),y   ;shift letters forward
		iny
		sta (datzp),y
		dey
		bpl -
clrcurp lda #$20
		sta (datzp),y
endfiln rts
bkspclp jsr fcurbwd
		ldy filerposzp
-		cpy filerlenzp
		beq clrcurp		;BACKSPACE character to last cursorplace
		iny
		lda (datzp),y   ;shift letters back
		dey
		sta (datzp),y
		iny
		jmp -
cursidw .if (MACHINE<2)
        cmp #keychr.fcri ;$84		;cursor-sideways keys?
		beq fcurfwd
		cmp #keychr.fcle ;$83
		bne norchar
        .else
        cmp #keychr.fcri
        bne norchar
		lda shiftsig
		beq fcurfwd
        .fi
fcurbwd cpy #0			;move cursor backwards in name-field
		beq endfiln
		dec filerposzp
		rts
norchar cmp #0
		bmi endfiln		;avoid typing characters for remaining control characters
		sta (datzp),y;normal character branch
fcurfwd cpy filerlenzp	;move cursor forward (if possible)
		bpl endfiln
		inc filerposzp
		rts

;--------------------------------------------------------------------------------
disfcur					;display cursor over typed data
		jsr clrcurs		;clear type-fields from cursor invertions
		lda filerwindow
		cmp #2			;selector?
		beq +
		ldy filerposzp	;display text-typer cursor
		lda (datzp),y
		ora #$80
		sta (datzp),y
+		rts
diselcu ldy #maxnamelen-1;display/clear file-selector cursor (action depends on Carry-bit, displays if Carry=1, clears if Carry=0)
-		lda (diszp),y
		and #$7f		;clear cursor
		bcc +			;if Carry bit set
		sta filenamp,y
		ora #$80		;set cursor
+		sta (diszp),y
		dey
		bpl -
		rts
clrcurs ldy #maxnamelen-1;clear type-fields from cursor invertions
-		lda filenamp,y
		and #$7f
		sta filenamp,y
		dey
		bpl -
		ldy #authorinfo_len-1;clear cursor
-		lda authorip,y
		and #$7f
		sta authorip,y
		dey
		bpl -
		rts

;--------------------------
regname jsr clrcurs		;start by clearing type-fields from cursor invertions
		ldy #maxnamelen-1;copy/register typed/selected filename and author-info (latter only if editauth is on
-		lda filenamp,y	;loop search back to first non-Space character
		cmp #$20		;check for spaces (if filename is 'spaced;, $60 Space will be noticed)
		bne +			;if not space coming, we found end of filename (without extension), and we can add the extension to it
		dey
		bpl -			;if not looped here, empty filename
+		iny
		sty filercolumnzp	;copy filename before last space
		beq +			;zero filename
		ldy #0
-		lda filenamp,y
		sta namebuf,y
		iny
		cpy filercolumnzp	;stored length of filename
		bne -
+		ldx #0			;add extension
-		lda tzftype,x	;read extension-string
		sta namebuf,y	;add it to namebuf.
		iny
		inx
		cpx #extlen
		bne -
		sty bufnlen+1	;register buffered name's length
regauth lda editauth
		beq clsfile		;if author-info being edited, register it in tune-header
		ldy #authorinfo_len-1;hardwired author-info length
-		lda authorip,y
		sta authorinfo,y
		dey
		bpl -
clsfile jsr ROMena
		lda #1			;	file # to close
		jsr KERNAL.CLOSE		; - so close it
		jmp KERNAL.CLRCHN		; - clear all channels

clrfsel	;clear file-selector area, init file-listing variables
        jsr ROMena
		lda #<dirvmem
		ldx #>dirvmem
		jsr inicptr		;set video-pointers
		ldx #0			;clear filelist-area
		stx filecnt		;counts displayed filenames
		stx filercolumnzp	;counts columns
fsclrlp ldy #rowlen-2
		lda #$20		;Space character
-		sta (datzp),y
		dey
		bpl -
		lda #rowlen		;one row forward
		jsr incptrs		;increase datzp	 ;iny -> Y=0 -> preserve diszp
		cpx #filelistheight
		bne fsclrlp
		rts

nodevic					;if OPEN failed, warn user and ask for retrial
		ldy #28			;display 'device not present'	(and later ask for overwrite-confirmation)
-		lda nodevicep,y
		sta VRAM+rowlen*lastrow,y
		dey
		bpl -
		rts ;jmp waitspace
		
filetx2 .text "DR:   .....................   FREE:...KB"

;scratch .text "S0:" ;Scratch-signal (OPEN 15,8,15,"S0:file name":CLOSE 15) - will preceed filename when user want to overwrite a file (Save&Replace "@filename" is buggy in old 1541 drives)
namebuf .fill 16		;filename-buffer (for extension-checking and for disk-operations)
		.fill 10		;for safety reasons, if filename gets appended by commands

sizebuf .fill 4			;(byte 0 and 1) filesize-temp-storage, after reading dir., free blocks (last 2 bytes (row-pointers) not needed)
colutab .byte maxnamelen+2,maxnamelen+1,maxnamelen+1;column-tabbing values (to get screenwidth as sum) (14+13+13=40)
filecnt .byte 0			;amount of displayed files in directory
dirready .byte 0		;value is 1 if directory is fully read
editauth .byte 0		;0 - no author info display $ edition, 1 - autor info displayed & editable
filerwindow .byte 0		;window in file-menu: 0-filename-typer , 1-player.authorinfo-typer, 2-file-selector
fkeybout .byte 0		;keyboard-routine output of filer's keyboard handler - used by main loop to take some actions

;error messages in filer window, 29 character long each
nodevicep .text " NO DISK OR DRIVE PRESENT!!! "
fnotfound .text " FILE NOT FOUND! PRESS A KEY."
;filexists .text "ERROR! (EXISTS?) PRESS SPACE."
saveerror .text " SAVING ERROR 0! PRESS A KEY."

filenot ;jsr clsfile		;in case of error, close to allow further trials
		ldy #28			;Display 'file not found' message and wait for SPACE
-		lda fnotfound,y
		sta VRAM+lastrow*rowlen,y
		dey
		bpl -
		jmp waitkey

saverror ldy #28			;Display 'save error' message and wait for SPACE
-		lda saveerror,y
		sta VRAM+lastrow*rowlen,y
		dey
		bpl -
		jsr KERNAL.READST		;read status error-code
		clc
		adc #"0"		;shift numbering for status-number display to be PETSCII compatible
		sta VRAM+lastrow*rowlen+14;display status error-code
		jmp waitkey	;wait for key press/release

;!these pointer routines may be used by many other parts of the code , don't touch them, not even rearrange them!!!
inicptr					;lo-pointer in A, hi-pointer in X, set zeropage pointers - order of entry points is important!
		sta tempzp
		stx tempzp+1
ctempzp lda tempzp
		sta diszp
		ldx tempzp+1
		stx diszp+1
inidptr sta datzp
		stx datzp+1
		rts

incptrs					;increase source zeropage pointers by boundary size in A, and target pointer by Y value
		iny
incopt2 clc
		adc datzp
		sta datzp
		bcc incompt
incptnp inc datzp+1
incompt tya
incmpt2 clc
		adc diszp
		sta diszp	;set compressed data pointer to next position
		bcc +
		inc diszp+1
+		inx
		rts

decptrs tya
deccptr sta astore4+1
		lda diszp
		sec				;input: Accu -decrease 16bit player.tunedata-pointers by value given in a
astore4	sbc #selfmod
		sta diszp
		bcs +
dechptr dec diszp+1
+		dey
		rts

filetx1 .text "FILENAME:             "
		.byte $75		;the ruler between filename and extension display
		.text "(FILETYPE: *";. 'tzftype' should follow it immediately
tzftype .text ".TZM)"	;OR-file type - string to search extension in filenames to filter on tune/instrument


divideX ;.proc
        stx divzp	;divide A by divisor X, remainder is in A for further division, Y gets charcode to display
		ldx #0
-		sec
		cmp divzp	;compare divisor
		bcc +
		sbc divzp	;substract divisor
		inx
		bne -			;jump
+		
		ldy hexdigi,x
retdivX rts
        ;.pend


;-----------------------------------------------------------------------
.else ;no filedialog-support? simple typing when saving/loading using KERNAL routines, but directory should be requestable with $
;tzftype .text ".TZM"
namebufx=1
namebufy=2
namebuf=VRAM+namebufy*rowlen+namebufx

fdialog sei
        lda #filerbgcol
        sta bgcol
        sta bordcol
        jsr smallch ;capitch ;smallch
        jsr hidecursor
        lda #<KERNAL.IRQ  ;jsr $FF84, jsr $FF8A does similar
        ldx #>KERNAL.IRQ
        sta $FFFE
        stx $FFFF
        jsr ROMena
        jsr KERNAL.CLRCHN
        lda #$71                 ;lda #$84 ;jsr KERNAL.CHROUT ;flash off
        sta $0114 ;exomizer ruined yellow colour, so restore it 
        lda #$05 ;white colour
        jsr KERNAL.CHROUT
        lda #filerfgcol
        jsr clearscrn
        jsr waitkeyrelease
        ldy #rowlen-1
-       lda filenametxt,y
        sta VRAM,y
        dey
        bpl -
        lda #namesep
        sta VRAM+2*rowlen
resetsp ldy #namebufx
        ldx #namebufy ;lastrow
        clc
        jsr KERNAL.SCREENPOS
        cli
        jsr KERNAL.GETIN
        bne *-3 ;empty buffer
ftypelp lda #namesep ;$22 ;display " as cursor-character
        jsr KERNAL.CHROUT
        jsr KERNAL.CURSORLEFT
        jsr KERNAL.GETIN
        beq ftypelp
        bmi ftypelp
        cmp #namesep ;$22
        beq ftypelp ;don't allow typing "
        sec
        jsr KERNAL.SCREENPOS
        cmp #$03 ;RUNSTOP? 
        bne +
        rts ;Carry-flag=1 return-value is set by 'cmp'   
+       cmp #$0d
        beq fntyped
        cmp #$14 ;delete?
        bne +
        cpy #namebufx
        beq ftypelp ;resetsp
        jmp ++
+       cmp #$20
        bcc ftypelp
        cpy #namebufx+maxfilenamelen
        beq ftypelp
+       jsr KERNAL.CHROUT ;BSOUT
        jmp ftypelp
fntyped dey
        beq dispdir
        sty bufnlen+1
regname dey
-       lda namebuf,y ;namebufx ;nonzero? set Carry-flag return-value accordingly
        cmp dirname ;$?
        beq dispdir
        cmp #$20
        bcs +
        ora #$40
+       sta namebuf,y
        dey
        bpl -
        clc
        rts
dispdir jsr clearscrn
        ldx #0
        ldy #0
        clc
        jsr KERNAL.SCREENPOS
        lda #1	    	;	filename-length is 1
		ldx #<dirname	;	lo byte pointer to file name. ("$")
		ldy #>dirname	;	hi byte pointer to file name. ("$")
		jsr inifnam		;init filename memory position and length
		jsr KERNAL.OPEN		; - call open
		bcs filenot ;nodevic		;if device-not-present error
		ldx #$01		;	file #1 ;if no error (device is present), just go forward
		jsr KERNAL.CHKIN		; - call chkin to set input file #.
dirdilp jsr KERNAL.READST
        bne endrdir
        jsr KERNAL.CHRIN
        cmp #namesep
        bne dirdilp
-       jsr KERNAL.CHRIN
		cmp #namesep	;check for filename end (right " filename-delimiter)
		beq +     		;find $00 row-delimiter
		jsr KERNAL.CHROUT
		bne -
+       lda #RETURNcode
        jsr KERNAL.CHROUT
        sei
-       lda #0 ;$7F
		sta keymatrix
        sta keylatch
 		lda keylatch		;wait for keys to be released, especially RETURN
		and #$7F
        cmp #$7F
		bne -
        jsr KERNAL.CHKRUNSTOP ;RUN-STOP pressed?  ;also clears keyboard-buffer
        bne dirdilp
endrdir lda #1
        jsr KERNAL.CLOSE
        jsr KERNAL.CLRCHN
        jsr waitkey
        jmp fdialog

saverror
filenot sei 
        lda #2
        sta bordcol
        jmp waitkey ;Carry-flag is set to 1 inside
.enc screen
filenametxt .text "eNTER fILENAME ($/EMPTY:DIR,rUNsT:BACK):"
.enc none
.fi ;end of FILEDIALOG_SUPPORT


.pend ;end of file-dialog procedure
;=======================================================================



clearscrn ;input: Accumulator - foreground-color
        sta clrcolo+1
        ldy #0
-       lda #" "
        sta VRAM,y
        sta VRAM+$100,y
        sta VRAM+$200,y 
        sta VRAM+$300,y
clrcolo lda #selfmod
        sta CRAM,y
        sta CRAM+$100,y
        sta CRAM+$200,y
        sta CRAM+$300,y
        iny
        bne -
        rts

capitch .if (MACHINE<2)
        lda #$C4
        sta bitmapaddr
        lda #$D0 ;normal (CAPITAL) character set (bit2)
        sta chsetaddr1MHz
        .else
        lda #$15 ;normal character set
        sta vid_ch_pos
        .fi
        rts

smallch .if (MACHINE<2)
        lda #$C4
        sta bitmapaddr
        lda #$D0+4 ;small character set (bit2)
        sta chsetaddr1MHz
        .else
        lda #$16 ;small character set
        sta vid_ch_pos
        .fi
        rts

waitkeypress
-       lda #$80
        cmp vscanpos ;synchronizing to frames provides button-debouncing
        bne *-3
        lda #$00
        sta keymatrix
        sta keylatch
        lda keylatch
        cmp #$ff
        beq -
        rts

waitkey jsr waitkeyrelease
        jsr waitkeypress
waitkeyrelease
-		lda #$80 ;<singlerast
        cmp vscanpos ;synchronizing to frames provides button-debouncing
        bne *-3
        lda #$00
		sta keymatrix
        sta keylatch
		lda keylatch		;wait for keys to be released, especially RETURN
		cmp #$ff
		bne -
        rts ;Carry=1 on exit

.if (TUNEINIT_SUPPORT>0 || EXAMPLE_TUNE_SUPPORT>0)
YesOrNo					;wait for Y/N and set Carry accordingly (1 if Y)
		sei
YNloop  lda #$e7
		sta keymatrix
-       sta keylatch
    	ldy keylatch
		cpy #($ff-2)	;Y key (or I key)?
		bne +
        jsr waitkeyrelease
		sec
		rts
+		cpy #($ff-$80)	;N (or V) key?
		bne -     		;key-testing loop
        jsr waitkeyrelease
		clc
		rts

RyouSur					;Ask 'are you sure', wait for Y/N and set Carry accordingly (1 if Y)
RyouXpos = 12
RyouYpos = 10
RyouCol = $71
        lda #$12
        sta ECMcapcol
		ldy #16
-		lda #"*"		;DECOR
		sta VRAM+rowlen*(RyouYpos+0)+RyouXpos,y
		sta VRAM+rowlen*(RyouYpos+3)+RyouXpos,y
		lda #RyouCol
		sta CRAM+rowlen*(RyouYpos+0)+RyouXpos,y
		sta CRAM+rowlen*(RyouYpos+1)+RyouXpos,y
		sta CRAM+rowlen*(RyouYpos+2)+RyouXpos,y
		sta CRAM+rowlen*(RyouYpos+3)+RyouXpos,y
		lda RyouSurTx,y
		sta VRAM+rowlen*(RyouYpos+1)+RyouXpos,y
		lda RyouSurT2,y
		sta VRAM+rowlen*(RyouYpos+2)+RyouXpos,y
		dey
		bpl -
		jmp YesOrNo
dpywmk0 ldy #27
-       lda trksubpos,y
        dey
        lsr
        sta VRAM+$3B7,y
        bcc -
        rts
.enc screen
RyouSurTx .text "* ARE YOU SURE? *"
.enc none
RyouSurT2 .text "*  (Y/N) (I/N)  *"
.enc none
.fi


hexdisp pha
        lsr
        lsr
        lsr
        lsr
        tax
        lda hexdigi,x
        sta xstore1+1
        pla
        and #$0f
        tax
        lda hexdigi,x
xstore1 ldx #selfmod
        rts


.if (MENU_SUPPORT>0 || FILEDIALOG_SUPPORT>0)
decdisp ;.proc			;decimal display - input:accu, output: in Accu and Y-register
		ldy #$2f
		sec
-		iny
		sbc #10
		bcs -
		adc #$3a
		rts
		;.pend
.fi


ROMena  .if (MACHINE<2)
        sta ROMon ;enable KERNAL and BASIC ROMs
        .else
        lda #$36  ;enable KERNAL ROM
        sta banksel
        .fi
        rts

ROMdisa sei
        .if (MACHINE<2)
        sta ROMoff ;disable KERNAL and BASIC ROMs
        .else
        lda #$35
        sta banksel ;disable KERNAL and BASIC
        .fi
        rts

hidecursor
        .if (MACHINE<2)
        lda #$ff ;hide cursor
        sta curposlo
        sta curposhi
        .else
        lda #0 
        sta $d015
        .fi
        rts

iniwfn	;init workfile name pointer and length, bank, and device,file,channel
        jsr ROMena
        jsr KERNAL.CLRCHN
bufnlen lda #selfmod	;self-written code - length of selected/typed filename
		ldx #<filedialog.namebuf
		ldy #>filedialog.namebuf
inifnam jsr KERNAL.SETNAM		;init filename pointer and length, and device,file,channel
devicen ldx #ddevice	;self-written, device # 8 is default (modifiable by user)
.if (MENU_SUPPORT>0 || FILEDIALOG_SUPPORT>0)
		txa
		jsr decdisp
		sty VRAM+$3c3
		sta VRAM+$3c4
.fi
		lda #1			;	file # 1
		ldy #0			;	channel # 0 - (in case of LOAD: if 1, load to address automatically, if 0, address can be given in X/Y)
		jmp KERNAL.SETLFS		; - call setlfs


.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
appendPRGW ldx bufnlen+1	;length of selected/typed filename with extension
		ldy #0
-		lda PRGwriTxt,y
		beq +			;end of string?
		sta filedialog.namebuf,x
		inx
		iny
		bne -
+		stx bufnln2		;adjust filename-length to be expanded with ",P,W"
		rts
PRGwriTxt .null ",P,W"	;the appended modifiers after the filename for PRG-type outputs
bufnln2 .byte 0			;the length of the appended (,P,W) filename for OPEN operation

OpenExp	;init workfile name pointer and length, bank, and device,file,channel
		jsr ROMena      ;init workfile name pointer and length, bank, and device,file,channel
        jsr KERNAL.CLRCHN
		lda bufnln2		;appended filename-length
		ldx #<filedialog.namebuf	;point to appended (,S,W or ,P,W) filename
		ldy #>filedialog.namebuf
		jsr KERNAL.SETNAM		;init filename pointer and length, and device,file,channel
		lda #1			;	file # 1
		ldx devicen+1	;self-written, device # 8 is default (modifiable by user)
		ldy #2			;	channel # 2 ;this can be used for SEQ file formats
		jsr KERNAL.SETLFS		; - call setlfs
		jsr KERNAL.OPEN		;open the file for writing
		bcc OKtoSav		;check if file exists, if exists, go forward with saving
ExitErr	jsr filedialog.saverror	;display save-error and wait for keypress
		jsr filedialog.clsfile		;in case of error, close to allow further trials
		sec  ;sign error to caller
		rts
OKtoSav	ldx #$01		;	file #1
		jsr KERNAL.CHKOUT		; - call chkout to set output file #.
		clc ;sign 'no error' to caller
		rts

SaveDat	sta datzp+0 ;startaddress (by A and X), end-address in 'savendL+1', 'savendH+1'
		stx datzp+1
		ldy #0			;reset Y to always be 0 while saving (no need to index, zp-pointers increase instead)
saveloop				;save effective file-content byte-by-byte
		jsr KERNAL.READST
		bne ExitErr ;error?
+		lda (datzp),y
		jsr KERNAL.CHROUT		;write byte to disk
		inc datzp+0
		bne +
		inc datzp+1
+		lda datzp+0	;check if end of file
savendL	cmp #selfmod
        bne saveloop
		lda datzp+1
savendH	sbc #selfmod
		bne saveloop
dontclo	ldx #selfmod ;$00		; filenumber 0
        bne expdone
		jsr KERNAL.CHKOUT		; call CHKOUT (reset output device to prevent keyboard-typings being written to disk)
		jsr filedialog.clsfile		;close file #1
expdone clc ;sign OK to caller
		rts
.fi



;--------------------- Loader/Saver/Exporter routines ------------------
;must be in the lower memory area to allow switching on ROM
loadWorkfile
        sei
        ;jsr ROMena
        jsr iniwfn
        ldx #<tuneheader
        ldy #>tuneheader
        lda #0
        jsr KERNAL.LOAD
        bcc +
        jsr filedialog.filenot     ; if carry set, a load error has happened
        jsr ROMdisa
        jmp loadDialog ;start over
+       stx tuneendptr+0 ;end of data is important info for depacker to start in-place backwards-decompression
        sty tuneendptr+1
        jsr ROMdisa
        jsr depackworkfile
.if (INFOBAR_SUPPORT>0)
        jsr nofirst
.fi
        jmp restEdi ;retuEdi


saveWorkfile
        jsr packworkfile ;lda#packmode_workfile jsr packtune ; sets tuneendptr
        sei
        ;jsr ROMena
        jsr iniwfn
        lda #<tuneheader
        ldx #>tuneheader
        sta tunebaseptr+0
        ;sta tuneheader.baseaddress+ ;done in depttmp already
        stx tunebaseptr+1
        ;stx tuneheader.baseaddress+1
        lda #<(tunebaseptr+0)
        ldx tuneendptr+0
        ldy tuneendptr+1
        jsr KERNAL.SAVE
        bcs +           ;if saving error (e.g. file exists)
        jsr KERNAL.READST
        ;cmp #KERNAL.IOerror.NO_ERROR ; test Accumulator for status-info
        beq getback     ;if no saving error
+       jsr filedialog.saverror
        jsr ROMdisa
        jsr depackworkfile ;
        jmp saveDialog
getback jsr ROMdisa
        jsr depackworkfile ;depack tune - input needed: tuneendptr (end of packed tune)
        jmp retMenu


.if (INSTRUMENT_LOADSAVE_SUPPORT>0)
loadIns sei
        ;jsr ROMena
        jsr iniwfn
        ldx #<instemp
        stx compzp+0
        ldy #>instemp
        sty compzp+1
        lda #0 ;load, not verify
        jsr KERNAL.LOAD
        bcs + ;bcc restEdi ;retuEdi
        txa ;X&Y points right after last loaded byte
        sec
        sbc compzp+0
        sta inssize
        jsr ROMdisa
        ldx currins
        lda insptlo,x
        sta datzp+0
        lda inspthi,x
        sta datzp+1
        jsr depack1inst
        jmp softRst
+       jsr filedialog.filenot     ; if carry set, a load error has happened
        jsr ROMdisa
        jmp loadInsDialog ;start over

saveIns sei
        jsr ROMena
        jsr iniwfn
        jsr ROMdisa
        lda #<instemp 
        ldx #>instemp
        sta compzp+0
        sta idatzp+0 ;using idatzp to store start-addres for saving
        stx compzp+1 
        stx idatzp+1 
        ldx currins
        stx tuneheader.ins_amount ;even save empty instrument (almost) correctly
        jsr pack1inst
        jsr ROMena
        ldx compzp+0 ;endaddress lo
        ldy compzp+1 ;endaddress hi
        lda #<(idatzp+0) ;startaddress
        jsr KERNAL.SAVE
        bcs +           ;if saving error (e.g. file exists)
        jsr KERNAL.READST
        ;cmp #KERNAL.IOerror.NO_ERROR ; test Accumulator for status-info
        beq retMenu     ;if no saving error
+       jsr filedialog.saverror
        jsr ROMdisa
        jmp saveInsDialog
.fi


;lower area's ROM==on version of returners
retMenu jsr ROMdisa ;return to menu
        lda #exitmode_justlaunch
		sta exitsig
		rts

retuEdi jsr retMenu ;return to editor
retuEd2 lda #keymode_editor
        sta keyermode
        rts

restIns lda #1
        sta currins
softRst lda #exitmode_softrestart
        sta exitsig
        jmp retuEd2

restTun jsr ROMdisa
        lda #0
        sta cursubtune
        jsr (SUBTUNE_SUPPORT!=0)? setsubt : player.initzak ;INIT, subtune in Accu
        jmp softRst

restEdi lda #exitmode_restart
        sta exitsig
        jmp retuEd2


.if (PLAYABLE_EXPORT_SUPPORT>0)
SavePlayable
		jsr ROMdisa
        lda #packmode_release
        jsr packtune
		jsr relocate
        jsr appendPRGW	;append PRG file Writing string to filename
		jsr OpenExp
        bcc +
        jsr revert0
restExp jmp exportPlayableDialog ;start all over if error
+       jsr ROMena        
        lda #<PLAYERADDR
		jsr KERNAL.CHROUT		;address lo-byte
		lda relocaddr
		jsr KERNAL.CHROUT		;address hi-byte
        jsr SaveTun ;handles 'unrelocate' and 'depacktune' too
        bcs restExp
        jmp retMenu ;retuEdi ;returnM ;jmp goBackE  
.fi

.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
SaveTun 
 .if (MACHINE<2)
        ldy #0       
        ldx #20
        clc
        jsr KERNAL.SCREENPOS ;don't allow possible upcoming LOAD/SAVE prompt to overwrite the insnametemp-data
 .fi
        lda tuneendptr+0
        ldx tuneendptr+1
        sta savendL+1
        stx savendH+1
        lda #0
        sta dontclo+1
		lda #<PLAYERADDR ;Set Start Address for saver loop
		ldx #>PLAYERADDR
        jsr SaveDat
revert0 php ;store Carry
revertp jsr ROMdisa
		jsr unrelocate
        lda #packmode_release
        jsr depacktune
		plp ;restore Carry
        rts
.fi

.if (RUNNABLE_EXPORT_SUPPORT>0)
SaveRunnable
        jsr ROMdisa
        lda #packmode_release
        jsr packtune
        lda #>EXEstarter.EXE_PLAYERADDR
        jsr reloca2
        ldy tuneheader.framespd
        lda frmspds,y   ;check framespeed-program lookup table in datatables.inc
        sta fspdsto+1
        dey
        sty (EXEstarter.exefspd+1-BASIC_START)+EXEstarter
        beq appendn     ;if 1x single-speed, don't disturb table
-       tya
        clc
fspdsto adc #selfmod    ;silf-written - add base-position of current rasterspeed
        tax
        lda EXEframerows,x ;get current frameraster from table
        sta (EXEstarter.EXEframes-BASIC_START)+EXEstarter,y ;graving into the executable-code
        dey
        bpl -  
appendn jsr ROMena
        jsr appendPRGW	;append PRG file Writing string to filename
		jsr OpenExp
        bcc +
        jsr revert0
restREx jmp exportRunnableDialog ;start all over if error
+       lda #<BASIC_START
		jsr KERNAL.CHROUT		;address lo-byte
		lda #>BASIC_START
		jsr KERNAL.CHROUT		;address hi-byte
        lda #<EXEstarter_end
        ldx #>EXEstarter_end
        sta savendL+1
        stx savendH+1
        lda #<EXEstarter
        ldx #>EXEstarter
        stx dontclo+1
        jsr SaveDat
        ;bcs restREx
        ;jsr ROMena
        jsr SaveTun ;handles 'unrelocate' and 'depacktune' too
        bcs restREx
        jmp retMenu ;retuEdi
.fi



;----------------------- Lower area data/variables ---------------------
relocaddr .byte >PLAYERADDR ;relocation target address HI-byte

.enc screen
hexdigi	.text "0123456789ABCDEF"
.enc none
TZWext .text "TZW"
TZIext .text "TZI"
PRGext .text "TZP"
RUNext .text "TZR"

authorinfo_len=rowlen
authorinfo .fill authorinfo_len," " ;will be copied to player-variable area for playable, or end of packed data for workfile
authorinfo_end


;================== Player-program for runnable export =================
.if (RUNNABLE_EXPORT_SUPPORT>0)
EXEstarter .block
 .logical BASIC_START
    .word ss2,Year
    .null $9e,^start2 ;SYS command
ss2	.word 0
start2  sei
        lda #exebgcol
        sta bgcol
        .if (MACHINE<2)
        lda #$08
        sta VRAMaddr
        lda #0
        sta VRAMposhi
        lda #$F8
        sta VRAMposlo
        lda #$C4
        sta bitmapaddr
        lda #$D0+4 ;small character set (bit2)
        sta chsetaddr1MHz
        .else
        lda #$03
        sta VICbank
        lda #$16 ;small character set
        sta vid_ch_pos
        .fi
        lda #$1b
        sta vmodeyscroll
        lda #$08 ;$48 for NTSC?
        sta cmodexscroll
        ldy #0
-       lda #exefgcol
        sta CRAM+$000,y
        sta CRAM+$100,y
        sta CRAM+$200,y
        sta CRAM+$300,y
        lda #" "
        sta VRAM+$000,y
        sta VRAM+$100,y
        sta VRAM+$200,y
        sta VRAM+$300,y
        iny
        bne -
        ldy #rowlen-1
-       lda expinfo,y
        cmp #$60
        bcc +
        and #$1F
+       sta VRAM+lastrow*rowlen,y
        dey
        bpl -
        jsr dispAuthorInfo
        lda #0 ;default subtune ;later should be changeable with +/-
        jsr EXE_PLAYERADDR+0
framcnt ldy #1 ;selfmod
        lda EXEframes,y
        cmp vscanpos
        bne *-3
        ldx #(MACHINE<2)? 19:11 ;beautify flicker
        dex
        bne *-1
        lda #exebarcol
        sta bordcol
        dey
        bpl +
exefspd ldy #1-1 ;selfmod ;written by exporter: framespd-1
+       sty framcnt+1
        bne +
        jsr EXE_PLAYERADDR+3
        jmp ++
+       jsr EXE_PLAYERADDR+6
+       lda #exebordcol
        sta bordcol
        jmp framcnt
dispAuthorInfo
		ldy #rowlen-1
-		lda #" "
		sta VRAM+(rowamount/3)*rowlen,y
		dey
		bpl -
		ldy #rowlen-1
-		lda EXE_PLAYERADDR+(explayer.authorinfo-explayer.player_top),y
		cmp #" "
		bne + ;find character before last space
		dey
		bne -
+		sty columnzp
		lda #rowlen-1
		sec
		sbc columnzp
		tay
		lsr ;halve the distance -> center text
		tay
		ldx #0
-		lda EXE_PLAYERADDR+(explayer.authorinfo-explayer.player_top),x
		sta VRAM+(rowamount/3)*rowlen,y
		inx
		iny
		cpy #rowlen
		bne -
		rts

;.enc screen
expinfo .text "It was created with TEDzakker-"
        .text (PLAYERTYPE==0)?"normal": (PLAYERTYPE==1)?"medium": (PLAYERTYPE==2)?"light": (PLAYERTYPE==3)?"extra": (PLAYERTYPE==4)?"bare": (PLAYERTYPE==5)?"demo" : ""
        .text "-",Version,"  "
;.enc none

;framespeed-program - overwritten/generated by exporter for specific rasterspeeds
EXEframes .byte <(exerast1-(PAL_SCANLINES/8)*range(0,7)) ;TABLE LOADED BY OTHER PARTS OF THE CODE (counts backwards)

  .align $100 ;important, as player is only relocatable to $100 boundaries
EXE_PLAYERADDR ;EXE_PLAYERADDR=(BASIC_START/$100+1)*$100
 .here
.bend
EXEstarter_end
.fi ;end of RUNNABLE_EXPORT_SUPPORT



;**************************** EXPORT-PLAYER ****************************
;the player that gets exported together with the packed TUNEDATA
;.cerror (*>=PLAYERADDR),"LOWER PART OF PROGRAM OVERLAPS PLAYER AND TUNEDATA ",*
;*=PLAYERADDR
.align $100
PLAYERADDR
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
		.union	;unnamed union - creates an instance for both but at the same memory location in prg output, so 'player' will overwrite 'player2'
 .if (RELOCATION_SUPPORT>0)
		 .struct
explayer2 #playerm PLAYERADDR+$100,0 ;for comparison & detection of code to relocate
		 .ends
 .fi
		 .struct
explayer  #playerm PLAYERADDR,0
		 .ends
		.endu
;.else
;explayer=player
.fi


;============================== TUNEDATA ===============================
;music header and packed data immediately follows the player
;*=$4000 
;.align $100 ;this shouldn't be here in exported tune
;.warn"Address of tune-data = ",*

tuneheader_size=$10
tuneheader .block ;if new parameters are to be added, they mustn't be inserted, so the format stays the same between versions
formatspec .text "TZW1" ;TEDzakker Workfile magic ID
baseaddress    .word tuneheader ;absolute address of originally saved data, needed to calculate (shift) pointertable and its addresses
playertype     .byte 0 ; `PLAYERTYPE ;converted from text to number - doesn't work all way round, need to set by software at init
subtune_amount .byte 0 ;(don't even change the order of these parameters, so you we can keep backwards kompatibility)
ins_amount     .byte 0
ptn_amount     .byte 0 ;final pattern-amount based on last non-empty pattern or used_ptn_amount if it's bigger
framespd       .byte 1
defaultptlen   .byte defptnlen
;ptrtables_addr .word pointertables ;$0000 ;absolute base-address of pointertables (not necessary as the structure of file-tail is well known)
;What's new to add? Add it here! ;bytes inbetween are kept for expansion coming later
*=tuneheader+tuneheader_size
.bend
tuneheader_end 


;.text "------------ TUNE PACK-AREA -------------"
packed_data_start
.if (MACHINE>0)
 .fill $100+2,0 ;give a little gap (around a pattern's maximal size) for in-place decompression
.else
 .fill maxseqlen*CHANNELAMOUNT+2,0 ;ins_maxsize,0 ;maxptnlen,0
.fi
depack_data_start

emptyseqval=seqendval
emptywfval=instbendval
emptyfrval=instbendval
emptyvoval=instbendval

;.warn"Address of orderlists = ",*
orderlists
orderlist0
.for i=0, i<maxsubtuneamount, i=i+1
 .for j=0,j<CHANNELAMOUNT,j=j+1
  .fill maxseqlen,emptyseqval ;j+i*16
  .byte seqendval
 .next
.next

;.warn"Address of instruments = ",*
instruments
.for i=1, i<=maxinstamount, i=i+1 ;0 instrument is needed to have some gap for in-place decompression
 #emptyinsm
.next

;.warn"Address of patterns = ",*
patterns
.for i=1, i<=maxptnamount, i=i+1
 .fill maxptnlen,ptnNOPval ;emptynoteval ;.fill defptnlen,emptynoteval ;note
 .byte ptnendval
 ;.fill maxptnlen-defptnlen,emptynoteval
 .fill maxptnlen,ptnNOPval ;emptyinsval ;inst/fx
 .byte ptnendval
 .fill maxptnlen,ptnNOPval ;emptyfxval ;fx/fxval
 .byte ptnendval
.next

tunedata_end
;.warn"End-address of tune-data = ",*
;.cwarn(*>=$8000),"Tune-data reaches ROM area, saving of the whole tune might be in risk. ",*



;***********************************************************************
;player used by the editor
.include "player.asm"
player #playerm *,1 ;editor's player instance

;==================== AUXILIARY TUNEDATA (for editor) ==================

;editor's pointertables
pointertables .segment

;.warn"Address of subtune-sequence low-pointers = ",*
seqptrlo ; ch0-st0lo, ch0-st1lo, ... ch0-stmaxlo  ;  ch1-st0lo, ch1-st1lo, ...
.for j=0, j<CHANNELAMOUNT, j=j+1
 .for i=0, i<maxsubtuneamount, i=i+1
  .byte <(  orderlists + i * (maxseqlen+1)*CHANNELAMOUNT + ( j*(maxseqlen+1) )  )
 .next
.next
seqptrhi ; ch0-st0hi, ch0-st1hi, ... ch0-stmaxhi  ;  ch1-st0hi, ch1-st1hi, ...
.for j=0, j<CHANNELAMOUNT, j=j+1
 .for i=0, i<maxsubtuneamount, i=i+1
  .byte >(  orderlists + i * (maxseqlen+1)*CHANNELAMOUNT + ( j*(maxseqlen+1) )  )
 .next
.next

;.warn"Address of instrument-pointers = ",*
insptlo
.byte <emptyins
.for i=0, i<maxinstamount, i=i+1
 .byte <(  instruments + i * (insheadersize+(maxinstblen+1)*instbcolumns)  )
.next
inspthi
.byte >emptyins
.for i=0, i<maxinstamount, i=i+1
 .byte >(  instruments + i * (insheadersize+(maxinstblen+1)*instbcolumns)  )
.next

;.warn"Address of pattern-pointers = ",*
pattptlo
.byte <emptyptn
.for i=0, i<maxptnamount, i=i+1
 .byte <(  patterns + i * ((maxptnlen+1)*ptncolumns)  )
.next
pattpthi
.byte >emptyptn
.for i=0, i<maxptnamount, i=i+1
 .byte >(  patterns + i * ((maxptnlen+1)*ptncolumns)  )
.next
insindexes
.byte 1
.for i=0, i<maxptnamount, i=i+1
 .byte (maxptnlen+1)
.next
fxindexes
.byte 2
.for i=0, i<maxptnamount, i=i+1
 .byte (maxptnlen+1)*2
.next

.endm ;pointertables

.if (MACHINE<2)
 #pointertables
.fi


;.align $100 ;temporary pointertable-storage for the exported/saved tune/workfile
;maxseqamount=maxsubtuneamount*CHANNELAMOUNT
pointertemp 
seqpl1tmp .fill maxsubtuneamount+1,0
seqph1tmp .fill maxsubtuneamount+1,0
seqpl2tmp .fill maxsubtuneamount+1,0
seqph2tmp .fill maxsubtuneamount+1,0
inspltmp .byte <emptyins ;for non-existent inst.0
         .fill maxinstamount,0
insphtmp .byte >emptyins ;for non-existent inst.0 
         .fill maxinstamount,0
ptnpltmp .byte <emptyptn ;for non-existent patt.0
         .fill maxptnamount,0
ptnphtmp .byte >emptyptn ;for non-existent patt.0
         .fill maxptnamount,0
ptniitmp .byte 1 ;for non-existent patt.0
         .fill maxptnamount,0
ptniftmp .byte 2 ;for non-existent patt.0
         .fill maxptnamount,0


ptnlen  .byte 1
        .fill maxptnamount,defptnlen ;pattern-length registry for the editor


.if (COPYPASTE_SUPPORT)
ptnbufdatastart .byte 0
firstptnbufdatalen .byte 0       
ptnbufdatalen .byte 0
ptnotebuf .fill maxptnlen,ptnNOPval ;emptynoteval
          .byte ptnendval

ptinsbuf .fill maxptnlen,ptnNOPval ;emptyinsval ;inst/fx
         .byte ptnendval

ptfxbuf .fill maxptnlen,ptnNOPval ;emptyfxval ;fx/fxval
        .byte ptnendval

seqbufdatastart .byte 0 ;to determine length when buffer gets shortened by Shift+C
firstseqbufdatalen .byte 0
seqbufdatalen .byte 0
seqbuf .fill maxseqlen,emptyseqval
       .byte seqendval

insbufdatalen=insbuf_end-insbuf ;for this to work insbuf structure should match TUNEDATA structure
insbuf  ;amount of following bytes (before inst.name) must match 'insmaindatalen' 
 #emptyinsm
insbuf_end
.fi

emptyinsm .macro  ;amount of following bytes (before inst.name) must match 'insmaindatalen' 
 .byte insheadersize+maxinstblen+1   ;freqtable-index
 .byte insheadersize+(maxinstblen+1)*2 ;volumetable-index
 .fill 3,0 ;noteoff-pointers
 .byte %01111100 ;table multispeed/restart/gap-staccatto bits
 .fill insnamelen,"."
 .fill maxinstblen,emptywfval ;this table has fix position at 'insheadersize' from base of instrument, no need for index
 .byte instbendval
 .fill maxinstblen,emptyfrval ;flexibe position in exported tune, index is in instrument main-data
 .byte instbendval
 .fill maxinstblen,emptyvoval ;flexibe position in exported tune, index is in instrument main-data
 .byte instbendval
.endm
emptyins
 #emptyinsm
emptyins_end

emptyptn
 .byte 0,0,0
emptyptn_end


.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
relocdata .segment

 .if (RELOCATION_SUPPORT>0) ;&& PLAYABLE_EXPORT_SUPPORT>0)
;================================================================================================
;Relocation table generator based on the new SID-Wizard relocator by Soci/Singular, utilizing 64tass union/struct capabilities
;Basically the player code is compiled twice to different locations. This small macro
;compares the resulting binaries and creates relocation entries for the changed addresses.

;create the relocation-list
;relocm .segment
relolist .var ()
         .for i=0, i < len(explayer), i=i+1
relodiff  .var (explayer2[i]-explayer[i]) & $ff
          .if relodiff == 0 ;Case: no difference in current code
          .elsif relodiff == 1 ;Case: difference in high-byte is $100, relocation needed in current code
relolist   .var relolist..(PLAYERADDR+i-2,) ;append relocation-list
          .else ;invalid difference in high-byte, maybe due to some tricky code
           .error "Not possible to relocate player-code at memory address ",player+i,"!"
          .fi
         .next

;.endm ;end of 'relocm' segment


;.align $100 ;avoid overlapping tune-data area
reloctable	.word relolist ;resulted relocation-list
			;.word $0000 ;end of relocation table - later in DataPtr, as those commands also need relocation
 .fi ;end of RELOCATION_SUPPORT

;-----------------------------------------------------------------------------------
;addresses of absolute-instructions which point to music data 
DataPtr ;.block
    .word explayer.p_ptnl1, explayer.p_ptnh1, explayer.p_ptnf1, explayer.p_ptni1
    .word explayer.p_insl1, explayer.p_insh1
    .if (SUBTUNE_SUPPORT!=0)
     .word explayer.p_seql1, explayer.p_seqh1
    .else
     .word explayer.p_olip1
     .if (SEQ_FX_SUPPORT!=0)
      .word explayer.p_olip2
      .if (TEMPOPROGRAM_SUPPORT!=0)
       .word explayer.p_olip3
      .fi
     .fi
    .fi
    .word explayer.p_insl2, explayer.p_insh2, explayer.p_insl3, explayer.p_insh3, explayer.p_insl4, explayer.p_insh4
    ;.word $0000 ;this also means an end for relocation-table
;.bend
DataPtr_end
reloctable_end

;------------------
;this table tells which zeropage-pointer (set by packer) to load to operands of instructions given in 'DataPtr' above
PtrValu ;(numeric value tells what amount to add to the address)
        .byte ptnptloadd,0, ptnpthiadd,0, ptnfxindexadd,0, ptninsindexadd,0
        .byte insptloadd,0, inspthiadd,0
        .if (SUBTUNE_SUPPORT!=0)
         .byte seqptloadd,0, seqpthiadd,0
        .else
         .byte orderlistadd,0
         .if (SEQ_FX_SUPPORT!=0)
          .byte orderlistadd,1
          .if (TEMPOPROGRAM_SUPPORT!=0)
           .byte orderlistadd,0
          .fi
         .fi
        .fi
        .byte insptloadd,0, inspthiadd,0, insptloadd,0, inspthiadd,0, insptloadd,0, inspthiadd,0
        ;.byte 0         ;signs end of player-setter data 
PtrValu_end

.endm ;relocdata

 .if (MACHINE<2)
  #relocdata
 .fi

.fi ;end of PLAYABLE_EXPORT_SUPPORT || RUNNABLE_EXPORT_SUPPORT


;=========================== main variables ============================
ptnwin=0 ;keep it as 0, so no need to have "cmp #ptnwin" in many places
oliwin=1
inswin=2
inamewin=3

cursubtune .byte 0
currptn    .byte 1,2 ;.fill CHANNELAMOUNT,1
currins    .byte 1
currwin    .byte ptnwin ;0:pattern-editor(keep it at 0!), 1:orderlist, 2:inst.table, 3:inst.name
curwinposx .byte 0,0,0,0
curwinposy .byte 0,0,0,0
octave     .byte 4
mutesolo   .fill CHANNELAMOUNT,$FF
stopmutesig .fill CHANNELAMOUNT,$FF

seqindex  .byte 0
ptnindex .fill CHANNELAMOUNT,0
insindex  .byte 0

jammode  .byte 1
fulljam  .byte 0 ;jam everywhere, when jam-mode is ON (avoids accidental hex.value typing in ptn/instr.table)
notemode .byte 0
advance  .byte 1

keymode_editor=0
keymode_insname=1
keymode_filer=2
keymode_menu=3
keyermode .byte 0 ;0:normal(editor), 1:instr.name-typer, 2:file-dialog name-typer, 3:menu-mode
;helpmode .byte 0

playmode .byte stopmode
followmode .byte 0

.if (HERMIDI_SUPPORT>0)
HerMIDIswitch .byte 0
.fi

playmark .fill CHANNELAMOUNT,0 ;for F2-initiated play-from-mark entries
markcnt .byte 0
ffwdcnt .byte 0
fspdcnt .byte 0

;help from player regarding positions to display:
currtempo .fill CHANNELAMOUNT,0 ;written by player
playerpatt .fill CHANNELAMOUNT,0 ;written by player
playerpcnt .fill CHANNELAMOUNT,0 ;written by player
wftbpos   .fill CHANNELAMOUNT,0 ;written by player
freqtbpos .fill CHANNELAMOUNT,0 ;written by player
voltbpos   .fill CHANNELAMOUNT,0 ;written by player



;============================= INTERRUPT ===============================
setirq  sei
        lda #(MACHINE<2)? rasterIRQenable+(>singlerast) : $01
        sta irqctrl ;enable raster-IRQ and set raster-comparator MSB to 0
        lda #>singlerast
        sta rscn8st+1
        .if (MACHINE==2)
        lda #$1B+(>singlerast)*80
        sta vmodeyscroll
        lda #$7F
        sta $DC0D
        sta $DD0D
        lda $DC0D
        lda $DD0D
        .fi
        lda #<singlerast
        sta rastercmp ;set raster-IRQ line
        sta rscntst+1
        lda #<irq
        ldx #>irq
        sta $fffe        
        stx $ffff
        lda #<dummynmi
        ldx #>dummynmi
        sta $fffa
        stx $fffb
        lda #$FF
        sta irqstatus ;acknowledge and reset any IRQ (statusbits) that has already happened
        lda #0 
        sta fspdcnt
        rts


;--------------------------------
irq		pha				;store sensitive registers and maybe bank status
		txa
		pha
		tya
		pha

playbar ldx #(MACHINE<2)? 11:15 ;beautify flicker
        dex
        bpl *-1   

        ldy fspdcnt
        bne multspd
singspd lda #jamplaybarcol 
        ldx playmode
        beq +
        lda #tuneplaybarcol
+       cpx #pattplaymode
        bne +
        lda #pattplaybarcol
+       sta bordcol
        lda playmode
        ;cmp #stopmode
        bne fastfwd ;normply
        jsr player.playsnd ;jamPLAY
        jmp +
fastfwd lda #selfmod
        beq normspd
        lda #fastfwdspeed-1
        sta ffwdcnt
-       jsr player.playsnd ;PLAY ;edplay
        dec ffwdcnt
        bne -
normspd jsr player.playsnd ;PLAY ;edplay
+       lda #bordercolor
        sta bordcol

.if (HERMIDI_SUPPORT>0)
        lda HerMIDIswitch   
        beq +
        jsr MIDIcall        
.fi
+       jsr keyer ;can take a longer time (e.g. insert/del/copy in pattern)

        lda jamnote+1
        sta prvnote+1

        jsr dispcursor

        lda followmode
        beq +
        jsr followplay
+       

cflash .if (MACHINE<2)
;        lda #flashspeed_edit
        ldy jammode
        bne chfrspd ;beq +
        lsr cursorflashcnt ;lda #flashspeed_jam
;+       clc
;        adc cursorflashcnt
;        bcc +
;        lda #$ff ;make sure the flash-overflow appens so the cursor changes state and doesn't disappear
;+       sta cursorflashcnt ;$ff1f
       .else
        lda cursorflashcnt
        ldy jammode
        beq +
        lsr
+       and #$0f
        tay
        lda curcolors,y
        sta $d027
        inc cursorflashcnt
       .fi
 
chfrspd ldy tuneheader.framespd
        cpy #2
        bpl +
        jmp retirq
+       dey
        sty fspdcnt
        jmp nextrst

multspd lda #mulbarcol
        sta bordcol
.if (MULTISPEED_ENTRY_SUPPORT==0)
        lda playmode
        ;cmp #stopmode
        bne normply
        jsr player.playsnd ;jamPLAY
        jmp +
.fi
normply jsr (MULTISPEED_ENTRY_SUPPORT!=0) ? player.playmul : player.playsnd   ;player.MULPLAY
+       lda #bordercolor
        sta bordcol

advarst dec fspdcnt
        bne nextrst
mulsend ldx #<singlerast
        stx rscntst+1
        lda #>singlerast
        sta rscn8st+1
        jmp wrirast

nextrst ldy tuneheader.framespd
        lda rscntst+1
        clc
        adc fspdtable,y
        sta rscntst+1
        lda rscn8st+1
        adc #0 ;add Carry
        sta rscn8st+1
        cmp #>PAL_SCANLINES
        bcc chkover
        lda rscntst+1
        sec
        sbc #<PAL_SCANLINES
        bcc chkover
        sta rscntst+1
        lda #0
        sta rscn8st+1
chkover lda rscntst+1 ;rastercmp ;check if the rasterline is over (by keyer) and need to set the next
        sta rscnst2+1
        lda rscn8st+1
        sta rsc8st2+1
        ldy vscanpos
        sty vspstor+1
        lda vscanpos8
.if (MACHINE==2)
        asl ;bit7 to Carry
        rol ;Carry to bit1
.fi
        and #1
        sta vsp8sto+1
        bne rsoffst    ;cmp #>singlerast ;bcc/bcs
.if (MACHINE<2)
        cpy #<singlerast
        bcc rscnst2
.else
        ldy rsc8st2+1
        bne advarst 
        beq rscnst2
.fi
rsoffst ldy rsc8st2+1
        bne rscnst2 ;cmp #>singlerast ;bcc/bcs
        ldy rscnst2+1
        cpy #<singlerast
        bcs rscnst2
        lda #<PAL_SCANLINES
        clc 
        adc rscnst2+1
        sta rscnst2+1
        lda rsc8st2+1
        clc
        adc #>PAL_SCANLINES
        sta rsc8st2+1
rscnst2 lda #selfmod
        sec
        sbc #4 ;safety-zone (to have enough gap for new upcoming raster-IRQ)
        bcs vspstor
        eor #$FF
vspstor cmp #selfmod
rsc8st2 lda #selfmod
vsp8sto sbc #selfmod
        bcs rscntst
        jmp advarst
rscntst ldx #selfmod
rscn8st lda #selfmod
wrirast stx rastercmp
.if (MACHINE<2)
        ora #rasterIRQenable
        sta irqctrl
.else
        lsr ;bit0 to Carry
        ror ;Carry to bit7
        ora #$1B
        sta vmodeyscroll
.fi

retirq  lda #$FF ;lda #2 ;reset raster-IRQ bit
        sta irqstatus
		pla
		tay
		pla
		tax
		pla
		rti

dummynmi pha				;store sensitive registers and bank status
		txa
		pha
		tya
		pha         
        .if (MACHINE==2)
        ldy currwin
        jsr pageup
        .fi
        jmp retirq


followplay
        ldx #CHANNELAMOUNT-1
follplp lda playmode
        cmp #pattplaymode
        beq +
        lda player.seqcnt,x
        bmi cntfltr
+       lda playerpatt,x ;currpatt,x
        beq cntfltr
        cmp #maxptnamount+1
        bcs cntfltr
        sta currptn,x
        tay
        lda ptnlen,y
        sec
        sbc #pattheight
        bcc +
        sta flplsto+1
        lda playerpcnt,x ;pattcnt,x
        bmi cntfltr
        sec
        sbc #pattheight/2
        bcc +
flplsto cmp #selfmod
        bcc ++
        lda flplsto+1
        jmp ++
+       lda #0
+       sta ptnindex,x       
cntfltr dex
        bpl follplp
        jsr getcurtrk
        lda playmode
        cmp #pattplaymode
        beq +
        lda player.seqcnt,y
        bmi ++
+       lda playerpcnt,y ;pattcnt,y
        sec
        sbc ptnindex,y
        bmi +
        sta curwinposy+ptnwin
+       rts

fspdtable .byte 0,<PAL_SCANLINES
          .for i=2,i<=maxframespeed,i=i+1
            .byte round(PAL_SCANLINES/i)
          .next



;============================ keyhandler ===============================
keyer   jsr shcbget		;shift & CBM key requester

		lda #7
		sta keyzp2
keylp1	ldy keyzp2
		lda keyrows,y
		sta keymatrix
        sta keylatch
		lda keylatch
		cmp #$ff
		beq skiprow
		ldx #7
keylp2	ldy keyzp2
		lda keylatch
		and keycols,x
		bne nextkey
		stx keyzp1
		tya
		asl
		asl
		asl
		clc
		adc keyzp1
		asl ;x2 (.word)
		tay
		
		cpy #15*2    	;Left Shift?   -not to count shift/cbm keys now, done already in 'shcbget'
		beq nextkey		;check next
		cpy #61*2		;C= key?
		beq nextkey		;check next
        .if (MACHINE==2)
		cpy #52*2   	;Right-Shift?
		beq nextkey		;check next
        .fi
zprvkey	cpy #selfmod	;self-written - compare previous key to current, if different, reset repeat-counter
		beq +			;if the same key is pressed, no counter-reset
		ldx #repdelay	;no pressed key, repeatcounter resets
		stx repecnt		;using X to preserve A
+		sty zprvkey+1
		
		ldx keyermode ;ldx currwin	;name-typing mode?
        ;cmp #keymode_editor
        beq edikeys ;cpx #inamewin
cmenuky	cpx #keymode_menu ;lda menumode
		bne +;beq +
        jmp (MENU_SUPPORT>0)? menukeyer:retukey
+       jmp nametyper
		
edikeys	lda keyjmp+0,y
		sta keyJump+1
		lda keyjmp+1,y
		sta keyJump+2
.if (INFOBAR_SUPPORT>0)
 .if (HORIZONTAL_ORDERLIST>0)
        lda editinf+1
 .else
editinf lda #selfmod
 .fi
        beq keyJump
        jsr delinfo
.fi
keyJump	jmp dummykey	;self-written - jump
nextkey	dex
		bpl keylp2
skiprow	dec keyzp2
        bmi +
		jmp keylp1
+
nokey	
.if (HERMIDI_SUPPORT>0)
        lda HerMIDIswitch
        beq +
MIDIsig lda #selfmod ;MIDIsig+1
        bne retukey ;++
.fi
+       lda #repdelay	;no pressed key, repeatcounter resets
		sta repecnt
		ldx #0
		stx fastfwd+1
+       lda playmode
        bne retukey
jamnote	lda #selfmod  ;0 already?
        beq retukey ;bne endnote      
;.if (HERMIDI_SUPPORT>0)
;        lda HerMIDIswitch
;        beq endnote
;MIDIsig lda #selfmod ;lda #0 ;lda prvnote+1 ;detect 1st frame of key-release
;        bne retukey ;sta jamnote+1 ;beq retukey
;.fi
endnote lda #0
        sta jamnote+1
        ldx #CHANNELAMOUNT-1
-       ldy player.currinst,x
        lda insptlo,y
        sta playzp+0
        lda inspthi,y
        sta playzp+1
        ;lda #cmd_rts
        ;sta player.return0
        jsr player.setgoff
        ;lda #cmd_nop
        ;sta player.return0
        dex
        bpl -
retukey rts

nametyper sta goediky+1
		lsr
		tay
        ;lda shiftsig
        ;ora cbmsig
        ;bne retnamt
		lda keychr,y	;(from datatables.inc)
        sta astore8+1
		beq retukey	;gonextk	;no process if 0 
.if (FILEDIALOG_SUPPORT>0)
        ldx keyermode ;ldy currwin
        cpx #keymode_filer ;cpy #inamewin ;file-dialog?
        bne +
		jsr repeatex
        lda astore8+1
        jmp filedialog.filenamer
.fi
+       cpy #55 ;slash-key? (page up/down)
        beq goediky
        cpy #(MACHINE<2)? 40:7 ;cursor down?
        beq goediky
        .if (MACHINE<2)
        cpy #48 ;cursor left?
        beq goediky
        .fi
        cpy #(MACHINE<2)? 51:2 ;cursor-right?
        beq goediky
        cpy #0 ;del-key?
        beq goediky
        .if (MACHINE==2)
        cpy #48 ;Pound (Insert in Vice)
        beq goediky
        .fi
        cpy #(MACHINE<2)? 57:$33 ;home-key?
        beq goediky
        cpy #(MACHINE<2)? $36:$28 ;plus-key?
        beq goediky
        cpy #(MACHINE<2)? $2E:$2B ;minus-key?
        beq goediky
        cmp #$80 
        bcc typechr  ;type character if $01..$7F
        cmp #$C0
        bcc retukey ;gonextk ;no process if $00 or $80..$BF
exitina lda #keymode_editor ;instrument-namer caught exit-signal
        sta keyermode
        jmp gotoins
typechr jsr repeatex
        jsr getcurinsaddr
astore8 lda #selfmod
        ;and #$3F ;transform shifted characters to normal
        sta (idatzp),y
        jmp crsrrig
goediky ldy #selfmod
        jmp edikeys

repeatex				;repeat-counter routine, return only if repeat can be done (shouldn't affect X or Y registers)
		lda repecnt		;keyrepeat-counter
		bne norsrep		;check, if repeat counter is 0
		lda #repspeed	;default repeat-speed 2
		sta repecnt		;if 0, reset counter to repeatspeed 2
noret	pla 			;getting back Program-counter from stack? (injected by Soci)
		pla				;causing '2-level rts'?
		rts				;repeat not allowed here
norsrep cmp #repdelay	;check, of repeat counter is initial value (repeatspeed 1)
		bne repcan		;if no, then just decrease the repeat counter
		dec repecnt		;if yes, decrease by one, and reset Z-flag - repeat possible
		rts				;repeat allowed here
repcan	dec repecnt
		bne noret		;if reaches 0, a repeat occurs, next round will reset to speed 2
		rts				;repeat allowed here
repecnt	.byte 0

shcbget	ldx #0			;get status of SHIFT and CBM keys
		stx shiftsig
		stx cbmsig
		ldy #(MACHINE<2)? 1:2
-		lda modkeyc,y
        sta keymatrix
		sta keylatch
		lda keylatch
		and modkeyr,y
		bne +
		inc shiftsig,x
+		dey
		bne +
		inx
+		bpl -
		rts
shiftsig	.byte 0
cbmsig  .byte 0 ;strictly be right after shiftsig (indexing by shcbget)

.if (MACHINE<2)
modkeyc .byte $7f,$fd;columns of CBM, SHIFT
modkeyr .byte $20,$80;rows of CBM, SHIFT
.else
modkeyc .byte $7f,$bf,$fd;columns of CBM, Right-SHIFT, Left-Shift
modkeyr .byte $20,$10,$80;rows of CBM, Right-SHIFT, Left-Shift
.fi

keyjmp .block ;keyboard-jumptable                                             ;- 01 - 02 - 04 - 08 - 10 - 20 - 40 - 80 ---
 .word keyDel  ,keyRet  ,key02j  ,keyHlpf7,key04j  ,key05j  ,key06j  ,key07j  ; DEL |RETU|poun|HELP|F1F4|F2F5|F3F6| @  |fe
 .word key3sub ,keyWsub ,keyAsub ,key4sub ,keyZsub ,keySsub ,keyEsub ,nextkey ;  3  | W  | A  | 4  | Z  | S  | E  |Shft|fd
 .word key5sub ,keyRsub ,keyDsub ,key6sub ,keyCsub ,keyFsub ,keyTsub ,keyXsub ;  5  | R  | D  | 6  | C  | F  | T  | X  |fb
 .word key7sub ,keyYsub ,keyGsub ,key8sub ,keyBsub ,keyHsub ,keyUsub ,keyVsub ;  7  | Y  | G  | 8  | B  | H  | U  | V  |f7
 .word key9sub ,keyIsub ,keyJsub ,key0sub ,keyMsub ,keyKsub ,keyOsub ,keyNsub ;  9  | I  | J  | 0  | M  | K  | O  | N  |ef
 .word key28j  ,keyPsub ,keyLsub ,key2Bj  ,keyDot  ,keyColon,key2Ej  ,keyComma; crdn| P  | L  |crup| .  | :  | -  | ,  |df
 .word key30j  ,keyStar ,keySeCol,key33j  ,key34j  ,keyEqual,key36j  ,keySlash; crle| *  | ;  |crri|ESC | =  | +  | /  |bf
 .word key1sub ,key39j  ,keyCtrl ,key2sub ,keySpace,nextkey ,keyQsub ,keyStop ;  1  |HOME|CTRL| 2  |SPC | C= | Q  |stop|7f
;keyboard-compatibility list/layer between C64 and C264 models
key02j=(MACHINE<2)? keyPound:keyRiC64 ;keyCuRi
key04j=(MACHINE<2)? keyf1f4:keyf1f2
key05j=(MACHINE<2)? keyf2f5:keyf3f4
key06j=(MACHINE<2)? keyf3f6:keyf5f6
key07j=(MACHINE<2)? keyAt:keyDnC64 ;keyCuDn
key28j=(MACHINE<2)? keyCuDn:keyPlus
key2Bj=(MACHINE<2)? keyCuUp:keyMinus
key2Ej=(MACHINE<2)? keyMinus:keyAt
key30j=(MACHINE<2)? keyCuLe:keyPound ;pound is used in Vice X64 as "Insert"
key33j=(MACHINE<2)? keyCuRi:keyHome
key34j=(MACHINE<2)? keyEsc:nextkey ;right-shift on C64
key36j=(MACHINE<2)? keyPlus:pgdown ;no up-arrow on Plus4, but it's still usable as PageUp/Dn beside RESTORE-key in VICE X64)
key39j=(MACHINE<2)? keyHome:keyEsc
;(RESTORE key on C64 would be handled from NMI of dummyIRQ, usable as PageUp/Dn beside up-arrow key in VICE)
.bend

;.enc screen ;.enc namechars
;.cdef "AZ",$40, "09"
keychr .block
       .byte fdel, facc, fk02, fexi, fdir, fpdn, fpdn, fk07
       .byte "3" , "W" , "A" , "4" , "Z" , "S" , "E" ,  0  
       .byte "5" , "R" , "D" , "6" , "C" , "F" , "T" , "X"  
       .byte "7" , "Y" , "G" , "8" , "B" , "H" , "U" , "V"  
       .byte "9" , "I" , "J" , "0" , "M" , "K" , "O" , "N"  
       .byte fk28, "P" , "L" , fk2B, "." , ":" , fk2E, ","
       .byte fk30, $00 , ";" , fk33, fk34, "=" , fk36, "/" ;$00
       .byte "1" , fk39, ftab, "2" , " " ,  0  , "Q" , fexi 
;compatibility list for file-dialog controls
fk02=(MACHINE<2)?  $00:fcri ;pound is not used on plus4
fk07=(MACHINE<2)?  $00:fcdn
fk28=(MACHINE<2)? fcdn:"+"
fk2B=(MACHINE<2)? fcup:"-"
fk2E=(MACHINE<2)?  "-":$00 ;"@"
fk30=(MACHINE<2)? fcle:fins ;Pound-key in VICE emulator is bound to 'insert' by default
fk33=(MACHINE<2)? fcri:fhom
fk34=(MACHINE<2)? fexi: 0 ;right-Shift
fk36=(MACHINE<2)?  "+": 0 ;'up-arrow' (might be used as page-up on C64, but there's no such function in file-dialog)
fk39=(MACHINE<2)? fhom:fexi
;.enc none
;file-dialog/name-typer control-signals ;value $00 and $80..$BF are ignored by instrument-nametyper, $Fx exits nametypers, and are controls for filenamer
fdel=$80 ;delete one character back
fcdn=$81 ;cursor-down
fcup=$82 ;cursor-up
fcle=$83 ;cursor-left
fcri=$84 ;cursor-right
fhom=$85 ;home (beginning of field)
fins=$86 ;insert (no Insert key, only 'pound' in VICE can be used)
fdir=$F8 ;directory read
fpdn=$F9 ;page-down in directory (next screen-chunk of filelist)
ftab=$FA ;tabulating in file-dialog between subwindows
fexi=$FE ;exit
facc=$FF ;accept value
.bend


keycols .byte $01,$02,$04,$08,$10,$20,$40,$80
keyrows .byte $fe,$fd,$fb,$f7,$ef,$df,$bf,$7f



;=============== key subroutines (navigation,settings) =================
winposxmax .byte trkcurcolumns*CHANNELAMOUNT-1, (HORIZONTAL_ORDERLIST>0)? seqdilen*2-1 : CHANNELAMOUNT*2-1, instbcurcolumns-1, instbwidth-1
winposymax .byte pattheight-1, (HORIZONTAL_ORDERLIST>0)? CHANNELAMOUNT-1 : seqdilen-1
           .byte (instbheight<=maxinstblen)? instbheight-1:maxinstblen-1 ,0

keySpace ;toggle jamming/editing  /  set playmark in orderlist (Shift)  /  play pattern from cursor-position (Shift)
        jsr repeatex
        lda shiftsig
        bne chpospl
        lda cbmsig
        bne setmark
        lda jammode
        eor #1
        sta jammode
retSpce rts
chpospl lda currwin
        ;cmp #ptnwin
        bne chpmark
        ldy #$FF ;0
        jmp playptn
chpmark cmp #oliwin
        bne chkoffp
allmark ldx #CHANNELAMOUNT-1
-       txa
        jsr getseqa
        sta playmark,x
        dex
        bpl -
        rts
setmark lda currwin
        cmp #oliwin
        bne retSpce
        jsr getcurseqaddr
.if (HORIZONTAL_ORDERLIST>0)
        ldy curwinposy+oliwin
.else
        ldx curwinposx+oliwin
        ldy oliindex,x
.fi
        sta playmark,y
        rts        
chkoffp cmp #inswin
        bne retSpce
        jsr getcurinsaddr
        lda curwinposx+inswin
        lsr
        tax
wftbstartindex=insheadersize
        lda #wftbstartindex ;player.wftbstartindex
        cpx #0
        beq +
        ldy noteonidx,x
        lda (idatzp),y
+       sta tboffst+1
        ldy noteoffidx,x
        lda curwinposy+inswin
        sec
        sbc insindex
        clc
tboffst adc #selfmod
        cmp (idatzp),y
        bne +
        lda #0 ;if exists at cursor-position, reset it
+       sta (idatzp),y
        rts
noteoffidx .byte wftbnoteoffindexpos,freqtbnoteoffindexpos,voltbnoteoffindexpos
noteonidx .byte wftbstartindex,freqtbstartindexpos,voltbstartindexpos
.if (HORIZONTAL_ORDERLIST==0)
oliindex .byte 0,0,1,1
.fi


.if (MACHINE==2)
keyRiC64 lda shiftsig
        beq keyCuRi
        jmp keyCuLe
.fi
keyCuRi jsr repeatex
crsrrig ldx currwin
        lda curwinposx,x
        cmp winposxmax,x
        beq +
        inc curwinposx,x
        rts
+       cpx #oliwin
        bne chptnri
.if (HORIZONTAL_ORDERLIST>0)
olright lda seqindex
        clc
        adc #seqdilen
        cmp #maxseqlen
        beq retCuRi
        inc seqindex
.else
        lda curwinposy+oliwin
        sta curwinposy+ptnwin
        lda #0
        sta curwinposx+ptnwin
        jmp gotoptn
.fi
retCuRi rts
chptnri cpx #ptnwin
        bne retCuRi
        lda #0
        sta curwinposx+inswin
        lda curwinposy+ptnwin
        bne +
        jmp goiname
+       sec
        sbc #instbaddy
        bpl +
        lda #0
+       sta curwinposy+inswin
        jmp gotoins


keyCuLe jsr repeatex
crsrlef ldx currwin
        lda curwinposx,x
        beq +
        dec curwinposx,x
        rts
+       cpx #oliwin
.if (HORIZONTAL_ORDERLIST>0)
        bne chinsle
olileft lda seqindex
        beq retCuLe
        dec seqindex
.else
        beq +
        cpx #ptnwin
        bne chinsle
        lda curwinposy+ptnwin
        sta curwinposy+oliwin
        lda #3
        sta curwinposx+oliwin
        jmp gotooli
+       rts ;jmp gotoins
.fi
retCuLe rts
chinsle lda curwinposy+inswin
        cpx #inswin
        beq +
        cpx #inamewin
        bne retCuLe
        lda #<(0-instbaddy)
+       clc
        adc #instbaddy
        sta curwinposy+ptnwin
        lda winposxmax+ptnwin
        sta curwinposx+ptnwin
        lda #keymode_editor
        sta keyermode
        jmp gotoptn


pgdown  ;jsr repeatex
        ;ldy currwin
        ;jmp pagedown

keySlash ;page up/down (orderlist:left/right)
        jsr repeatex
        ldy currwin
        ldx shiftsig
        bne pageup
pagedown 
.if (HORIZONTAL_ORDERLIST>0)
        cpy #oliwin
        beq cholis0
.fi
        ldy #pageupdn
-       jsr crsrdn
        dey
        bne -
retSlas rts
.if (HORIZONTAL_ORDERLIST>0)
cholis0 ldy #pageupdn/2
-       jsr crsrrig
        dey
        bne -
        rts
.fi
pageup  
.if (HORIZONTAL_ORDERLIST>0)
        cpy #oliwin
        beq cholisl
.fi
        ldy #pageupdn
-       jsr crsrup
        dey
        bne -
        rts
.if (HORIZONTAL_ORDERLIST>0)
cholisl ldy #pageupdn/2
-       jsr crsrlef
        dey
        bne -
        rts
.fi


.if(MACHINE==2)
keyDnC64 lda shiftsig
        beq keyCuDn
        jmp keyCuUp
.fi
keyCuDn jsr repeatex
crsrdn  ldx currwin        ;don't use Y register here, needed by page-up/down
        lda curwinposy,x
        cmp winposymax,x
        beq +
        inc curwinposy,x
        rts
+
.if (HORIZONTAL_ORDERLIST==0)
        cpx #oliwin
        bne +
        lda seqindex
        clc
        adc #seqdilen
        cmp #maxseqlen
        beq retCuUp
        inc seqindex
+
.fi
        cpx #ptnwin
        bne chinsdn
ptndown ldx #CHANNELAMOUNT-1 ;ldx currtrk
-       lda ptnindex,x
        clc
        adc #pattheight
        cmp #maxptnlen
        beq +
        inc ptnindex,x
+       dex
        bpl -
        rts
chinsdn cpx #inswin
        bne chinadn
insdown lda insindex
        clc
        adc #instbheight
        cmp #maxinstblen
        bcs retCuDn
        inc insindex
retCuDn rts
chinadn cpx #inamewin
        bne retCuDn
        lda #0
        sta curwinposy+inswin
        lda #keymode_editor
        sta keyermode
        jmp gotoins


keyCuUp jsr repeatex
crsrup  ldx currwin        ;don't use Y register here, needed by page-up/down
        lda curwinposy,x
        beq +
        dec curwinposy,x
        rts
+
.if (HORIZONTAL_ORDERLIST==0)
        cpx #oliwin
        bne +
        lda seqindex
        beq retCuUp
        dec seqindex
+
.fi
        cpx #ptnwin
        bne chinsup
ptnup   ldx #CHANNELAMOUNT-1
-       lda ptnindex,x
        beq +
        dec ptnindex,x
+       dex
        bpl -
        rts
chinsup cpx #inswin
        bne retCuUp ;choliup
insup   lda insindex
        beq retCuUp ;bne +
        ;jmp goiname ;retCuUp
+       dec insindex
retCuUp rts
;choliup cpx #oliwin
;        bne retCuUp
;        jmp gotoptn


keyRet ;enter area, put noteon/noteoff
        jsr repeatex
        lda currwin
        ;cmp #ptnwin ;it's actually 0
        bne cholire
        ldy curwinposx+ptnwin
        lda cbmsig
        beq +
setplen ldx trkselect,y
        ldy currptn,x
        lda curwinposy+ptnwin
        sec ;add 1
        adc ptnindex,x
        sta ptnlen,y
        rts
+       lda shiftsig
        bne putNoteOn ;retkRet ;note-on
        lda trksubpos,y
        cmp #pinstsubpos
        beq callins
        cmp #pinstsubpos+1
        bne chfxcol ;chnotec
callins jsr getcurptnaddr
        lda (idatzp),y
        beq retkRet ;crnextr ;chnotec
        cmp #maxinstamount+1
        bcs retkRet ;crnextr ;retkRet
        sta currins
        jsr newinst
        jmp gotoins
chfxcol cmp #pfxsubpos+1
        bcc chnotec
crnextr jsr crsrlef
        jmp crsrdn
chnotec lda curwinposx+ptnwin
        beq putNoteOff ;retkRet
        cmp #trkcurcolumns
        beq putNoteOff ;retkRet
        rts ;jmp gotooli
cholire cmp #oliwin
        bne chinsre ;retkRet
        lda shiftsig
        beq selptns
selptn  
.if (HORIZONTAL_ORDERLIST>0)
        ldx curwinposy+oliwin
.else
        ldy curwinposx+oliwin
        ldx oliindex,y
.fi
        jsr selpatt
        bcs retkRet
        jmp gotoptn
selptns ldx #CHANNELAMOUNT-1
-       jsr selpatt
        dex
        bpl -
        jmp selptn ;gotoptn
chinsre cmp #inswin
        bne retkRet
        lda curwinposx+inswin
        and #1
        beq retkRet
        jmp crnextr
retkRet rts



putNoteOn lda #noteon
        .byte $2c		;skip
putNoteOff
        lda #noteoff
wnotfx2 ldy jammode
        bne retkRet ;retKeyM
        jmp wnotfx3


selpatt txa
        jsr getseqa
        lda (idatzp),y
        beq dontmov
        cmp #maxptnamount+1
        bcs dontmov
        sta currptn,x
        lda #0
        sta ptnindex,x
        sta curwinposy+ptnwin
        lda trkorigo,x
        sta curwinposx+ptnwin
        clc
        rts
dontmov sec
        rts


keyEsc  lda shiftsig
        beq +
        jsr repeatex
        lda followmode
        eor #1
        sta followmode
        rts
+       lda cbmsig
        beq +
        jsr repeatex
        lda autoflw+1
        eor #1
        sta autoflw+1
        sta followmode
        rts
+       inc fastfwd+1 ;? +fast-forward? / toggle auto follow-play?
        rts

keyStop ;stop/continue playback
        jsr repeatex
stopcont lda playmode
        ;cmp #stopmode
        bne stopply
contply lda playmodestore 
        sta playmode
        lda cbmsig
        sta followmode
        ldx #CHANNELAMOUNT-1
-       lda playinstore,x
        sta player.currinst,x
        ;lda #0
        ;sta stopmutesig,x
        dex
        bpl -
.if (MAIN_VOLUME_SUPPORT!=0)
        lda mainvolstore
        sta player.mainvol+1
.fi 
        rts
stopply lda playmode
        sta playmodestore
        lda #stopmode
        sta playmode
        lda #0
        sta followmode
        sta jamnote+1
        sta prvnote+1
        ldx #CHANNELAMOUNT-1
-       lda player.currinst,x
        sta playinstore,x
        lda #0
        ;sta player.currinst,x
        ;sta player.notevol,x
.if (NOTEVOLUME_FADE_SUPPORT!=0)
        sta player.fadespd,x
.fi
        lda #$FF
        sta stopmutesig,x
        dex
        bpl -
.if (MAIN_VOLUME_SUPPORT!=0)
        lda player.mainvol+1
        sta mainvolstore
        cmp #8 ;if volume is too silent, use 8 (half of the max) as volume to hear the sound
        bcs +
        lda #8
        sta player.mainvol+1
.fi
+       jmp player.silence
        ;rts
playmodestore .byte 0
playinstore .fill CHANNELAMOUNT,0
.if (MAIN_VOLUME_SUPPORT!=0)
mainvolstore .byte $0F
.fi

keyCtrl ;tabulate between tracks (and instrument/orderlist windows)
        jsr repeatex
        ldx shiftsig
        lda currwin
        ;cmp #ptnwin
        bne chinstb
pattab  lda curwinposx+ptnwin
        cpx #0 ;shift?
        beq ptabfwd
ptabbwd cmp #trkcurcolumns
        bpl +
        jmp gotooli ;ptabfwd
+       sec
        sbc #trkcurcolumns
        jmp setptnx
ptabfwd cmp #trkcurcolumns
        bmi +
        jmp gotoins
+       clc
        adc #trkcurcolumns
setptnx sta curwinposx+ptnwin
        rts
chinstb cmp #inswin
        bne cholitb
        cpx #0 ;shift?
        bne +
        jmp gotooli
+       jmp gotoptn
cholitb cmp #oliwin
        bne retkCtl
        cpx #0 ;shift?
        bne tabinst
        lda curwinposx+ptnwin
        cmp #trkcurcolumns
        bmi +
        jsr ptabbwd
+       jmp gotoptn
tabinst jmp gotoins
retkCtl rts


.if (MACHINE<2)
keyf1f4 ;play / followplay(C=) tune from beginning   /   stop/continue playback (Shift)
        jsr repeatex
        lda shiftsig
        beq playbeg
        jmp stopcont
.else
keyf1f2 jsr repeatex
        lda shiftsig
        beq playbeg
        jmp playmrk
.fi
playbeg lda #0 ;play from beginning
playtun sta player.markply+1
        lda cursubtune
        jsr player.initzak ;INIT
        lda #tuneplaymode
        sta playmode
chkflwp ldy #0
autoflw lda #selfmod ;auto-follow? (no need to press CBM-key)
        bne +
        lda cbmsig
        beq ++
+       iny
+       sta followmode
        rts


.if (MACHINE<2)
keyf2f5 ;play / followplay(C=) tune from mark  /  goto/toggle pattern-window (Shift)
        jsr repeatex
        lda shiftsig
        bne togglpt
.else
keyf3f4 jsr repeatex
        lda shiftsig
        bne +
        jmp playpbg
+       jmp stopcont
.fi
playmrk lda #1 ;play from mark
        jmp playtun
togglpt lda currwin
        ;cmp #ptnwin
        beq gotooli
gotoptn lda #ptnwin
        sta currwin
        rts
    
 
.if (MACHINE<2)
keyf3f6 ;play / followplay(C=) pattern  /  toggle orderlist/patternwindow (Shift)
        jsr repeatex
        lda shiftsig
        bne toggoli
.else
keyf5f6 jsr repeatex
        lda shiftsig
        bne +
        jmp togglpt
+       jmp toggoli        
.fi
playpbg ldy #0 ;<(-1)
playptn sty chplbeg+1
        lda #pattplaymode
        sta playmode
        jsr player.softini
        ldx #CHANNELAMOUNT-1
        lda #cmd_rts
        sta player.return0
ptplylp lda currptn,x
        sta player.currpatt,x
        lda #0
        sta player.pattcnt,x ;jsr rnewptn
        ;sta player.currinst,x ;init, 'readptn' will fill it
chplbeg lda #selfmod
        beq ptlpend
-       lda #0 ;better silencing previous note's tail, we only need to get instruments
        sta player.currnote,x
        ldy trkselect,x
        lda curwinposy+ptnwin
        clc
        adc ptnindex,y
        cmp player.pattcnt,x ;jsr rnewptn
        beq ptlpend
        bcc ptlpend
        lda #cmd_rts
        sta player.return0
        jsr player.readptn
        lda #cmd_nop
        sta player.return0
        jmp -
ptlpend dex
        bpl ptplylp
        lda #cmd_nop
        sta player.return0
        jsr player.softini
        jmp chkflwp
toggoli lda currwin
        cmp #oliwin
        beq gotoptn
gotooli lda #oliwin
        sta currwin
        rts


keyHlpf7 ;toggle instrument-window/patternwindow  /  menu 
        jsr repeatex
        lda shiftsig
       .if (MACHINE<2)
        bne toggins 
       .else
        beq toggins
       .fi
        lda #keymode_menu ;inc menusig+1
        sta keyermode
.if (MENU_SUPPORT==0)
        ldx #0
 .if (INSTRUMENT_LOADSAVE_SUPPORT>0)
        lda currwin
        cmp #inswin
        beq +
        ldx #2
 .fi
+       lda cbmsig
        beq +
        inx
+       stx filmode+1
.fi
        rts
toggins lda currwin
        cmp #inswin
        bne gotoins
        jmp gotoptn
gotoins lda #inswin
        sta currwin
        rts


keyHome  ;HOME
        jsr repeatex
        lda #0
        ldy currwin
cholihm cpy #oliwin
        bne chptihm
        ldx (HORIZONTAL_ORDERLIST>0)? curwinposx,y : curwinposy,y
        beq +
        sta (HORIZONTAL_ORDERLIST>0)? curwinposx,y : curwinposy,y
        rts
+       sta seqindex
        rts
chptihm ldx curwinposy,y
        beq +
        sta curwinposy,y
        rts
+       cpy #ptnwin
        bne chinshm
        ldy #CHANNELAMOUNT
-       sta ptnindex,y
        dey
        bpl -
retkHom rts
chinshm cpy #inswin
        bne chitbhm
        sta insindex
        rts
chitbhm cpy #inamewin
        bne rethome
        sta curwinposx+inamewin
rethome rts


keyDel  jsr repeatex
        lda shiftsig
        beq delete
        jmp insert
delete  lda currwin
        ;cmp #ptnwin
        bne choldel
        jsr getcurtrk
        ldx #pnotesubpos ;note-column
        jsr delptco
        ldx #pinstsubpos ;ins-column
        jsr delptco
        ldx #pfxsubpos ;fx-column
        ;jmp delptco
delptco jsr getptna
setdlen sta dlensto+1
        lda cbmsig
        beq dlensto
        lda #0
        jmp filend3
dlensto cpy #selfmod
        beq fillend
        iny
        lda (idatzp),y
        dey
        sta (idatzp),y
        iny
        bne dlensto
fillend lda #0
filend2 dey
filend3 sta (idatzp),y
        rts
choldel cmp #oliwin
        bne chitdel
        jsr getcurseqaddr
        lda #maxseqlen
        jmp setdlen
chitdel cmp #inswin
        bne delinam ;retdele
        lda cbmsig
        bne dallitb
        jsr getcurinstbaddr
        lda #maxinstblen
        jmp setdlen
dallitb ldx #iwfsubpos
        jsr delinco
        ldx #inotesubpos
        jsr delinco
        ldx #ivolsubpos
        ;jmp delinco
delinco jsr getitba
        lda #maxinstblen
        jmp setdlen
delinam cmp #inamewin
        bne retdele
        jsr getcurinsaddr
        cpy #insnamepos
        beq retdele
-       lda (idatzp),y
        dey
        sta (idatzp),y
        iny
        iny
        cpy #insnamepos+insnamelen
        bne -
        lda #" "
        jsr filend2
        jmp crsrlef
retdele rts
        

insert  lda currwin
        ;cmp #ptnwin
        bne cholins
        jsr getcurtrk
        ldx #pnotesubpos ;note-column
        jsr insptco
        ldx #pinstsubpos ;ins.column
        jsr insptco
        ldx #pfxsubpos ;fxcolumn
        ;jmp insptco
insptco jsr getptna
        sty instart+1
        tay
        dey
instart cpy #selfmod
        beq filstrt
        dey
        lda (idatzp),y
        iny
        sta (idatzp),y
        dey
        bne instart
filstrt lda #0
        sta (idatzp),y 
        rts
cholins cmp #oliwin
        bne chitins
        jsr getcurseqaddr
        sty instart+1
        ldy #maxseqlen-1
        jmp instart
chitins cmp #inswin
        bne insinam
        lda cbmsig
        bne iallitb
        jsr getcurinstbaddr
setista sty instart+1
        ldy #maxinstblen-1
        jmp instart
iallitb ldx #iwfsubpos
        jsr insinco
        ldx #inotesubpos
        jsr insinco
        ldx #ivolsubpos
        ;jmp insinco
insinco jsr getitba
        jmp setista
insinam cmp #inamewin
        bne retinse
        jsr getcurinsaddr
        sty inastrt+1
        ldy #insnamepos+insnamelen-1
inastrt cpy #selfmod
        beq +
        dey
        lda (idatzp),y
        iny
        sta (idatzp),y
        dey
        bne inastrt
+       lda #" "
        sta (idatzp),y
retinse rts


key0sub ldx #$00 ;note / octave 0 (C=)
		.byte $2c		;skip
key1sub ldx #$01 ;note? / mute/unmute channel1 (shift) / octave (C=)
		.byte $2c		;skip
key2sub ldx #$02 ; note /  mute/unmute channel2 (shift) / octave (C=)
		lda shiftsig
		beq octa012
		jsr repeatex  ;mute/solo tracks
		dex
        bmi retMute 
MuteSub lda mutesolo,x
        eor muteormask,x
       	sta mutesolo,x  
retMute rts
muteormask .byte $10,$60


octa012 lda cbmsig  ;octave selection
		bne setocta
		jmp datawriter


key3sub ldx #$03
		.byte $2c		;skip
key4sub ldx #$04
		.byte $2c		;skip
key5sub ldx #$05
		.byte $2c		;skip
key6sub ldx #$06
		.byte $2c		;skip
key7sub ldx #$07
		.byte $2c		;skip
key8sub ldx #$08
		.byte $2c		;skip
key9sub ldx #$09
setocta	lda cbmsig
		beq +
		jsr repeatex
		stx octave
		rts
+		jmp datawriter


keyAsub ldx #$0A
		lda shiftsig
        ora cbmsig
        beq +
        jsr repeatex
        lda advance
        eor #1
        sta advance
+       jmp datawriter

keyBsub ldx #$0B
godatwr jmp datawriter


keyDsub ldx #$0D ;slide-down (dovetailing?)
		lda shiftsig
        beq +
        jsr repeatex
        lda #slidedn_nfx+defaultslidespd
        jmp wnotfx3
+       jmp godatwr

keyEsub ldx #$0E  ;note / first unused entry? (shift)
        jmp datawriter
        
keyFsub ldx #$0f ;decrement framespeed, hexa value F, note
		lda cbmsig
        ora shiftsig
		beq godatwr
		jsr repeatex
		ldy tuneheader.framespd
		dey
		bne +
		ldy #maxframespeed
+		sty tuneheader.framespd
		rts
        jmp datawriter


keyGsub	ldx #0+7 ;note / increment framespeed
		lda cbmsig
        ora shiftsig
		bne +
        jmp notewriter
+		jsr repeatex
		ldy tuneheader.framespd
		iny
		cpy #maxframespeed+1
		bmi +
		ldy #1
+		sty tuneheader.framespd
		rts


keyIsub ;Shift+I -> instrument-window
        lda shiftsig
        beq +
        jmp gotoins
+       ldx #12+12+1	;'C' note in 2nd upper octave ;lda #12+12+1	;'C' note in 2nd upper octave
        jmp gonotew


keyKsub
retKeyK rts


keyLsub	ldx #12+2		;'C#' note in upper octave at lower row ;lda #12+3		;'D' note in upper octave at lower row
        lda #legatoon
        ldy #legatooff
        jmp wnotefx


keyMsub ;mute/unmute current track or set multispeed-switch for inst.tables
        lda shiftsig
        beq +
        jsr repeatex
        lda currwin
        ;cmp #ptnwin
        bne cimulsp
        ldy curwinposx+ptnwin
        ldx trkselect,y
        jmp MuteSub
+       ldx #0+12		;'H' note in lower octave
        jmp gonotew
cimulsp cmp #inswin
        bne retKeyM
        jsr getcurinsaddr
        lda curwinposx+inswin
        lsr
        tax
        ldy #instcontrolswitchpos
        lda (idatzp),y
        eor mulspmask,x
        sta (idatzp),y
retKeyM rts
mulspmask .byte $20,$40,$80


keyNsub ;Shift+N -> edit instrument-name
        ldx #0+10		;'A' note in lower octave
        lda shiftsig
        beq chnshif ;gonotew
        jsr repeatex
goiname lda #inamewin
        sta currwin
        lda #keymode_insname
        sta keyermode
        rts
chnshif lda cbmsig
        beq gonotew
        jmp cnotemo


keyOsub ;Shift+O -> orderlist
        ldx #12+12+3	;'D' note in 2nd upper octave ;lda #12+2		;'C#' note in upper octave at lower row
        lda shiftsig
        beq gonotew
keyOoli jsr repeatex
        jmp gotooli ;toggoli ;gotooli

        
keyPsub ;pattern-window
        ldx #12+12+5	;'E' note in 2nd upper octave ;lda #12+4		;'D#' note in upper octave at lower row
        lda shiftsig
        beq gonotew
        jmp gotoptn


keySsub	ldx #0+2		;'C#' note in lower octave ;lda #0+3		;'D' note in lower octave
        lda #syncon
        ldy #syncoff
wnotefx sty valuest+1   ;write note-column effect into pattern
        ldy cbmsig
        bne +
		ldy shiftsig
        beq gonotew
        sta valuest+1 
+       jsr repeatex
valuest lda #selfmod
wnotfx3 sta jamnote+1
        jmp wriptno


keyTsub	ldx #12+8		;'G' note in upper octave ;lda #0+7		;'F#' note in lower octave 
        lda shiftsig ;Shift+T -> tone-portamento note-fx 
        beq gonotew
        jsr repeatex ;jmp gotoptn
        lda #portam_nfx+defaultslidespd
        jmp wnotfx3 ;wnotfx2

keyJsub	ldx #0+11		;'A#' note in lower octave ;lda #0+12		;'H' note in lower octave
		lda cbmsig
        beq gonotew
        jsr repeatex
        lda fulljam
        eor #$80
        sta fulljam
        rts

keyHsub ldx #0+9		;'G#' note in lower octave ;lda #0+10		;'A' note in lower octave
.if (HELPTEXT_SUPPORT>0)
		lda cbmsig
        ora shiftsig
        beq gonotew
        jmp ShowHelp
.else
		.byte $2c		;skip        
.fi

keyRsub	ldx #12+6		;'F' note in upper octave ;lda #$ff		
		.byte $2c		;skip
keyYsub	ldx #12+10		;'A' note in upper octave ;lda #0+9	
		.byte $2c		;skip
keyZsub	ldx #0+1		;'C' note in lower octave
		.byte $2c		;skip
keyAt   ldx #12+12+6	;'F' note in 2nd upper octave 
		.byte $2c		;skip
keyColon ldx #12+4		;'D#' note in upper octave at lower row
gonotew	jmp notewriter


keyDot ;increment subtune-number (with C= key)
        ldx #12+3		;'D' note in upper octave at lower row
        lda cbmsig
        beq gonotew
.if (MACHINE>0) ;(SUBTUNE_SUPPORT!=0)
        jsr repeatex
        lda cursubtune
        cmp #maxsubtuneamount-1
        beq +
        inc cursubtune
        jsr setsubt
.fi
+       rts
        
keyComma ;decrement subtune-number (with C=key)
        ldx #12+1		;'C' note in upper octave at lower row
        lda cbmsig
        beq gonotew
.if (MACHINE>0) ;(SUBTUNE_SUPPORT!=0)
        jsr repeatex
        lda cursubtune
        beq +
        dec cursubtune
        jmp setsubt
.else
        rts
.fi
setsubt lda #0
        sta seqindex
        sta (HORIZONTAL_ORDERLIST>0)? curwinposx+oliwin : curwinposy+oliwin
+       lda cursubtune
        jsr player.initzak ;INIT
        ldx #CHANNELAMOUNT-1
-       lda player.currpatt,x
        beq +
        cmp #maxptnamount
        bcs +
        sta currptn,x
        lda #0
        sta ptnindex,x
+       dex
        bpl -
        jmp stopply


keyQsub	ldx #12+1		;'C' note in upper octave
		lda shiftsig
		beq chtroct
        jsr repeatex
        lda currwin
        ;cmp #ptnwin
        bne retKeyQ
transDn	lda #<(-1) ;transpose down (-1)
transPt sta trnsadd+1
        jsr getcurtrk
        ldx #pnotesubpos ;note-column
        jsr getptna
        sta trnsend+1
trnsend cpy #selfmod
        beq retKeyQ
        lda (idatzp),y
        beq +
        cmp #maxnotenum
        bcs +
        clc
trnsadd adc #selfmod
        beq +
        cmp #maxnotenum
        bcs +
        sta (idatzp),y
+		iny
        bne trnsend
retKeyQ rts
chtroct lda cbmsig
        bne +
		jmp gonotew
+       jsr repeatex
        lda currwin
        ;cmp #ptnwin
        bne retKeyQ
        lda #<(-12)
        jmp transPt


keyWsub ldx #12+3		;'D' note in upper octave 
		lda shiftsig
		beq chCbmW
        jsr repeatex
        lda currwin
        ;cmp #ptnwin
        bne retKeyQ
transUp	lda #1
        jmp transPt
chCbmW	lda cbmsig
		bne +
		jmp notewriter
+       jsr repeatex
        lda currwin
        ;cmp #ptnwin
        bne retKeyQ
        lda #12
        jmp transPt


keyXsub	ldx #0+3		;'D' note in lower octave
.if (COPYPASTE_SUPPORT>0)
		lda cbmsig
        beq gonotw2
        jsr repeatex
        lda #1 ;signal to delete original in copy-routines
        ldy currwin
        ;cpy #ptnwin
        bne cholicu
        jmp copyPtn
retKeyX rts
cholicu cpy #oliwin
        bne chinscu
        jmp copySeq
chinscu cpy #inswin
        bne retKeyX
        jmp copyIns
.fi

gonotw2 jmp gonotew


keyCsub ldx #$0C ;note / copy(C=/Shift)
.if (COPYPASTE_SUPPORT>0)
		lda cbmsig
        bne +
        jmp cbufend
+       jsr repeatex
        lda currwin
        ;cmp #ptnwin
        bne cholico
        lda #0 ;don't delete original
copyPtn sta deltoop+1
        jsr getcurtrk
        ldx #pnotesubpos ;note-column
        jsr getptna
        sty ptnbufdatastart
        sta ptcpend+1
        ldx #0
ptcpend cpy #selfmod
        beq setpdln
        lda (idatzp),y
        sta ptnotebuf,x
        jsr deltoop
        bne ptcpend
setpdln stx firstptnbufdatalen
        stx ptnbufdatalen
        ldx #pinstsubpos ;note-column
        jsr getptna
        ldx #0
-       cpy ptcpend+1
        beq +
        lda (idatzp),y
        sta ptinsbuf,x
        jsr deltoop
        bne -
+       ldx #pfxsubpos ;note-column
        jsr getptna
        ldx #0
-       cpy ptcpend+1
        beq +
        lda (idatzp),y
        sta ptfxbuf,x
        jsr deltoop
        bne -       
+       rts
cholico cmp #oliwin
        bne chinsco
        lda #0 ;don't delete original
copySeq sta deltoos+1
        jsr getcurseqaddr
        sty seqbufdatastart
        ldx #0
-       lda (idatzp),y
        sta seqbuf,x
deltoos lda #selfmod
        beq +
        lda #emptyseqval
        sta (idatzp),y
+       inx
        iny
        cpy #maxseqlen
        bne -
        stx firstseqbufdatalen
        stx seqbufdatalen
        rts
chinsco cmp #inswin ;cmp #inamewin+1 ;inswin/inamewin?
        bne retkeyC ;bpl retkeyC
        lda #0 ;don't delete original
copyIns sta deltooi+1
        jsr getcurinsaddr
        ldy #0
-       lda (idatzp),y
        sta insbuf,y
deltooi lda #selfmod
        beq +
        lda emptyins,y
        sta (idatzp),y
+       iny
        cpy #insbufdatalen
        bne -
retKeyC rts
cbufend lda shiftsig
        bne +
        jmp datawriter
+       lda currwin
        ;cmp #ptnwin
        bne chseqce
        jsr getcurtrk
        lda curwinposy+ptnwin
        clc
        adc ptnindex,y
        sec
        sbc ptnbufdatastart
        bcc retKeyC
        cmp firstptnbufdatalen
        bcs retKeyC
        sta ptnbufdatalen
        rts
chseqce cmp #oliwin
        bne retKeyC
        jsr setseqy
        sec
        sbc seqbufdatastart
        bcc retKeyC
        cmp firstseqbufdatalen
        bcs retKeyC
        sta seqbufdatalen
        rts

deltoop lda #selfmod
        beq +
        lda #0
        sta (idatzp),y
+       iny
        inx
        rts
.else
        jmp datawriter
.fi ;end of COPYPASTE_SUPPORT

keyUsub	ldx #12+12		;'H' (B) note in upper octave ;lda #0+11		;'A#' note in lower octave
		lda shiftsig
        beq +
        jsr repeatex
        lda #slideup_nfx+defaultslidespd
        jmp wnotfx3
+       jmp notewriter

keyVsub	ldx #0+6		;'F' note in lower octave
		lda cbmsig
.if (COPYPASTE_SUPPORT>0)
        bne +
		jmp chptvib ;paste?
+       jsr repeatex
        lda currwin
        ;cmp #ptnwin
        bne cholipa
pastPtn jsr getcurtrk
        ldx #pnotesubpos ;note-column
        jsr getptna
        sta ptpaend+1
        ldx #0
ptpaend cpy #selfmod ;maxptnlen / pattern-length
        beq +
        cpx ptnbufdatalen
        beq +
        lda ptnotebuf,x
        sta (idatzp),y
        inx
        iny
        bne ptpaend
+       ldx #pinstsubpos ;note-column
        jsr getptna
        ldx #0
-       cpy ptpaend+1
        beq +
        cpx ptnbufdatalen
        beq +
        lda ptinsbuf,x
        sta (idatzp),y
        inx
        iny
        bne -
+       ldx #pfxsubpos ;note-column
        jsr getptna
        ldx #0
-       cpy ptpaend+1
        beq +
        cpx ptnbufdatalen
        beq +
        lda ptfxbuf,x
        sta (idatzp),y
        inx
        iny
        bne -
+       rts
cholipa cmp #oliwin
        bne chinspa
        jsr getcurseqaddr
        ldx #0
-       cpy #maxseqlen
        beq +
        cpx seqbufdatalen
        beq +
        lda seqbuf,x
        sta (idatzp),y
        iny
        inx
        bne -
+       rts
chinspa cmp #inswin ;cmp #inamewin+1 ;inswin/inamewin?
        bne retkeyV ;bpl retKeyV
        jsr getcurinsaddr
pastIns ldy #0
-       lda insbuf,y
        sta (idatzp),y
        iny
        cpy #insbufdatalen
        bne -
.else
        beq chptvib
.fi ;end of COPYPASTE_SUPPORT
retKeyV rts
chptvib lda shiftsig
        beq + ;pattern note-column vibrato?
        jsr repeatex
        lda #vibrato_min+defaultvibamp
        jmp wnotfx3 ;wnotfx2
+       jmp notewriter


keySeCol ;semicolon is too close to RETURN key to have a function (maybe combined with Shift/CBM-keys if needed)
        rts

keyMinus ;decrement instrument-number (or octave with C= key)
        jsr repeatex
        lda cbmsig
        beq cdecins
decocta	lda octave
		beq +
		dec octave
+		rts
cdecins lda shiftsig
        bne decpatt
decinst lda currins
        cmp #1
        beq +
        dec currins
+       jmp newinst
decpatt lda currwin
        bne incinst ;retMinu
        ldy curwinposx+0
        ldx trkselect,y
        lda currptn,x  
        cmp #1
        beq retMinu
        dec currptn,x
retMinu rts

keyPlus ;increment instrument-number (or octave with C= key)
        jsr repeatex
        lda cbmsig
        beq cincins
incocta lda octave
		cmp #maxoctave
		bpl +
		inc octave
+		rts
cincins lda shiftsig
        bne incpatt
incinst lda currins
        cmp #maxinstamount ;-1
        beq newinst
        inc currins
newinst lda #0
        sta insindex
        sta curwinposx+inamewin
        rts
incpatt lda currwin
        bne incinst ;retPlus
        ldy curwinposx+0
        ldx trkselect,y
        lda currptn,x
        cmp #maxptnamount
        bcs retPlus
        inc currptn,x
retPlus rts


keyEqual ;(;negate value? - not really relevant as there are no full-range continuous values)
        rts

;freqtb-notemode? 
cnotemo jsr repeatex
		lda notemode
		eor #1
		sta notemode
		rts



keyPound ;insert (in Vice)? ;ldx #12+12+6	;'F' note in 2nd upper octave 
       .if (MACHINE<2)
        rts
       .else
        jsr repeatex
        jmp insert ;rts
       .fi

keyStar ;orderlist? negate value?
        jmp keyOoli ;rts

dummykey rts



;======================== DATA MANIPULATION ============================
datawriter ;note/hexvalue typing, hexvalue in X
        lda shiftsig
        ora cbmsig
        bne retdatw
        stx wrhxad1+1
        stx wrhxad3+1
        lda fulljam
        beq +
        lda jammode
        beq +
.if (HERMIDI_SUPPORT>0)
;        lda HerMIDIswitch
;        beq dofullj
        lda #0
        sta MIDIsig+1 ;don't clash with running MIDI-sound
.fi
dofullj lda NoteOfX,x
        sta jamnote+1
        jmp jammer 
+       ldx currwin
        ;cmp #ptnwin
        bne chdwoli
dwpattn jsr getcurptnaddr
        sta astore1+1
astore1 cpy #selfmod ;outside of pattern?
        bcs retdatw
        ldx curwinposx+ptnwin
        lda trksubpos,x
        beq cnotefx ;notewhx ;note-column?
        jsr repeatex
        ldx curwinposx+ptnwin
        lda trkdiginum,x
        tax
puthexv lda (idatzp),y
        jsr writehex
        sta (idatzp),y
retdatw rts

chdwoli cpx #oliwin
        bne chdwins
dwordli jsr repeatex
        jsr getcurseqaddr
        lda curwinposx+oliwin
        and #1
        tax
        jmp puthexv
        

chdwins cpx #inswin
        bne retdatw
dwinstb jsr getcurinstbaddr
        lda curwinposx+inswin
        ldx notemode
        beq wrinshx
        cmp #2 ;freq-column?
        beq notewhx ;bne +
        ;ldx wrhxad1+1 ;below $80
        ;cpx #$08
        ;bpl notewhx ;freq-column?
+       cmp #3  
        beq notewhx ;freq-column?
wrinshx jsr repeatex
        lda curwinposx+inswin
        and #1
        tax
        jmp puthexv

cnotefx lda (idatzp),y
        bpl notewhx
        ldx wrhxad1+1
        bne + ;0 value deletes the FX
        jsr repeatex
        lda #0
        sta (idatzp),y
        rts
+       jsr repeatex
        ldx #1
        jmp puthexv

notewhx ldx wrhxad1+1
        lda NoteOfX,x
notewh2 cmp #$ff
        beq jamorw ;wrinshx ;retdatw
        sta jamnote+1
        lda jammode
        bne jamorw
        jsr repeatex
        lda jamnote+1
        bne wrinote
        jmp writeno ;1 and A keys delete content at cursor-position

jamorw  lda currwin
        cmp #inswin
        beq wrinshx
.if (HERMIDI_SUPPORT>0)
        ;lda HerMIDIswitch
        ;beq +
        lda #0
        sta MIDIsig+1 ;don't clash with running MIDI-sound
.fi
+       jmp jammer


notewriter ;note-value in X
.if (HERMIDI_SUPPORT>0)
        ;lda HerMIDIswitch
        ;beq +
        lda #0
        sta MIDIsig+1 ;don't clash with running MIDI-sound
.fi
+       lda shiftsig
        bne retnotew
        lda cbmsig
        bne retnotew
notewr2 stx jamnote+1
        lda jammode 
        beq +
        jmp jammer
+       jsr repeatex
        lda currwin
        ;cmp #ptnwin
        beq wriptno
        cmp #inswin
        bne jammer ;retnotew
wriinot jsr getcurinstbaddr
        ldx curwinposx+inswin
        cpx #2 ;freq-column?
        beq wrinote
        cpx #3 ;freq-column?
        beq wrinote
        jmp jammer
retnotew rts
wriptno jsr getcurptnaddr
        sta astore2+1
astore2 cpy #selfmod ;outside of pattern?
        bcs retnotew
        ldx curwinposx+ptnwin
        lda trksubpos,x
        ;cmp #pnotesubpos
        bne jammer ;retnotew ;don't write note in ins/fx column
wrinote lda jamnote+1 ;Y holds position in track here! don't touch
        cmp #maxnotenum ;note-column-fx?
        bcc +
        ldx #0
        stx jamnote+1
        jmp writeno
+       jsr wrinot2
        jmp jammer

wrinot2 
.if (HERMIDI_SUPPORT>0)
        ldx HerMIDIswitch
        beq +
        ldx MIDIsig+1
        beq +
        txa
        bne ++
.fi
+       clc
        ldx octave
        adc OCTMULS,x
+       cmp #maxnotenum
        bcs retnotew
        ldx currwin
        cpx #inswin
        bne writeno
        ldx notemode
        beq retnotew
+       ora #$80 ;absolute-notes in instrument-table 'frequency' column
writeno sta (idatzp),y
        lda (idatzp),y
        bpl + ;don't advance for note-fx in pattern-window
        lda currwin
        ;cmp #ptnwin
        beq jammer ;retnotew
+       lda advance
        beq jammer ;retnotew
        iny
        cpy astore2+1
        beq retnotew
        jmp crsrdn ;jmp crsrdn ;advance in pattern

jammer  lda playmode
        bne retnotew
        ldx #1       ;display realtime play-positions in instr.tables
        lda currwin
        ;cmp #ptnwin
        bne + ;if not pattern-window, always display channel2 instr.
        ldy curwinposx+ptnwin ;else display instr. of cursor's channel
        ldx trkselect,y
+       lda jamnote+1
prvnote cmp #selfmod
        beq retnotew
.if (HERMIDI_SUPPORT>0)
        ldy HerMIDIswitch
        beq +
        ldy MIDIsig+1
        beq +
        tya
        bne ++
.fi
+       clc
        ldy octave
        adc OCTMULS,y
+       sta player.currnote,x
        lda currins
        sta player.currinst,x
        tay
        lda insptlo,y
        sta playzp+0
        lda inspthi,y
        sta playzp+1
        lda prvnote+1
        bne legato ;there was no gap between keypresses? -> legato
newnote ;lda #cmd_rts
        ;sta player.return0
.if (SYNC_SUPPORT!=0 || PHASE_SUPPORT!=0)
        lda #0
        sta player.syncmode+0
        sta player.syncmode+1
.fi
        jmp player.initins ;jsr player.initins ;(this editor's version ends with 'rts' after instrument initializations)
        ;jmp bktonop
legato  ;lda #cmd_rts
        ;sta player.return0
        jmp player.legato ;jsr player.legato
;bktonop lda #cmd_nop
;        sta player.return0
;        rts


writehex ;inputs: read-value in A, digi-number in X, Y is intact 
        cpx #1
		beq writehex2
;merge typed 1st hexa digit with existing data
writehex1
		and #$0f
		sta wrhxad2+1
wrhxad1 lda #selfmod	
		asl
		asl
		asl
		asl
wrhxad2 ora #selfmod
        ldx currwin
		inc curwinposx,x
		rts
writehex2			;merge typed 2nd hexa digit with existing data
		and #$f0
wrhxad3 ora #selfmod
		rts


getcurptnaddr ;into idatzp, returns current index in Y, current track in X, current patternlength in A
        jsr getcurtrk
        lda trksubpos,x
        tax
getptna ldy trkstor+1
        lda currptn,y ;entry point to give column inside track in X (call getcurtrk beforehand)
        tay
        lda pattptlo,y
        clc
        adc ptcolindexes,x
        sta idatzp+0
        lda pattpthi,y
        adc #0 ;add Carry
        sta idatzp+1
        lda ptnlen,y
        sta ptlenst+1
trkstor ldx #selfmod
gettidx lda curwinposy+ptnwin
        clc
        adc ptnindex,x
        tay
ptlenst lda #selfmod
        rts

getcurtrk ldx curwinposx+ptnwin
        ldy trkselect,x
        sty trkstor+1
        rts


getcurseqaddr
.if (HORIZONTAL_ORDERLIST>0)
        lda curwinposy+oliwin
.else
        ldy curwinposx+oliwin
        lda oliindex,y
.fi
getseqa sta olichan+1
        ldy cursubtune
        lda seqptrlo,y
        sta idatzp+0
        lda seqptrhi,y
        sta idatzp+1
olichan ldy #selfmod
        beq setseqy
-       lda idatzp+0
        clc
        adc #maxseqlen+1
        sta idatzp+0
        bcc +
        inc idatzp+1
+       dey
        bne -
setseqy 
.if (HORIZONTAL_ORDERLIST>0)
        lda curwinposx+oliwin
        lsr
.else
        lda curwinposy+oliwin
.fi
        clc
        adc seqindex
        tay
        rts


getcurinsaddr
        ldy currins
        lda insptlo,y
        sta idatzp+0
        lda inspthi,y
        sta idatzp+1
        lda curwinposx+inamewin
        clc
        adc #insnamepos
        tay
        rts


getcurinstbaddr
        ldx curwinposx+inswin
getitba ldy currins
        lda insptlo,y
        clc
        adc inswindex,x
        sta idatzp+0
        lda inspthi,y
        adc #0 ;add Carry
        sta idatzp+1
        lda curwinposy+inswin
        clc
        adc insindex
        tay
        rts


OCTMULS .byte 0,12,24,36,48,60,72,84,96,108 ;TRANSPOSITION VALUE OF OCTAVES TO ADD/SUBSTRACT FROM NOTE

NoteOfX	.byte 12+12+4	;X=0 D# in the second higher keyboard octave
		.byte 0			;X=1 no note to play, using for NOP placement
		.byte 12+2		;X=2 C# in the higher keyboard octave
		.byte 12+4		;X=3 D# in the higher keyboard octave
		.byte $ff		;X=4 no note for key 4
		.byte 12+7		;X=5 F# in the higher keyboard octave
		.byte 12+9		;X=6 G# in the higher keyboard octave
		.byte 12+11		;X=7 A# in the higher keyboard octave
		.byte $ff		;X=8 no note for key 8
		.byte 12+12+2	;X=9 C# in the second higher keyboard octave
		.byte 0			;X=A no note assigned for key A, using it for NOP
		.byte 0+8		;X=B G in the lower keyboard octave
		.byte 0+5		;X=C E in the lower keyboard octave
		.byte 0+4		;X=D D# in the higher keyboard octave
		.byte 12+5		;X=E E in the higher keyboard octave
		.byte $ff		;X=F no sound produced on F key for jamming



;======================== DISPLAY ROUTINES =============================
.if (MACHINE==2)
 .cerror(*>=$D000),"CODE-AREA BELOW I/O OVERLAPS C64 I/O AREA. MOVE SOME CODE ABOVE $E000, ",*
 .if ( * >= $D000-($FFFF-$E000) )
  *=$E000
 .fi
.fi



display 
.if (MACHINE>0) ;(SUBTUNE_SUPPORT!=0)
        lda cursubtune
        jsr hexdisp
.else
        lda #"-"
.fi
        sta (HORIZONTAL_ORDERLIST>0)? VRAM+mainhdposy*rowlen+mainhdposx+2 : VRAM+mainhdposy*rowlen+4
        lda tuneheader.framespd
        jsr hexdisp
        sta (HORIZONTAL_ORDERLIST>0)? VRAM+mainhdposy*rowlen+mainhdposx+5 : VRAM+mainhdposy*rowlen+mainhdposx+8
        lda octave
        jsr hexdisp
        sta (HORIZONTAL_ORDERLIST>0)? VRAM+mainhdposy*rowlen+mainhdposx+13 : VRAM+mainhdposy*rowlen+mainhdposx+18
        lda currtempo+0
        and #$7f
        jsr hexdisp
        cpx #"0"
        bne +
        ldx #"."
+       stx (HORIZONTAL_ORDERLIST>0)? VRAM+mainhdposy*rowlen+mainhdposx+9 : VRAM+mainhdposy*rowlen+mainhdposx+12
        sta (HORIZONTAL_ORDERLIST>0)? VRAM+mainhdposy*rowlen+mainhdposx+10 : VRAM+mainhdposy*rowlen+mainhdposx+13
.if (HORIZONTAL_ORDERLIST==0)
        lda currtempo+1
        and #$7f
        jsr hexdisp
        cpx #"0"
        bne +
        ldx #"."
+       stx (HORIZONTAL_ORDERLIST>0)? VRAM+mainhdposy*rowlen+mainhdposx+9 : VRAM+mainhdposy*rowlen+mainhdposx+14
        sta (HORIZONTAL_ORDERLIST>0)? VRAM+mainhdposy*rowlen+mainhdposx+10 : VRAM+mainhdposy*rowlen+mainhdposx+15
.fi
        
dispatt ldx #CHANNELAMOUNT-1
        stx columnzp
pattdlp ldx columnzp
        ldy currptn,x
        lda ptnlen,y
        sta lenstor+1
        lda pattptlo,y
        sta datzp+0
        lda pattpthi,y
        sta datzp+1
        lda trkposxlo,x
        sta diszp+0
        lda trkposxhi,x
        sta diszp+1
        tya
        ldy trkhdrposx,x
        jsr hexdisp
        sta VRAM+trkposy*rowlen+pattposx+1,y
        txa
        sta VRAM+trkposy*rowlen+pattposx+0,y
        ldx columnzp
        lda player.currinst,x
        jsr hexdisp
        sta VRAM+trkposy*rowlen+pattposx+5,y
        txa
        sta VRAM+trkposy*rowlen+pattposx+4,y
        lda #0
        sta rowzp
pattdl2 ldx columnzp
        clc ;accu holds 'rowzp' here even when looping back
        adc ptnindex,x
        sta pdindex+1 
        lsr
        lsr
        lsr
        lsr
        tax
        lda invhexd,x
        ldy #0
        sta (diszp),y
        lda pdindex+1
        and #$0f
        tax
        lda invhexd,x
        iny
        sta (diszp),y
dplypos ldx columnzp
        ldy #" "
        lda playerpcnt,x ;pattcnt,x
        cmp pdindex+1
        bne +
        lda currptn,x
        cmp playerpatt,x ;currpatt,x
        bne +
        ldy #"<"
+       tya
        ldy #playposcolumnx
        sta (diszp),y
pdindex lda #selfmod        
lenstor cmp #selfmod
        bcc inpattn
outpatt lda #" "
        ldy #notecolumnx
-       sta (diszp),y
        iny
        cpy #trkwidth ;fxcolumnx+2
        bne -
        jmp gonextr
inpattn ldy pdindex+1
        lda (datzp),y ;freq(note)
        bpl normaln
dnotefx pha
        and #$0f
        tay
        lda hexdigi,y
        ldy #notecolumnx+2
        sta (diszp),y
        pla
        lsr
        lsr
        lsr
        lsr
        sec
        sbc #8
        tax
        lda noteFxCh2,x 
        dey
        sta (diszp),y
        lda noteFxCh1,x
        dey
        sta (diszp),y
        jmp dptnins
normaln tax
        lda noteCh1,x
        ldy #notecolumnx
        sta (diszp),y 
        lda noteCh2,x
        iny
        sta (diszp),y
        lda noteCh3,x 
        iny
        sta (diszp),y
dptnins lda pdindex+1
        clc
        adc #maxptnlen+1 ;reading 'insindex' could be used but would be much slower (positions in editor are fixed anyway)
        tay
        lda (datzp),y ;instrument/fx
        pha
        bne +
        lda #"."
        jmp ++
+       lsr
        lsr
        lsr
        lsr
        tax
        lda hexdigi,x
+       ldy #instcolumnx
        sta (diszp),y
        pla
        bne +
        lda #"."
        jmp  ++
+       and #$0f
        tax
        lda hexdigi,x
+       iny
        sta (diszp),y
diptnfx lda pdindex+1
        clc
        adc #(maxptnlen+1)*2 ;reading 'fxindex' could be used but would be much slower (positions in editor are fixed anyway)
        tay
        lda (datzp),y ;fx/val
        pha
        bne +
        lda #"."
        jmp ++
+       lsr
        lsr
        lsr
        lsr
        tax
        lda hexdigi,x
+       ldy #fxcolumnx
        sta (diszp),y
        pla
        bne +
        lda #"."
        jmp  ++
+       and #$0f
        tax
        lda hexdigi,x
+       iny
        sta (diszp),y
gonextr jsr nextrow
        inc rowzp
        lda rowzp
        cmp #pattheight
        beq +
        jmp pattdl2
+       dec columnzp
        bmi +
        jmp pattdlp
+

dispseq 

.if (HORIZONTAL_ORDERLIST>0)

        lda #<(VRAM+(oliposy+CHANNELAMOUNT)*rowlen+oliposx)
        sta diszp+0
        lda #>(VRAM+(oliposy+CHANNELAMOUNT)*rowlen+oliposx)
        sta diszp+1 
 .if(INFOBAR_SUPPORT>0)
editinf lda #selfmod
        bne +
 .fi
        ldx #0 ;display orderlist position numbering
-       txa
        clc
        adc seqindex
        pha
        lsr
        lsr
        lsr
        lsr
        tay
        lda invhexd,y
        ldy seqnumposx,x
        sta (diszp),y
        pla
        and #$0f
        tay
        lda invhexd,y
        ldy seqnumposx,x
        iny
        sta (diszp),y
        inx
        cpx #seqdilen
        bne -
+       lda #<(VRAM+oliposy*rowlen+oliposx)
        sta diszp+0
        sta colorzp+0
        lda #>(VRAM+oliposy*rowlen+oliposx)
        sta diszp+1   
        lda #>(CRAM+oliposy*rowlen+oliposx)
        sta colorzp+1
        ldx #0 
        stx rowzp
dsequen ldy cursubtune
        lda seqptrlo,y
        sta datzp+0
        lda seqptrhi,y
        sta datzp+1
olidilp ldx #0
seqdilp txa
        clc
        adc seqindex
        sta seqppos+1
        tay
        lda (datzp),y
        pha
        lsr
        lsr
        lsr
        lsr
        tay
        lda hexdigi,y
        ldy seqnumposx,x
        sta (diszp),y
        pla
        and #$0f
        tay
        lda hexdigi,y
        ldy seqnumposx,x
        iny
        sta (diszp),y
seqcolo ldy rowzp
        lda player.seqcnt,y
        sta seqcnst+1
        lda playmark,y
        tay
        lda #olicolor
seqppos cpy #selfmod
        bne +
        lda #seqplaymarkcol
+       ldy seqppos+1
seqcnst cpy #selfmod
        bne +
        lda #seqplayposcol
+       ldy seqnumposx,x
        sta (colorzp),y
        iny
        sta (colorzp),y
        inx
        cpx #seqdilen
        bne seqdilp
        jsr nextrow
        lda datzp+0
        clc
        adc #maxseqlen+1
        sta datzp+0
        bcc +
        inc datzp+1
+       inc rowzp
        lda rowzp
        cmp #CHANNELAMOUNT
        bne olidilp

.else ;vertical orderlist?
        lda #<(VRAM+oliposy*rowlen+oliposx)
        sta diszp+0
        sta colorzp+0
        lda #>(VRAM+oliposy*rowlen+oliposx)
        sta diszp+1 
        lda #>(VRAM+oliposy*rowlen+oliposx)
        sta diszp+1   
        lda #>(CRAM+oliposy*rowlen+oliposx)
        sta colorzp+1
        ldx #0
        stx columnzp
        ldy cursubtune
        lda seqptrlo,y
        sta datzp+0
        lda seqptrhi,y
        sta datzp+1
olidilp lda columnzp
        clc
        adc seqindex
        sta seqppos+1
        lsr
        lsr
        lsr
        lsr
        tay
        lda invhexd,y
        ldy #oliposx
        sta (diszp),y
        lda seqppos+1
        and #$0F
        tay
        lda invhexd,y
        ldy #oliposx+1
        sta (diszp),y
seqppos ldy #selfmod
        lda (datzp),y
        pha
        lsr
        lsr
        lsr
        lsr
        bne +
        lda #"."
        bne ++ ;jmp
+       tay
        lda hexdigi,y
+       ldy #oliposx+2
        sta (diszp),y
        pla
        and #$0F
        tay
        lda hexdigi,y
        ldy #oliposx+3
        sta (diszp),y
        ldy seqppos+1
        lda (datzp),y
        lda seqppos+1
        clc
        adc #maxseqlen+1
        tay
        lda (datzp),y
        pha
        lsr
        lsr
        lsr
        lsr
        bne +
        lda #"."
        bne ++ ;jmp
+       tay
        lda hexdigi,y
+       ldy #oliposx+4
        sta (diszp),y
        pla
        and #$0F
        tay
        lda hexdigi,y
        ldy #oliposx+5
        sta (diszp),y
seqcolo lda playmark+0
        tay
        lda #olicolor
        cpy seqppos+1
        bne +
        lda #seqplaymarkcol
+       ldy seqppos+1
        cpy player.seqcnt+0
        bne +
        lda #seqplayposcol
+       ldy #2
        sta (colorzp),y
        iny
        sta (colorzp),y
        lda playmark+1
        tay
        lda #olicolor2
        cpy seqppos+1
        bne +
        lda #seqplaymarkcol2
+       ldy seqppos+1
        cpy player.seqcnt+1
        bne +
        lda #seqplayposcol2
+       ldy #4
        sta (colorzp),y
        iny
        sta (colorzp),y
        jsr nextrow
        inc columnzp
        lda columnzp
        cmp #seqdilen ;oliheight
        beq +
        jmp olidilp
+
.fi


dispins ldy currins
        lda insptlo,y
        sta datzp+0
        lda inspthi,y
        sta datzp+1
dinsnum tya
        jsr hexdisp
        stx VRAM+(instbposy+2)*rowlen+instbposx
        sta VRAM+(instbposy+2)*rowlen+instbposx+1
dimulsp ldx #" "
        ldy #instcontrolswitchpos
        lda (datzp),y
        bpl +
        ldx #$5a ;"*" ;$67
+       stx VRAM+(instbposy+2)*rowlen+instbposx+9
        pha
        ldx #" "
        and #$40
        beq +
        ldx #$5a ;$5c ;$5a ;$7c ;$6c ;"*" ;$67
+       stx VRAM+(instbposy+2)*rowlen+instbposx+5        
        pla
        ldx #" "
        and #$20
        beq +
        ldx #$5a
+       stx VRAM+(instbposy+2)*rowlen+instbposx+2  
.enc screen
        ldx #"Q"
        lda notemode
        beq +
        ldx #"N"
+       stx VRAM+(instbposy+2)*rowlen+instbposx+8
.enc none
dinsnam ldy #insnamepos
        ldx #0
-       lda (datzp),y 
        and #$3F
        sta VRAM+instbposy*rowlen+instbposx,x
        iny
        inx
        cpx #insnamelen
        bne -
        lda #<(VRAM+(instbposy+instbaddy)*rowlen+instbposx)
        ldx #>(VRAM+(instbposy+instbaddy)*rowlen+instbposx)
        sta diszp+0
        stx diszp+1
        ldx #0
insdilp txa
        clc
        adc insindex
        sta idindex+1
dispiwf clc
        adc #insheadersize
        tay
        lda (datzp),y ;waveform/control
        pha
        lsr
        lsr
        lsr
        lsr
        tay
        lda hexdigi,y
        ldy #iwfcolumnx
        sta (diszp),y
        pla
        and #$0f
        tay
        lda hexdigi,y
        ldy #iwfcolumnx+1
        sta (diszp),y
idindex lda #selfmod  ;position-numbering of instrument-table
        lsr
        lsr
        lsr
        lsr
        tay
        lda invhexd,y
        ldy #0
        sta (diszp),y
        lda idindex+1
        and #$0f
        tay
        lda invhexd,y
        ldy #1
        sta (diszp),y
dwfppos stx xstore6+1
        ldx #1       ;display realtime play-positions in instr.tables
        lda currwin
        ;cmp #ptnwin
        bne dwftpos ;if not pattern-window, always display channel2 instr.
        ldy curwinposx+ptnwin ;else display instr. of cursor's channel
        ldx trkselect,y
dwftpos ldy #wftbnoteoffindexpos
        lda (datzp),y
        sec
        sbc #wftbstartindex
        ldy #" "        
        cmp idindex+1
        bne +
        ldy #$67
+       lda currins
        cmp player.currinst,x ;2nd channel to monitor & jam instrument
        bne +
        lda wftbpos,x
        sec
        sbc #wftbstartindex
        cmp idindex+1
        bne +
        ldy #">"
+       tya
        ldy #iwfcolumnx-1
        sta (diszp),y
dfrtpos ldy #freqtbstartindexpos
        lda (datzp),y
        sta frqtidx+1
        ldy #freqtbnoteoffindexpos
        lda (datzp),y
        sec
frqtidx sbc #selfmod
        ldy #" "
        cmp idindex+1
        bne +
        ldy #$67
+       lda currins
        cmp player.currinst,x ;2nd channel to monitor & jam instrument
        bne +
        lda freqtbpos,x
        sec
        sbc frqtidx+1
        cmp idindex+1
        bne +
        ldy #">"
+       tya
        ldy #ifreqcolumnx-1
        sta (diszp),y
dvotpos ldy #voltbstartindexpos
        lda (datzp),y
        sta voltidx+1
        ldy #voltbnoteoffindexpos
        lda (datzp),y
        sec
voltidx sbc #selfmod
        ldy #" "
        cmp idindex+1
        bne +
        ldy #$67
+       lda currins
        cmp player.currinst,x ;2nd channel to monitor & jam instrument
        bne +
        lda voltbpos,x
        sec
        sbc voltidx+1
        cmp idindex+1
        bne +
        ldy #">"
+       tya
        ldy #ivolcolumnx-1
        sta (diszp),y
xstore6 ldx #selfmod
disfreq lda idindex+1
        clc
        adc #insheadersize+maxinstblen+1 ;could be calculated from corresponding indexers in inst.data, but in editor it's faster this way
        tay
        lda (datzp),y ;freq/note
        bpl disnumf ;above $80? absolute note
        cmp #instb_max_note
        bcs disnumf
        ldy notemode
        bne disnote
disnumf pha
        and #$0f
        tay
        lda hexdigi,y
        ldy #ifreqcolumnx+2
        sta (diszp),y
        pla
        lsr
        lsr
        lsr
        lsr
        tay
        lda hexdigi,y
        ldy #ifreqcolumnx+1
        sta (diszp),y
        dey
        lda #"$"
        sta (diszp),y
        jmp disivol
disnote and #$7f
        sta notesto+1
        tay
        lda noteCh1,y
        ldy #ifreqcolumnx
        sta (diszp),y
notesto ldy #selfmod 
        lda noteCh2,y
        ldy #ifreqcolumnx+1
        sta (diszp),y
        ldy notesto+1
        lda noteCh3,y 
        ldy #ifreqcolumnx+2
        sta (diszp),y
disivol lda idindex+1
        clc
        adc #insheadersize+(maxinstblen+1)*2 ;could be calculated from corresponding indexers in inst.data, but in editor it's faster this way
        tay
        lda (datzp),y ;volume
        pha
        lsr
        lsr
        lsr
        lsr
        tay
        lda hexdigi,y
        ldy #ivolcolumnx
        sta (diszp),y
        pla
        and #$0f
        tay
        lda hexdigi,y
        ldy #ivolcolumnx+1
        sta (diszp),y        
        jsr nextrow
        inx
        cpx #instbheight
        beq +
        cpx #maxinstblen
        bcs +
        jmp insdilp
+       
        ldx #0
        jsr dispmutesolo
        ldx #1
        jmp dispmutesolo
        ;rts
winposy .byte pattposy,oliposy,instbposy+instbaddy,instbposy


nextrow lda diszp+0
        clc
        adc #rowlen
        sta diszp+0
        sta colorzp+0
        bcc +
        inc diszp+1
        inc colorzp+1
+       rts


dispmutesolo ;for a given channel
        lda trkcolposxlo,x
        sta diszp+0 ;colorzp+0
        lda trkcolposxhi,x
        sta diszp+1 ;colorzp+1
        lda mutesolo,x
        and muteormask,x
        bne +
        lda #mutecolor
        .byte $2c ;skip
+       lda #notecolor     
        sta mscolst+1
        lda #pattheight
        sta rowzp
mscolst lda #selfmod
        ldy #0
        sta (diszp),y ;(colorzp),y
        iny 
        sta (diszp),y ;(colorzp),y
        iny
        sta (diszp),y ;(colorzp),y
        jsr nextrow
        dec rowzp   
        bne mscolst
        rts


dispcursor
notefxv lda currwin
        cmp #ptnwin
        bne +
        jsr getcurptnaddr
        lda (idatzp),y
        bpl +
        lda #$80
        ldx curwinposx+ptnwin
        beq ++
        cpx #trkcurcolumns ;trkorigo+1
        beq ++
+       lda #0
+       sta idatzp

        ldy currwin        
        ldx curwinposx,y
        cpy #ptnwin
        bne ++
        lda ptwinposx,x
        bit idatzp
        bpl +
        lda ptwinposx2,x
+       jmp discrxa
+       cpy #oliwin
        bne +
.if (HORIZONTAL_ORDERLIST>0)
        lda olwinposx,x
.else
        txa
        clc
        adc #oliposx+2
.fi
        jmp discrxa
+       cpy #inswin
        bne +
        lda inswinposx,x
        jmp discrxa
+       cpy #inamewin
        bne discrxb
        txa
        clc
        adc #instbposx
discrxa sta cursorx+1
discrxb lda curwinposy,y
        clc
        adc winposy,y
.if (MACHINE<2)
discrxy tay
        lda curmul40lo,y
        clc
cursorx adc #selfmod  ;pattposx+notecolumnx
        sta curposlo
        lda curmul40hi,y
        adc #0 ;add Carry
        sta curposhi
.else
        asl
        asl
        asl
        clc
        adc #$32-1
        sta $d001
        ldy #0
cursorx lda #selfmod
        asl
        asl
        asl
        bcc +
        iny
+       clc
        adc #$18-1
        sta $d000
        bcc +
        ldy #1
+       sty $d010
        lda #$01
        sta $d015
        lda #0
        sta $d01b
        sta $d017
        sta $d01c
        lda #<(cursprite/$40)
        sta VRAM+$3F8
.fi
        rts


trkposxlo .byte <(VRAM+pattposy*rowlen+pattposx), <(VRAM+pattposy*rowlen+pattposx+trkgapx+trkwidth)
trkposxhi .byte >(VRAM+pattposy*rowlen+pattposx), >(VRAM+pattposy*rowlen+pattposx+trkgapx+trkwidth)
trkcolposxlo .byte <(CRAM+pattposy*rowlen+pattposx+2), <(CRAM+pattposy*rowlen+pattposx+trkgapx+trkwidth+2)
trkcolposxhi .byte >(CRAM+pattposy*rowlen+pattposx+2), >(CRAM+pattposy*rowlen+pattposx+trkgapx+trkwidth+2)

.if (HORIZONTAL_ORDERLIST>0)
seqnumposx .for i=0,i<seqdilen,i=i+1
            .byte i*3
           .next
.fi

trkhdrposx .for i=0,i<CHANNELAMOUNT,i=i+1
            .byte 2+(trkwidth+trkgapx)*i
           .next

ptwinposx .for i=0,i<CHANNELAMOUNT,i=i+1
            .byte i*(trkwidth+trkgapx)+pattposx+notecolumnx, i*(trkwidth+trkgapx)+pattposx+instcolumnx, i*(trkwidth+trkgapx)+pattposx+instcolumnx+1
            .byte i*(trkwidth+trkgapx)+pattposx+fxcolumnx, i*(trkwidth+trkgapx)+pattposx+fxcolumnx+1
          .next

ptwinposx2 .for i=0,i<CHANNELAMOUNT,i=i+1
             .byte i*(trkwidth+trkgapx)+pattposx+notecolumnx+2, i*(trkwidth+trkgapx)+pattposx+instcolumnx, i*(trkwidth+trkgapx)+pattposx+instcolumnx+1
             .byte i*(trkwidth+trkgapx)+pattposx+fxcolumnx, i*(trkwidth+trkgapx)+pattposx+fxcolumnx+1
           .next

trkorigo .for i=0,i<CHANNELAMOUNT,i=i+1
          .byte i*trkcurcolumns
         .next

trkselect .for i=0,i<CHANNELAMOUNT,i=i+1
            .fill trkcurcolumns,i
          .next

trksubpos .for i=0,i<CHANNELAMOUNT,i=i+1
            .for j=0,j<trkcurcolumns,j=j+1
             .byte j
            .next
          .next

trkdiginum .byte $00, $00,$01, $00,$01,   $00, $00,$01, $00,$01,$41,$10,$0A, $24,$1A,$12, $28, $40,$01, $00 

ptcolindexes .byte 0, maxptnlen+1, maxptnlen+1, (maxptnlen+1)*2, (maxptnlen+1)*2

.if (HORIZONTAL_ORDERLIST>0)
olwinposx .for i=0,i<seqdilen, i=i+1
           .byte oliposx+i*3, oliposx+i*3+1
          .next
.fi

inswindex .for i=0,i<instbcurcolumns,i=i+1
           .byte insheadersize+(maxinstblen+1)*(i/2)
          .next

inswinposx .byte instbposx+iwfcolumnx,instbposx+iwfcolumnx+1, instbposx+ifreqcolumnx+1,instbposx+ifreqcolumnx+2, instbposx+ivolcolumnx,instbposx+ivolcolumnx+1

.if (MACHINE<2)
curmul40lo .for i=0,i<rowamount,i=i+1
            .byte <(i*40)
           .next
curmul40hi .for i=0,i<rowamount,i=i+1
            .byte >(i*40)
           .next
.else
curcolors .byte 0,6,4,14,3,13,7,1,1,7,15,10,8,2,9,0
.fi

.enc screen
invhexd .text "0"+$80,"1"+$80,"2"+$80,"3"+$80,"4"+$80,"5"+$80,"6"+$80,"7"+$80,"8"+$80,"9"+$80,"A"+$80,"B"+$80,"C"+$80,"D"+$80,"E"+$80,"F"+$80
noteCh1 .TEXT ".CCDDEFFGGAAHCCDDEFFGGAAHCCDDEFFGGAAHCCDDEFFGGAAHCCDDEFFGGAAHCCDDEFFGGAAHCCDDEFFGGAAHCCDDEFFGGAAHCCDDEFFGGAAHCCDDEFFGGAAH","S","S","L","L","+","-","G"
noteCh2 .TEXT ".-#-#--#-#-#--#-#--#-#-#--#-#--#-#-#--#-#--#-#-#--#-#--#-#-#--#-#--#-#-#--#-#--#-#-#--#-#--#-#-#--#-#--#-#-#--#-#--#-#-#-","Y","Y","E","E","+","-","A"
noteCh3	.TEXT ".000000000000111111111111222222222222333333333333444444444444555555555555666666666666777777777777888888888888999999999999","N","-","G","-","+","-","P"
noteFxCh1 .text $60+8 , " "  , " "  ,$40+21      ;.text "V","S","S","P"
noteFxCh2 .text $60+8 ,$40+14,$40+13,$40+9      ;.text "I","U","D","O"
.enc none

.if (RUNNABLE_EXPORT_SUPPORT>0)
frmspds ;framespeed-program positions ;couldn't calculate by iteration (accumulation caused double defines)
        .byte 0,   0, 1, 1+2, 1+2+3, 1+2+3+4, 1+2+3+4+5, 1+2+3+4+5+6, 1+2+3+4+5+6+7
EXEframerows ;a hand-crafted table so it looks better on Plus4 than automatic at higher framespeeds
 .byte exerast1 ;1x
 .if (MACHINE<2)
  .byte $30, exerast1 ;2x
  .byte $34, exerast1, $64 ;3x
  .byte $24, exerast1, $82, $38 ;4x
  .byte $10+8, exerast1+8, $8E+8, $50+8, $0F+8 ;5x
  .byte $04+16, exerast1+16, $98+16, $64+16, $30+16, $00+16 ;6x
  .byte $00+20, exerast1+20, $A0+20, $74+20, $48+20, $1C+20, $02 ;7x
  .byte $00+22, exerast1+22, $A5+22, $7E+22, $57+22, $30+22, $9+22, $1E+22 ;8x
 .else ;C64:
  .byte $62, exerast1 ;2x
  .byte $38, exerast1, $96 ;3x
  .byte $37, exerast1, $B0, $62 ;4x
  .byte $37, exerast1, $C0, $82, $44 ;5x
  .byte $30, exerast1, $CA, $96, $62, $2E ;6x
  .byte $2E, exerast1, $D2, $A6, $7A, $4E, $22 ;7x
  .byte $25, exerast1, $D7, $B0, $89, $62, $3B, $14 ;8x 
 .fi
.fi



;=========================== MISC ROUTINES =============================
iniscrn lda #bgcolor
        sta bgcol
        lda #bordercolor
        sta bordcol
        .if (MACHINE<2)
        lda #$08
        sta VRAMaddr
        lda #0
        sta VRAMposhi
        lda #$F8
        sta VRAMposlo
        .fi
        jsr capitch
        lda #$1b
        sta vmodeyscroll
        lda #$08 ;$48 for NTSC?
        sta cmodexscroll
        lda #fgcolor
        jsr clearscrn
        ldy #rowlen-1
        lda #$43 ;"-"
-       sta VRAM+(pattposy-1)*rowlen,y
        sta VRAM+(pattposy+pattheight)*rowlen,y ;(HORIZONTAL_ORDERLIST>0)? VRAM+(oliposy-1)*rowlen,y : VRAM+lastrow*rowlen+0,y
        dey
        bpl -
        ldy #(HORIZONTAL_ORDERLIST>0)? trkwidth-1: 7
-       lda trkheader,y
.for i=0, i<CHANNELAMOUNT, i=i+1
        sta VRAM+trkposy*rowlen+pattposx+(trkwidth+trkgapx)*i,y
.next
.if (COLOR_SUPPORT>0)
        lda trkheadercol,y
 .for i=0, i<CHANNELAMOUNT, i=i+1
        sta CRAM+trkposy*rowlen+pattposx+(trkwidth+trkgapx)*i,y
 .next
.fi
        dey
        bpl -
        ldy #mainhdwidth-1  ;main header
-       lda mainheader,y
.if (HORIZONTAL_ORDERLIST==0)
        cpy #5
        beq ++
        bcs +    
        sta VRAM+mainhdposy*rowlen+0,y ;oliposx
        jmp ++
.fi 
+       sta VRAM+mainhdposy*rowlen+mainhdposx,y
+       dey
        bpl -
        ldy #instbwidth-1   ;inst.table decorations
-       lda instbheader,y
        sta VRAM+(instbposy+2)*rowlen+instbposx,y
        lda #$43 ;"-"
        sta VRAM+(instbposy+3)*rowlen+instbposx,y        
        sta VRAM+(instbposy+1)*rowlen+instbposx,y
        lda #"."
        sta VRAM+(instbposy+0)*rowlen+instbposx,y
        .if (COLOR_SUPPORT>0)
        lda #datacolor
        sta CRAM+(instbposy+0)*rowlen+instbposx,y
        .fi
        dey
        bpl -
        lda #<(VRAM+(pattposy-1)*rowlen)
        sta diszp+0
        lda #>(VRAM+(pattposy-1)*rowlen)
        sta diszp+1
        ldx #pattheight+2
-       ldy #(HORIZONTAL_ORDERLIST>0)? 0 : pattposx-1 
        lda #$42 ;"!"
        cpx #pattheight+2
        bne +
        lda #$72
+       cpx #1
        bne +
        lda #$71
+       sta (diszp),y
        ldy #instbposx-1
        sta (diszp),y
.if (HORIZONTAL_ORDERLIST>0)
        ldy #rowlen-1
        sta (diszp),y
.fi
        jsr nextrow
        dex
        bne -
.if (COLOR_SUPPORT>0)
        lda #(HORIZONTAL_ORDERLIST>0)? <(CRAM+pattposy*rowlen+pattposx) : <(CRAM+pattposy*rowlen+oliposx) ;colouring patterns
        sta diszp+0
        lda #(HORIZONTAL_ORDERLIST>0)? >(CRAM+pattposy*rowlen+pattposx) : >(CRAM+pattposy*rowlen+oliposx)
        sta diszp+1
        ldx #pattheight-1
-       ldy #(HORIZONTAL_ORDERLIST>0)? ((trkwidth+trkgapx)*CHANNELAMOUNT)-1 : ((trkwidth+trkgapx)*CHANNELAMOUNT)+oliwidth+1
-       lda trkcolors,y
        sta (diszp),y
        dey
        bpl -
        jsr nextrow
        dex
        bpl --
        lda #<(CRAM+(instbposy+instbaddy)*rowlen+instbposx)
        sta diszp+0
        lda #>(CRAM+(instbposy+instbaddy)*rowlen+instbposx)
        sta diszp+1
        ldx #instbheight-1
-       ldy #instbwidth-1
-       lda instbcolors,y
        sta (diszp),y
        dey
        bpl -
        jsr nextrow
        dex
        bpl --
.fi
.if (HORIZONTAL_ORDERLIST>0)
        ldy #oliwidth-1
-       
.if (COLOR_SUPPORT>0)
        lda #olicolor
 .for i=0, i<CHANNELAMOUNT, i=i+1
        sta CRAM+(oliposy+i)*rowlen+oliposx,y
 .next
.fi
        lda #"-"+$80
        sta VRAM+(oliposy+CHANNELAMOUNT)*rowlen+oliposx,y
.if (COLOR_SUPPORT>0)
        lda #poscolor
        sta CRAM+(oliposy+CHANNELAMOUNT)*rowlen+oliposx,y
.fi
        dey
        bpl -
.fi
.if (COLOR_SUPPORT>0)
 .if (HORIZONTAL_ORDERLIST>0)
        lda #poscolor
        sta CRAM+(oliposy+CHANNELAMOUNT)*rowlen+0
        sta CRAM+(oliposy+CHANNELAMOUNT)*rowlen+rowlen-1
 .fi
        lda #datacolor
        sta CRAM+(instbposy+2)*rowlen+instbposx+0
        sta CRAM+(instbposy+2)*rowlen+instbposx+1
        sta (HORIZONTAL_ORDERLIST>0)? CRAM+mainhdposy*rowlen+mainhdposx+5 : CRAM+mainhdposy*rowlen+mainhdposx+8
        sta (HORIZONTAL_ORDERLIST>0)? CRAM+mainhdposy*rowlen+mainhdposx+9 : CRAM+mainhdposy*rowlen+mainhdposx+12 
        sta (HORIZONTAL_ORDERLIST>0)? CRAM+mainhdposy*rowlen+mainhdposx+10 : CRAM+mainhdposy*rowlen+mainhdposx+13
        sta (HORIZONTAL_ORDERLIST>0)? CRAM+mainhdposy*rowlen+mainhdposx+13 : CRAM+mainhdposy*rowlen+mainhdposx+18
 .if (HORIZONTAL_ORDERLIST==0)
        sta CRAM+mainhdposy*rowlen+mainhdposx+14
        sta CRAM+mainhdposy*rowlen+mainhdposx+15
 .fi
 .if (SUBTUNE_SUPPORT==0)
        lda #poscolor
 .fi
        sta (HORIZONTAL_ORDERLIST>0)? CRAM+mainhdposy*rowlen+mainhdposx+2 : CRAM+mainhdposy*rowlen+4
        lda #(MULTISPEED_ENTRY_SUPPORT!=0 && TABLE_MULTISPEED_SEL_SUPPORT!=0) ? fgcolor : poscolor
        sta CRAM+(instbposy+2)*rowlen+instbposx+2
        sta CRAM+(instbposy+2)*rowlen+instbposx+5
        sta CRAM+(instbposy+2)*rowlen+instbposx+9
.fi
.if (HORIZONTAL_ORDERLIST==0)
        lda #$6B
        sta VRAM+(instbposy+1)*rowlen+instbposx-1
        sta VRAM+(instbposy+3)*rowlen+instbposx-1
.fi
.if (MACHINE==0 && maxinstblen<=15 && HORIZONTAL_ORDERLIST==0)
        ldy #instbwidth-1
-       lda #$40
        sta VRAM+(lastrow-3)*rowlen+instbposx,y
        lda C16help1,y
        sta VRAM+(lastrow-2)*rowlen+instbposx,y
        lda C16help2,y
        sta VRAM+(lastrow-1)*rowlen+instbposx,y
        dey
        bpl -
        lda #$6B
        sta VRAM+(lastrow-3)*rowlen+instbposx-1
.fi

.if (INFOBAR_SUPPORT>0)
disinfo lda firstrun
        bne +
        ldy #authorinfo_len-2
        sty editinf+1
-       lda authorinfo,y
        and #$3F
        ora #$80
        sta VRAM+lastrow*rowlen,y
        dey
        bpl -
        ldy tuneheader.playertype
        lda playertype_letter,y
        sta VRAM+lastrow*rowlen+lastcolumn
        rts
+       ldy #(info_len-1)
        sty editinf+1
-       lda (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)? explayer.playerinfo,y : appname,y 
        ;cmp #$40
        ;bcc +
        and #$3F ;lda authorinfo,y ;or tuneinfo when loaded
+       ora #$80
        sta VRAM+lastrow*rowlen+(rowlen-info_len)/2,y ;VRAM+(oliposy+CHANNELAMOUNT)*rowlen+oliposx+(rowlen-info_len)/2,y
        dey
        bpl -
nofirst lda #0
        sta firstrun
        rts
firstrun .byte 1
 .enc screen
playertype_letter .byte "N","M","L","E","B","D"
 .enc none

delinfo ldy #rowlen-1 ;(info_len)-1 ;rowlen-1 ;(HORIZONTAL_ORDERLIST>0)? oliwidth-1 : rowlen-1
        lda #(HORIZONTAL_ORDERLIST>0)? "-"+$80 : $43
-       sta VRAM+lastrow*rowlen,y ; VRAM+24*rowlen+(rowlen-info_len)/2,y ;VRAM+(oliposy+CHANNELAMOUNT)*rowlen+oliposx,y
        dey
        bpl -
 .if (HORIZONTAL_ORDERLIST==0)
        lda #$71
        sta VRAM+lastrow*rowlen+instbposx-1
        sta VRAM+lastrow*rowlen+pattposx-1
 .fi 
        lda #0
        sta editinf+1

.fi ;end of INFOBAR_SUPPORT
        rts


.enc screen
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
info_len=explayer.playerinfo_end-explayer.playerinfo
.else
 .if (INFOBAR_SUPPORT>0)
info_len=appname_end-appname
appname .text "tedzakker ",Version," by hermit"
appname_end
 .fi
.fi
trkheader .text "PT00-I00-FX "
trkheadercol .text fgcolor,fgcolor,datacolor,datacolor,fgcolor,fgcolor,datacolor,datacolor,fgcolor,fgcolor,fgcolor,fgcolor
mainheader .text (HORIZONTAL_ORDERLIST>0)? "ST0-F0-SP00-O0" : "SUBT0-FS0-SP.0.0-O0"
instbheader .text "00 WF FRQ VO"
.if (MACHINE==0 && maxinstblen<=15 && HORIZONTAL_ORDERLIST==0)
C16help1 .text "F8/HELP:LOAD"
C16help2 .text "C= + F8:SAVE"
.fi
.enc none

.if (COLOR_SUPPORT>0)
trkcolors 
 .if (HORIZONTAL_ORDERLIST==0)
  .byte poscolor,poscolor,olicolor,olicolor,olicolor,olicolor,fgcolor
 .fi
 .for i=0,i<CHANNELAMOUNT,i=i+1
  .byte poscolor,poscolor
  .fill notewidth,notecolor
  .byte playposcolor
  .fill 2,inscolor
  .if (HORIZONTAL_ORDERLIST>0)
   .byte 0
  .fi
  .fill 2,fxcolor
  .fill trkgapx,fgcolor
 .next
instbcolors .byte poscolor,poscolor,(NOTEOFF_TBINDEX_SUPPORT)?0:poscolor,wfcolor,wfcolor
            .byte (NOTEOFF_TBINDEX_SUPPORT)?0:poscolor,frqcolor,frqcolor,frqcolor
            .byte (NOTEOFF_TBINDEX_SUPPORT)?0:poscolor,volcolor,volcolor
.fi



;=============================== MENU ==================================
exitsig .byte 0 ;different return-levels , see 'exitmode_xxx' for values


.if (MENU_SUPPORT>0)

menux=(rowlen-menuwidth)/2
menuy=4
menuwidth=menutxt0_end-menutxt0
menuheight=(menutxt_end-menutxt)/menuwidth
menupoint .byte 0 ;current menupoint
menusize=menuheight-2


menu    lda #exitmode_noexit
        sta exitsig
menustrt;sei
        jsr ROMdisa
        ;jsr stopply
        jsr player.silence
        jsr dispmenu
        ;lda #keymode_menu
        ;sta keyermode ;set already by menu-caller
        jsr waitkeyrelease

menuloop 
        lda #$CD
        cmp vscanpos
        bne *-3
        jsr keyer
        jsr dispMenuPt
        lda keyermode
        cmp #keymode_menu
        beq menumod
        jmp backtoe ;chexits
menumod lda exitsig
        ;cmp #exitmode_noexit
        beq menuloop
        cmp #exitmode_justlaunch ;just back to menu?
        beq menu ;redraw menu after helptext-display
backtoe ;sei
        ;jsr ROMdisa
.if (HERMIDI_SUPPORT>0)
        lda HerMIDIswitch
        beq + ;was HerMIDI turned ON?
        lda #(MACHINE<2)? 16+HerMIDI.AsyncMode : HerMIDI.MaxBuffSize  ;synchronous mode (bit7=0)?, HerMIDI.MaxBuffSize: max. buffersize that's supported by HerMIDI
        jsr HerMIDI.PowerON ;Carry=0 on exit when succeeded (StatusByte can be checked later as well)
.fi
+       jmp chexits


menukeyer
 		cpy #$0F*2 ;Shift?
		bne +
shiftpr	jmp nextkey
+		cpy #$3F*2 ;STOP key?
		beq +
        cpy #(MACHINE<2)? $34*2:$39*2 ;ESC/back-arrow key?
        beq +
		cpy #$03*2 ;HELP(F8)/F7 key?
		bne chCurDn ;chHelp
        jsr repeatex ;prevents going back to editor instantly (was occasionall bug)
+		jmp retuEdi
;chHelp	lda helpmode
;		beq chCurDn
;		jmp HelpKeyHandler
chCurDn	cpy #(MACHINE<2)? $28*2:$07*2 ;cursor-down key?
		bne (MACHINE<2)? chCurUp:chCurRi
        .if (MACHINE>=2)
        lda shiftsig
        bne menucUp
        .fi
menucDn jsr repeatex
	    ldx menupoint
		inx
		cpx #menusize
		bne +
		ldx #0
+		stx menupoint
		rts
chCurUp .if (MACHINE<2)
        cpy #$2B*2 ;cursor-up key?
        bne chCurRi
        .fi
menucUp	jsr repeatex
        dec menupoint
		bpl +
		ldx #menusize-1
		stx menupoint
+		rts
chCurRi	cpy #(MACHINE<2)? $33*2:$02*2 ;cursor-right key?
		beq increas
		cpy #(MACHINE<2)? $36*2:$28*2 ;plus key?
		bne chMinus
increas	.if (MACHINE>=2)
        lda shiftsig
        bne decreas
        .fi
        ldy menupoint
		cpy #(drivePl-menutxt1)/menuwidth
		bne +
		jmp setDrive
+
 .if (PLAYABLE_EXPORT_SUPPORT>0)
 		cpy #(relocPl-menutxt1)/menuwidth
		bne +
		jmp incReloc
+
 .fi
        cpy #(ptlenPl-menutxt1)/menuwidth
        bne retmkey
        jmp incDefPtLen
chMinus	cpy #(MACHINE<2)? $2E*2:$2B*2 ;Minus-key?
        .if (MACHINE<2)
		beq decreas
        cpy #$30*2 ;cursor-left key?
        .fi
        bne chRetur
decreas ldy menupoint
		cpy #(drivePl-menutxt1)/menuwidth
		bne +
		jmp decdevi
+
 .if (PLAYABLE_EXPORT_SUPPORT>0)
 		cpy #(relocPl-menutxt1)/menuwidth
		bne +
		jmp decReloc
+
 .fi
        cpy #(ptlenPl-menutxt1)/menuwidth 
        bne retmkey
        jmp decDefPtLen
chRetur	cpy #$01*2 ;Return-key?
		bne chNumbr
goMenuP	lda menupoint
goMenP2 asl
		tax
		lda menuPtAddr,x
		sta menuJmp+1
		lda menuPtAddr+1,x
		sta menuJmp+2
menuJmp	jmp selfmodA ;self-written - jumping to menupoint
chNumbr	tya
		ldx #menusize+1 ;$0F-1 ;menusize-1
-		cmp menuPtKey,x
		bne ++
        cpx #menusize+1 ;$0F-1
        bcc +
        txa
        jmp goMenP2
+		stx menupoint
		jsr dispMenuPt
		jmp goMenuP
+		dex
		bpl -
retmkey	rts


setDrive jsr repeatex
		ldy devicen+1
		cpy #15	;max. device number
		iny
		blt setdevi
		ldy #8	;min. device-number
setdevi	sty devicen+1
dispdev lda devicen+1
		jsr decdisp
		sty drivetxt		;display device-number digit1 in menu
		sta drivetxt+1	;display device-number digit2 in menu
		rts
decdevi	jsr repeatex
		ldy devicen+1
		dey
		cpy #8-1
		bne +
		ldy #15
+		jmp setdevi


 .if (PLAYABLE_EXPORT_SUPPORT>0 && RELOCATION_SUPPORT>0)
setReloc
incReloc lda repecnt		;keyrepeat-counter  --- trick to make it faster
		bne +			;check, if repeat counter is 0
		lda #1 ;alternative (faster) repeat-speed for relocation-setting
		sta repecnt		;if 0, reset counter to alternative repeatspeed
		rts 
+		jsr repeatex
		lda #>playersize ;lda #>tunedata_end ;end of area to be exported - hi-byte
		;sec 			;injected by tlr at CSDB
		;sbc #>PLAYERADDR;injected by tlr at CSDB - this checks if the tune fits into the remaining range below top of memory (RELOC_MAX_HI)
		clc
		;adc #1			;add 1 for safety to be in range
		adc relocaddr
		bcs wraprlU ;direloc		;if range passes over top of memory, don't allow further change
		cmp #reloc_hi_max ;max relocation-address - checked tunelength some rows above
		bne + ;beq direloc
wraprlU lda #reloc_hi_min ;min. reloc. address
        sta relocaddr
        jmp dispReloc
+	    inc relocaddr
        jmp dispReloc
decReloc lda repecnt		;keyrepeat-counter  --- trick to make it faster
		bne +			;check, if repeat counter is 0
		lda #1 ;alternative repeat-speed for relocation-setting
		sta repecnt		;if 0, reset counter to alternative repeatspeed
		rts 
+	 	jsr repeatex 
		lda relocaddr
		cmp #reloc_hi_min		;min. reloc. address
		bne + ;beq direloc
wraprlD lda #reloc_hi_max ;max reloc.addr.
        sec
        sbc #>playersize
        sta relocaddr
        jmp dispReloc
+   	dec relocaddr
		jmp dispReloc


dispReloc
		lda relocaddr
        jsr hexdisp
        stx reloctxt+0
		sta reloctxt+1
		rts
 .fi ;end of PLAYABLE_EXPORT_SUPPORT && RELOCATION_SUPPORT

incDefPtLen
        jsr repeatex
        lda tuneheader.defaultptlen
        cmp #maxptnlen
        bcc + ;bcs +
        lda #1-1
        sta tuneheader.defaultptlen
+       inc tuneheader.defaultptlen
        jsr dispdefplen
        rts
decDefPtLen
        jsr repeatex
        lda tuneheader.defaultptlen
        cmp #2
        bcs + ;bcc +
        lda #maxptnlen+1
        sta tuneheader.defaultptlen
+       dec tuneheader.defaultptlen
        jsr dispdefplen
        rts

dispdefplen
        lda tuneheader.defaultptlen
        jsr hexdisp
        stx ptlentxt+0
        sta ptlentxt+1
        rts

 .if (HERMIDI_SUPPORT>0)
.enc screen
setMIDI jsr repeatex
        lda HerMIDIswitch
        eor #$FF
        sta HerMIDIswitch
        ldx #"-"
        ldy #"-"
        lda HerMIDIswitch
        beq +
        ldx #"O"
        ldy #"N"
+       stx midictxt+0
        sty midictxt+1
        rts
.enc none
 .fi


;--------------------------------------------
dispmenu lda #menubgcol
        sta bgcol
        sta bordcol
        jsr hidecursor
        lda #menuhelpcol
        jsr clearscrn
        lda #$1b+$40 ;extended-colour mode
        sta vmodeyscroll
        lda #menubarcol
        sta ECMinvcol
        jsr capitch
        jsr dispMenuPt
 .if (HELPTEXT_SUPPORT>0)
        ldy #rowlen-1
-       lda MenuHelpTxt,y
        sta VRAM+0*rowlen,y
        lda MenuHelpTxt+rowlen*3,y
        sta VRAM+1*rowlen,y
        lda MenuHelpTxt+rowlen,y
        sta VRAM+21*rowlen,y
        lda MenuHelpTxt+rowlen*2,y
        sta VRAM+22*rowlen,y
        lda CreditTxt,y
        sta VRAM+lastrow*rowlen,y
        dey
        bpl -
diplinf lda #PLAYERTYPE
        asl
        asl
        asl
        tax
        ldy #0
-       lda pltypetxt,y
        sta VRAM+(menuy-1)*rowlen+1,y
        lda playername,x
        sta VRAM+menuy*rowlen+2,y
        lda pltimetxt,y
        sta VRAM+(menuy-1)*rowlen+rowlen-9,y
        lda plsizetxt,y
        sta VRAM+menuy*rowlen+rowlen-9,y
        inx
        iny
        cpy #8
        bne -
        lda #>playersize
        jsr hexdisp
        sta VRAM+menuy*rowlen+rowlen-3
        lda #<playersize
        jsr hexdisp
        stx VRAM+menuy*rowlen+rowlen-2
        sta VRAM+menuy*rowlen+rowlen-1
        lda #rastertime
        jsr hexdisp
        stx VRAM+(menuy-1)*rowlen+rowlen-2
        sta VRAM+(menuy-1)*rowlen+rowlen-1
disfeat lda #<(VRAM+(menuy+2)*rowlen)
        ldx #>(VRAM+(menuy+2)*rowlen)
        sta diszp+0
        stx diszp+1
        ldx #0
        stx rowzp        
        stx featpos+1
-       ldy rowzp
        lda featinstances,y
featpos ldy #selfmod
        sta (diszp),y
        ldy #0
-       iny
        lda featuretxt,x
        and #$3F
        sta (diszp),y
        inx
        cpy #8
        bne -
        jsr nextrow
        inc rowzp
        ldy rowzp
        cpy #(featuretxt_end-featuretxt)/8/2
        bne +
        lda #<(VRAM+(menuy+2)*rowlen+rowlen-10)
        sta diszp+0
        lda #>(VRAM+(menuy+2)*rowlen+rowlen-10)
        sta diszp+1   
        lda #9
        sta featpos+1
+       cpy #(featuretxt_end-featuretxt)/8
        bne --     
 .fi
        
        jsr dispdev
 .if (PLAYABLE_EXPORT_SUPPORT>0)
		jsr dispReloc
 .fi
        jmp dispdefplen

dispMenuPt 
        ldx menupoint
        inx
        inx
        stx menupt2+1
        lda #<menutxt0
        ldx #>menutxt0
        sta datzp+0
        stx datzp+1
        lda #<(VRAM+menuy*rowlen+menux)
        ldx #>(VRAM+menuy*rowlen+menux)
        sta diszp+0
        stx diszp+1
        lda #<(CRAM+menuy*rowlen+menux)
        ldx #>(CRAM+menuy*rowlen+menux)
        sta colorzp+0
        stx colorzp+1
        ldx #0 ;menuheight
-       ldy #menuwidth-1
-       lda (datzp),y
menupt2 cpx #selfmod ;menupoint
        bne +
        ora #$80
+       sta (diszp),y
        lda #menufgcol
        cpx menupt2+1
        bne +
        lda #menuactivecol
+       sta (colorzp),y
        dey
        bpl -
        jsr nextrow
        lda #menuwidth
        jsr datzadd
        inx
        cpx #menuheight
        bne --
        rts


;---------------------------- menu data --------------------------------
.enc screen
menutxt
menutxt0 .text "TEDZAKKER 1.0 MENU"
menutxt0_end
menutx0b .text "------------------"
menutxt1 .text "1. LOAD WORKFILE  " ;"1. LOAD WORKF",(PLAYABLE_IMPORT_SUPPORT>0)? "/TUNE":"ILE  "
menutxt2 .text "2. SAVE WORKFILE  "
 .if (INSTRUMENT_LOADSAVE_SUPPORT>0)
menutxt3 .text "3. LOAD INSTRUMENT"
menutxt4 .text "4. SAVE INSTRUMENT"
 .fi
 .if (PLAYABLE_EXPORT_SUPPORT>0)
relocPl  .text "5. EXPORT TO $"
reloctxt .text               "0000"
 .fi
 .if (RUNNABLE_EXPORT_SUPPORT>0)
menutxt6 .text "6. EXPORT RUNNABLE"
 .fi
drivePl  .text "7. DISK DRIVE: "
drivetxt .text                "00 "
menutxt8 .text "8. CLEAR PAT.&SEQ."
menutxt9 .text "9. CLEAR INSTRUM. "
ptlenPl  .text "A. SET PAT.LEN:$"
ptlentxt .text                 "00"
 .if (HERMIDI_SUPPORT>0)
miditxt  .text "B. HERMIDI-ACT.:"
midictxt .text                 "--"
 .fi
 .if (EXAMPLE_TUNE_SUPPORT>0)
menutxtB .text "C. EXAMPLE TUNE   "
 .fi
 .if (HELPTEXT_SUPPORT>0)
menutxtC .text "D. HELP/CHEATSHEET"
 .fi
menutxtD .text "E. EDITOR (F8/ESC)"
menutxt_end


playersize=explayer.player_bottom-explayer.player_top

 .if (HELPTEXT_SUPPORT>0)

MenuHelpTxt
.text "TOGGLE MENU WITH HELP(F8)/F7 KEY ANYTIME"
.text "CURSOR-UP/DOWN OR 1..D, THEN RETURN KEY,"
.text "PUSH +/- OR CURSOR-L/R TO ADJUST VALUES."
.text "IN THE EDITOR HOLD DOWN C=+H TO SEE HELP"
CreditTxt
.text "      2015 HERMIT SOFTWARE HUNGARY      "
.enc none

.enc screen
playername .text "NORMAL  ","MEDIUM  ","LIGHT   ","EXTRA   ","BARE    ","DEMO    "

featuretxt .text "MultiSpd","NoFrSkip","FS.VolFX","Pack.NOP","Subtunes","Subt.Jmp"
           .text "Ordrl.FX","Transpos","TempoPrg","Main-Vol"
           .text (MAIN_VOLUME_FADEOUT_SUPPORT==0)? "Ext.mVol" : "Ex.VFade"
           .text "Note-FX ","LowNotes","fBalance"
           .text "Portamen","Vibratos","Inc.Vibr","ViRestor","SmartVFX","Detuning"
           .text "Fr1Click","Fr1C.Vol","Tbl.Wait","NoteOFFi","Synching"," Phasing","Envelope","MixModes"
featuretxt_end
pltypetxt .text "PLAYER: "
plsizetxt .text "SIZE:$  "
pltimetxt .text "RTIME:$ "
.enc none

rastertime = PLAYERTYPE==0?$1E: PLAYERTYPE==1?$1C: PLAYERTYPE==2?$18: PLAYERTYPE==3?$24: PLAYERTYPE==4?$11: PLAYERTYPE==5?$17: 0


featinstances .byte MULTISPEED_ENTRY_SUPPORT ? "*" : " " ;$7A
              .byte FRAME_NOSKIP_SUPPORT ? "*" : " "   
              .byte FRAMESKIP_NOTEVOL_SUPPORT ? "*" : " "
              .byte PACKED_NOP_SUPPORT ? "*" : " "
              .byte SUBTUNE_SUPPORT ? "*" : " "
              .byte SUBTUNE_JUMP_SUPPORT ? "*" : " "
              .byte SEQ_FX_SUPPORT ? "*" : " "
              .byte TRANSPOSE_SUPPORT ? "*" : " "
              .byte TEMPOPROGRAM_SUPPORT ? "*" : " "
              .byte MAIN_VOLUME_SUPPORT ? "*" : " "
              .byte (EXT_MAIN_VOLUME_SUPPORT || MAIN_VOLUME_FADEOUT_SUPPORT) ? "*" : " "
              .byte NOTE_FX_SUPPORT ? "*" : " "
              .byte LOWFREQ_NOISELOOP_SUPPORT ? "*" : " "
              .byte BALANCED_SLIDE_SUPPORT ? "*" : " "

              .byte PORTAMENTO_SUPPORT ? "*" : " "
              .byte VIBRATO_SUPPORT ? "*" : " "
              .byte INCREMENTAL_VIBRATO_SUPPORT ? "*" : " "
              .byte VIBRATO_RESTORE_SUPPORT ? "*" : " "
              .byte GENTLE_VIBRATO_FX_SUPPORT ? "*" : " "
              .byte DETUNE_SUPPORT ? "*" : " "
              .byte SOUNDSTART_CLICK_SUPPORT ? "*" : " "    
              .byte STARTCLICK_VOL_SUPPORT ? "*" : " "
              .byte TABLE_DELAY_SUPPORT  ? "*" : " "
              .byte NOTEOFF_TBINDEX_SUPPORT ? "*" : " "
              .byte SYNC_SUPPORT ? "*" : " "
              .byte PHASE_SUPPORT ? "*" : " "
              .byte NOTEVOLUME_FADE_SUPPORT ? "*" : " "
              .byte MIXING_MODES_SUPPORT ? "*" : " "
 .fi ;end of HELPTXT_SUPPORT


menuPtKey .byte $38*2,$3B*2       ;keycodes 1..9 and A..F for menupoints
          .if (INSTRUMENT_LOADSAVE_SUPPORT>0)
            .byte $08*2,$0B*2
          .fi
          .if (PLAYABLE_EXPORT_SUPPORT>0)
            .byte $10*2
          .fi
          .if (RUNNABLE_EXPORT_SUPPORT>0)
            .byte $13*2
          .fi
          .byte $18*2,$1B*2,$20*2, $0A*2
          .if (HERMIDI_SUPPORT>0)
           .byte $1C*2  
          .fi
          .if (EXAMPLE_TUNE_SUPPORT>0)          
           .byte $14*2
          .fi
          .if (HELPTEXT_SUPPORT>0)
           .byte $12*2
          .fi
          .byte $0E*2,$42*2,$29*2

menuPtAddr .word loadDialog,saveDialog
           .if (INSTRUMENT_LOADSAVE_SUPPORT>0)
            .word loadInsDialog,saveInsDialog
           .fi
           .if (PLAYABLE_EXPORT_SUPPORT>0)
            .word exportPlayableDialog
           .fi
           .if (RUNNABLE_EXPORT_SUPPORT>0)
            .word exportRunnableDialog
           .fi
           .word setDrive,clearTune,clearIns,setPattLen
           .if (HERMIDI_SUPPORT>0)
           .word setMIDI
           .fi
           .if (EXAMPLE_TUNE_SUPPORT>0)
            .word exampleTune
           .fi
           .if (HELPTEXT_SUPPORT>0)
            .word showHelp
           .fi 
           .word retuEdi

.else
menu    lda #exitmode_noexit
        sta exitsig
menustrt;sei
        jsr ROMdisa
        ;jsr stopply
        jsr player.silence
        ;lda #keymode_menu
        ;sta keyermode ;set already by menu-caller
        ;jsr waitkeyrelease

        jsr filmode
        jmp chexits

filmode lda #selfmod
        bne +
        jmp LoadDialog    ;0
+       cmp #2
        bcs +
        jmp SaveDialog    ;1
+
 .if (INSTRUMENT_LOADSAVE_SUPPORT>0)
        bne +
        jmp SaveDialog    ;2
+       jmp SaveInsDialog ;3
 .fi
.fi ;end of MENU_SUPPORT




;-------------------------------menupoints------------------------------
.if (FILEDIALOG_SUPPORT>0)
setTZWe	clc
        bit dpywmk0
        ldx #extlen-1	;set TEDzakker-Workfile extension
-       lda TZWext,x
		sta filedialog.tzftype+1,x
		dex
		bpl -
        rts

setTZIe ldx #extlen-1	;set TEDzakker-Instrument extension
-       lda TZIext,x
		sta filedialog.tzftype+1,x
		dex
		bpl - 
        rts
.fi


loadDialog 
        .if (FILEDIALOG_SUPPORT>0)
        jsr setTZWe
        lda #2
		sta filedialog.defawin+1	;file-selector is preferred default subwindow in loader-filer (but changeable with TAB)
		lda #0
		sta filedialog.editauth
        .fi
        jsr (FILEDIALOG_SUPPORT>0)? filedialog.reredir: filedialog.fdialog ;reading directory automatically for loader
        bcc +
        jmp returnM
+       jmp loadWorkfile ;goBackE


saveDialog 
        .if (INFOBAR_SUPPORT>0)
        jsr nofirst
        .fi
        .if (FILEDIALOG_SUPPORT>0)
        jsr setTZWe
        lda #1
		sta filedialog.editauth	;switch on author-editing for saver
        lda #0
		sta filedialog.defawin+1	;filename-input is preferred default subwindow in saver-filer (but changeable with TAB)
        .fi
        jsr filedialog.fdialog ;reredir ;directory loads only when F1 is pressed
        bcs returnM
        jmp saveWorkfile


.if (INSTRUMENT_LOADSAVE_SUPPORT>0)
loadInsDialog
        .if (FILEDIALOG_SUPPORT>0)
        jsr setTZIe
        lda #2
		sta filedialog.defawin+1	;file-selector is preferred default subwindow in loader-filer (but changeable with TAB)
		lda #0
		sta filedialog.editauth
        .fi
        jsr filedialog.reredir ;reading directory automatically for loader
        bcs returnM
        jmp loadIns

saveInsDialog
        .if (FILEDIALOG_SUPPORT>0)
        jsr setTZIe
		lda #0
		sta filedialog.editauth	
        lda #0
		sta filedialog.defawin+1	;filename-input is preferred default subwindow in saver-filer (but changeable with TAB)
        .fi
        jsr filedialog.fdialog ;reredir ;directory loads only when F1 is pressed
        bcs returnM
        jmp saveIns
.fi


.if (PLAYABLE_EXPORT_SUPPORT>0)
exportPlayableDialog
        .if (FILEDIALOG_SUPPORT>0)
		ldx #extlen-1
-       lda PRGext,x   ;playable PRG format
		sta filedialog.tzftype+1,x
		dex
		bpl -
        lda #1
		sta filedialog.editauth	;switch on author-editing for saver
        lda #0
		sta filedialog.defawin+1	;filename-input is preferred default subwindow in saver-filer (but changeable with TAB)
        .fi
        jsr filedialog.fdialog ;reredir ;directory loads only when F1 is pressed
        bcs returnM
        jmp savePlayable
.fi


.if (RUNNABLE_EXPORT_SUPPORT>0)
exportRunnableDialog
        .if (FILEDIALOG_SUPPORT>0)
		ldx #extlen-1
-       lda RUNext,x   ;runnable format
		sta filedialog.tzftype+1,x
		dex
		bpl -
        lda #1
		sta filedialog.editauth	;switch on author-editing for saver
        lda #0
		sta filedialog.defawin+1	;filename-input is preferred default subwindow in saver-filer (but changeable with TAB)
        .fi
        jsr filedialog.fdialog ;reredir ;directory loads only when F1 is pressed
        bcs returnM
        jmp saveRunnable
.fi


returnM	jmp retMenu


.if TUNEINIT_SUPPORT
clearTune
		jsr RyouSur
		bcc returnM
        lda #0
        sta tuneheader.subtune_amount
        sta tuneheader.ptn_amount
        jsr depksub
        jsr depkptn
        ldy #authorinfo_len-1
-       lda #" "
        sta authorinfo,y
        dey
        bpl -
        ldy #1
        sty currptn+0
        sty player.currpatt+0
        iny ;2 
        sty currptn+1
        sty player.currpatt+1
        jmp restTun


clearIns
		jsr RyouSur
		bcc returnM
        lda #0
        sta tuneheader.ins_amount
        jsr depkins
        jmp restIns       


setPattLen
		jsr RyouSur
		bcc returnM
        ldy #maxptnamount
-       lda tuneheader.defaultptlen
        sta ptnlen,y
        dey
        bpl -
reseptn ldx #CHANNELAMOUNT-1
-       lda ptnindex,x
        cmp tuneheader.defaultptlen
        bcc +
        lda #0
        sta ptnindex,x
        sta curwinposy+ptnwin
+       dex
        bpl -
        jmp restTun
.fi


.if (HELPTEXT_SUPPORT>0)
ShowHelp
        php ;store I-flag
        ;sei
        jsr ROMdisa
        jsr hidecursor
        jsr player.silence
        lda #$1b ;not extended-colour mode
        sta vmodeyscroll
        lda #helpbgcol
        sta bgcol
        sta bordcol
        jsr smallch
 .if(MACHINE==2)
        lda #$34
        sta banksel ;grab helptext from under I/O area
 .fi
        ldy #0
-       lda helptxt,y
		;cmp #$60		;input: Accu, output: Accu
		;bcc +			;handle lowercase
		;and #$1f
+       sta VRAM,y
        lda helptxt+$100,y
        sta VRAM+$100,y
        lda helptxt+$200,y
        sta VRAM+$200,y
        lda helptxt+$300,y
        sta VRAM+$300,y
        iny
        bne -
 .if(MACHINE==2)
        lda #$35
        sta banksel
 .fi
        lda #helpfgcol
        ldy #0
-       sta CRAM,y
        sta CRAM+$100,y
        sta CRAM+$200,y
        sta CRAM+$300,y
        iny
        bne -
        jsr waitkeyrelease 
        lda keyermode
        cmp #keymode_menu
        bne +
        jsr waitkeypress
+       plp ;restore I-flag
        jmp returnM
.fi ;end of HELPTEXT_SUPPORT


.if (EXAMPLE_TUNE_SUPPORT>0)
exampleTune
		jsr RyouSur
        bcs +
		jmp returnM
+       lda #<demotune
        ldx #>demotune
        sta demotpt+1
        stx demotpt+2
        lda #<tuneheader
        ldx #>tuneheader
        sta targtpt+1
        stx targtpt+2
 .if (MACHINE==2)
        lda #$34
        sta banksel ;get demotune from under I/O area
 .fi
demotpt lda selfmodA
targtpt sta selfmodA
        inc targtpt+1
        bne +
        inc targtpt+2
+       inc demotpt+1
        bne +
        inc demotpt+2
+       lda demotpt+1
        cmp #<demotune_end
        bne demotpt
+       lda demotpt+2
        cmp #>demotune_end
        bne demotpt
 .if (MACHINE==2)
        lda #$35
        sta banksel
 .fi
        lda targtpt+1
        sta tuneendptr+0
        lda targtpt+2
        sta tuneendptr+1
        jsr depackworkfile
        jsr nofirst
        jmp restEdi
.fi




;========================== TUNE PACKER ================================

packmode_workfile=0
packmode_release=1
packworkfile
        lda #packmode_workfile
packtune    ;in-place compression of tune-data, input: A=0:workfile target, A>0:playable/runnable target (no ins.names stored)
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
        sta packmod+1
.fi
        lda #<packed_data_start
        ldx #>packed_data_start
        sta compzp+0
        stx compzp+1
.if (SUBTUNE_SUPPORT==0)
        sta orderlistadd+0
        stx orderlistadd+1
.fi
        ;lda #<pointertemp
        ;ldx #>pointertemp
        ;sta ptrzp+0
        ;stx ptrzp+1

        jsr psubtun
        jsr pinstru
        jsr ppatter
        jsr regptr

.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
packmod ldy #selfmod
        ;cpy #packmode_workfile
        bne setendp
.fi
        ldy #authorinfo_len-1
-       lda authorinfo,y
        sta (compzp),y ;author-info to the end of packed workfile
        dey
        bpl -
        lda #authorinfo_len
        jsr compadd

setendp lda compzp+0
        sta tuneendptr+0
        lda compzp+1
        sta tuneendptr+1

.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
        lda packmod+1
        ;cmp #packmode_workfile
        beq +
        jmp setplayer ;jsr setplayer
.fi
+       lda #PLAYERTYPE ;`PLAYERTYPE ;convert char to int
        sta tuneheader.playertype

retpack rts


;----------------------- pack orderlists (sequences)
psubtun lda #$ff
        sta tuneheader.subtune_amount
        ldx #0 ;pack subtune-orderlists (sequences)
        stx used_ptn_amount
stdetlp lda seqptrlo,x
        sta datzp+0
        lda seqptrhi,x
        sta datzp+1
        jsr resetvs
        ldy #maxseqlen-1
-       lda (datzp),y
        bit validsig
        bmi +
        cmp #0
        beq ++
        stx tuneheader.subtune_amount ;register subtune 
        jsr regvali
.if (SUBTUNE_SUPPORT==0 && (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0) )
        cpx #0
        bne +
        sty ystore2+1
        iny
        iny
        sty explayer.seq0_len
ystore2 ldy #selfmod
.fi
+       jsr regusedptn
        sta (compzp),y 
+       dey
        bpl -
        cpx tuneheader.subtune_amount
        bne emps1pt
        lda compzp+0
        sta seqpl1tmp,x
        lda compzp+1
        sta seqph1tmp,x
        jsr compad0
        jmp +
emps1pt lda #0
        sta seqpl1tmp,x
        sta seqph1tmp,x
+       lda seqptrlo+maxsubtuneamount,x
        sta datzp+0
        lda seqptrhi+maxsubtuneamount,x
        sta datzp+1
        ldy #maxseqlen-1
-       lda (datzp),y
        bit validsig
        bmi +
        cmp #0
        beq ++
        stx tuneheader.subtune_amount
        jsr regvali
+       jsr regusedptn
        sta (compzp),y 
+       dey
        bpl -
        cpx tuneheader.subtune_amount
        bne emps2pt
        lda compzp+0
        sta seqpl2tmp,x
        lda compzp+1
        sta seqph2tmp,x
        jsr compad0
        jmp +
emps2pt lda #0
        sta seqpl2tmp,x
        sta seqph2tmp,x
+       inx
        cpx #maxsubtuneamount
        beq +
        jmp stdetlp
+       inc tuneheader.subtune_amount
        rts

regusedptn 
        cmp #1
        bcc retrupt
        cmp #maxptnamount+1 ;-1
        bcs retrupt
        cmp used_ptn_amount
        bcc retrupt
        pha
        dey
        lda (datzp),y ;check if $FF preceedes the number, then don't treat it as pattern-number
        iny
        cmp #jumpval
        beq +
        pla
        sta used_ptn_amount
        rts
+       pla
retrupt rts
used_ptn_amount .byte 0 ;pattern-amount based on last pattern used in orderlists


;------------------------------------- pack instruments
ins_maxsize=insheadersize+(maxinstblen+1)*3
pinstru lda #0
        sta tuneheader.ins_amount
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
        lda #<(insnametemp-insnamepos)
        ldx #>(insnametemp-insnamepos)
        sta inametmptr+0
        stx inametmptr+1
.fi
        ldx #1
ispcklp jsr pck1ins
        inx
        cpx #maxinstamount+1
        bne ispcklp
retipck rts

pack1inst
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
        lda #packmode_workfile
        sta packmod+1
.fi
;pack one instrument, its number is given in X, target in 'compzp', set packmode!
pck1ins lda insptlo,x
        sta datzp+0
        lda inspthi,x
        sta datzp+1
        ldy #wftbnoteoffindexpos
        lda (datzp),y
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
		beq +
        ldy packmod+1
        ;cmp #packmode_workfile
        beq +
		sec
		sbc	#insheadersize-insmaindatalen
+	    ldy #wftbnoteoffindexpos	
.fi
		sta (compzp),y
		ldy #freqtbnoteoffindexpos
		lda (datzp),y
		sta frgoffs+1
		ldy #voltbnoteoffindexpos
		lda (datzp),y
		sta vogoffs+1
		ldy #instcontrolswitchpos
		lda (datzp),y
		sta (compzp),y
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
        ldy packmod+1
        ;cpy #packmode_workfile
        beq cpiname
buiname ldy #insnamepos ;make backups of instrument-names to temp.area
-       lda (datzp),y
inmtemp sta (inametmptr),y
        iny
        cpy #insnamepos+insnamelen
        bne -
incinpt lda #insnamelen ;increment instrument-name temp. pointer
        clc
        adc inametmptr+0
        sta inametmptr+0
        bcc +
        inc inametmptr+1
+       lda #insnamepos ;insmaindatalen ;default is omitting (skipping) instr.name from target        
        jsr adtempz
        jmp packitb
.fi
cpiname ldy #insnamepos
-       lda (datzp),y
        sta (compzp),y
        iny
        cpy #insnamepos+insnamelen
        bne -
        lda #insheadersize ;correct tempzp: setting it AFTER ins.name
        jsr adtempz

packitb lda #wftbstartindex
        jsr cpinstb

        lda tempzp+0
		sec
		sbc compzp+0
        ldy #freqtbstartindexpos
        sta (compzp),y
frgoffs	lda #selfmod
		beq +
		sec
		sbc #insheadersize+(maxinstblen+1)*1
		clc
		adc (compzp),y
+		ldy #freqtbnoteoffindexpos
		sta (compzp),y
packftb lda #maxinstblen+1
        jsr cpinstb
        
        lda tempzp+0
		sec
		sbc compzp+0
        ldy #voltbstartindexpos
        sta (compzp),y
vogoffs	lda #selfmod
		beq +
		sec
		sbc #insheadersize+(maxinstblen+1)*2
		clc
		adc (compzp),y
+	    ldy #voltbnoteoffindexpos
		sta (compzp),y
packvtb lda #maxinstblen+1
        jsr cpinstb
        
        cpx tuneheader.ins_amount
        bne emptipt
        lda compzp+0
        sta inspltmp+1,x
        lda compzp+1
        sta insphtmp+1,x
        lda inssize
        jsr compadd
        jmp +
emptipt lda #0 ;if empty instrument inbetween used instruments, its pointer is 0
        sta inspltmp+1,x
        sta insphtmp+1,x        
+       rts

;pack one instrument-table, input: Accu=table-baseindex relative to instrument
cpinstb jsr datzadd
        jsr resetvs
        ldy #$ff
        sty compad1+1
        ldy #maxinstblen-1
- 		dey
		lda (datzp),y
		cmp #jumpval
		bne +
		lda tempzp+0
		sec
		sbc compzp+0
		.byte $2c ;skip
+		lda #0
		iny
		clc
		adc (datzp),y
        bit validsig
        bmi +
        cmp #0
        beq ++
        stx tuneheader.ins_amount
        jsr regvali
+       sta (tempzp),y
+       dey
		bpl -
clositb cpx tuneheader.ins_amount
        bne retcpit
        lda #0
        ldy compad1+1 ;length
        iny
+       sta (tempzp),y
        iny
        tya
        pha 
        clc
        adc tempzp+0
        sta tempzp+0
        bcc +
        inc tempzp+1
+       pla
        clc
        adc inssize
        sta inssize
        lda #0
        sta validsig
retcpit rts


;---------------------------- pack patterns
ppatter lda #0
        sta tuneheader.ptn_amount      
        ldx #maxptnamount ;-1 ;no pattern 0 used
ptdetlp lda pattptlo,x ;loop to copy & compress used patterns
        sta datzp+0
        lda pattpthi,x
        sta datzp+1
        ldy ptnlen,x ;#maxptnlen-1 ;loop to detect last used pattern
        dey
-       lda (datzp),y
        bne +
        dey
        bpl -
        lda #maxptnlen+1
        jsr datzadd ;copy & compress pattern
        ldy ptnlen,x ;#maxptnlen-1 ;loop to detect last used pattern
        dey
-       lda (datzp),y
        bne +
        dey
        bpl -
        lda #maxptnlen+1
        jsr datzadd ;copy & compress pattern
        ldy ptnlen,x ;#maxptnlen-1 ;loop to detect last used pattern
        dey
-       lda (datzp),y
        bne +
        dey
        bpl -
        dex
        bne ptdetlp ;no pattern 0
+       stx tuneheader.ptn_amount

        lda used_ptn_amount
        cmp tuneheader.ptn_amount
        bcc +
        sta tuneheader.ptn_amount

+       lda tuneheader.ptn_amount
        beq retpptn

        ldx #1 ;no pattern 0 used
ptcmplp lda pattptlo,x ;loop to copy & compress used patterns
        sta datzp+0
        lda pattpthi,x
        sta datzp+1
        lda compzp+0
        sta ptnpltmp+1,x
        lda compzp+1
        sta ptnphtmp+1,x
        lda #0
        sta inscolu
        jsr cppatt2
        clc
        adc #1 ;accounting endvalue $FF
        sta ptniitmp+1,x
        lda #ptnendval
        sta (compzp),y
        iny
        jsr compad2
        lda #$FF
        sta inscolu ;tell depacker it's instr.column
        lda #maxptnlen+1
        jsr cppattn
        clc
        adc #1 ;accounting endvalues ($FF) at table-ends
        adc ptniitmp+1,x
        sta ptniftmp+1,x
        lda #ptnendval
        sta (compzp),y
        iny
        jsr compad2
        lda #0
        sta inscolu
        lda #maxptnlen+1
        jsr cppattn
        lda #ptnendval
        sta (compzp),y
        iny
        jsr compad2
        cpx tuneheader.ptn_amount ;#maxptnamount
        beq retpptn
        inx
        bne ptcmplp
retpptn rts

.if (PACKED_NOP_SUPPORT!=0)
cppattn jsr datzadd ;copy & compress pattern
cppatt2 ;jsr resetvs
        ldy ptnlen,x
        sty plenst2+1
        dey
        sty plenst3+1
        stx xstore7+1
        lda compzp+0
        sta packtgt+1
        lda compzp+1
        sta packtgt+2
        ldy #0
        ldx #0
        stx packcnt
-       lda (datzp),y
        bne nonNOP
itisNOP inc packcnt
plenst3 cpy #selfmod
        bcs +
        lda packcnt
        cmp #(ptnendval-packNOP_min)+1
        bcs +
        iny
        jmp -
+       jsr putPNOP
        jmp advasrc
nonNOP  cmp #packNOP_min ;accidental $FF-endsignal or packed NOPs written by user should be substituted with zero 
        bcs itisNOP ;no need to set Accumulator=0
        lda packcnt
        beq writetg
        jsr putPNOP
writetg lda (datzp),y
        jsr checkinvalidinst
        jsr packtgt
advasrc iny
plenst2 cpy #selfmod
        bcc -
        txa ;exiting with compressed length in Accumulator and Y
        tay
xstore7 ldx #selfmod
        rts

putPNOP lda packcnt
        cmp #1
        bne +
        lda #0
        jmp packtgt
+       clc
        adc #packNOP_min-2
packtgt sta selfmodA,x
        inx
        lda #0
        sta packcnt
        rts
.else
cppattn jsr datzadd ;copy & compress pattern
cppatt2 ldy ptnlen,x
-       lda (datzp),y
        cmp #packNOP_min ;accidental $FF-endsignal or packed NOPs written by user should be substituted with zero 
        bcc +
        lda #0 ;for non-valid FX ($FF or packed-NOP value)
+       jsr checkinvalidinst
        sta (compzp),y
        dey
        bpl -
        lda ptnlen,x
        tay
        rts
.fi

checkinvalidinst 
        bit inscolu
        bpl +
        cmp #$3F ;not instrument-selection?
        bcs +
        cmp tuneheader.ins_amount ;selecting valid instrument?
        bcc +
        beq +
        lda #0 ;if non-valid instrument, substitute it with 0 (NOP) in export
+       rts

packcnt .byte 0	
inscolu .byte 0


;--------------------------- copy and register pointer-tables
regptr  
.if (SUBTUNE_SUPPORT!=0)
        jsr ldcompzp
        sta seqptloadd+0
        stx seqptloadd+1
.fi
        ldy #0  
-       lda seqpl1tmp,y
        sta (compzp),y
        iny
        cpy tuneheader.subtune_amount 
        bne -
        jsr compad2

        ldy #0  
-       lda seqpl2tmp,y
        sta (compzp),y
        iny
        cpy tuneheader.subtune_amount 
        bne -
        jsr compad2

.if (SUBTUNE_SUPPORT!=0)
        jsr ldcompzp
        sta seqpthiadd+0
        stx seqpthiadd+1
.fi
        ldy #0  
-       lda seqph1tmp,y
        sta (compzp),y
        iny
        cpy tuneheader.subtune_amount 
        bne -
        jsr compad2

        ldy #0  
-       lda seqph2tmp,y
        sta (compzp),y
        iny
        cpy tuneheader.subtune_amount 
        bne -
        jsr compad2

        jsr ldcompzp
        sta insptloadd+0
        stx insptloadd+1
        ldy tuneheader.ins_amount 
-       lda inspltmp+1,y
        sta (compzp),y
        dey
        bpl -
        ldy tuneheader.ins_amount 
        jsr compad3

        jsr ldcompzp
        sta inspthiadd+0
        stx inspthiadd+1
        ldy tuneheader.ins_amount 
-       lda insphtmp+1,y
        sta (compzp),y
        dey
        bpl -
        ldy tuneheader.ins_amount 
        jsr compad3

        jsr ldcompzp
        sta ptnptloadd+0
        stx ptnptloadd+1
        ldy tuneheader.ptn_amount 
-       lda ptnpltmp+1,y
        sta (compzp),y
        dey
        bpl -
        ldy tuneheader.ptn_amount 
        jsr compad3

        jsr ldcompzp
        sta ptnpthiadd+0
        stx ptnpthiadd+1
        ldy tuneheader.ptn_amount 
-       lda ptnphtmp+1,y
        sta (compzp),y
        dey
        bpl -
        ldy tuneheader.ptn_amount 
        jsr compad3

        jsr ldcompzp
        sta ptninsindexadd+0
        stx ptninsindexadd+1
        ldy tuneheader.ptn_amount 
-       lda ptniitmp+1,y
        sta (compzp),y
        dey
        bpl -
        ldy tuneheader.ptn_amount 
        jsr compad3

        jsr ldcompzp
        sta ptnfxindexadd+0
        stx ptnfxindexadd+1
        ldy tuneheader.ptn_amount 
-       lda ptniftmp+1,y
        sta (compzp),y
        dey
        bpl -
        ldy tuneheader.ptn_amount 
        jsr compad3

        rts


;----------------------------------------------
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
;Set player pointertable-addresses and other misc.data
setplayer
 .if (MACHINE==2)
        lda #$34
        sta banksel ;get data from RAM under I/O-area
 .fi
        ldx #(DataPtr_end-DataPtr)-2 ;ldx #(PtrValu_end-PtrValu)-1
-       ;txa
        ;asl
        ;tay
        lda DataPtr+0,x ;lda DataPtr,y
        sta datzp+0
        lda DataPtr+1,x ;lda DataPtr+1,y
        sta datzp+1
        ldy PtrValu+0,x
        sty zpload1+1
        iny
        sty zpload2+1
        ldy #1
zpload1 lda $11;selfmod
        clc
        adc PtrValu+1,x
        sta (datzp),y
        iny
zpload2 lda $11;selfmod
        adc #0 ;Add Carry
        sta (datzp),y
        dex
        dex
        bpl -
 .if (MACHINE==2)
        lda #$35
        sta banksel
 .fi
 .if (SUBTUNE_SUPPORT!=0)
        lda tuneheader.subtune_amount
        sta explayer.subtune_amount
 .fi
        ldy #authorinfo_len-1
-       lda authorinfo,y
        sta explayer.authorinfo,y
        dey
        bpl -
        rts
.fi ;end of PLAYABLE_EXPORT_SUPPORT || RUNNABLE_EXPORT_SUPPORT



;---------------------------- misc. routines for packer
ldcompzp lda compzp+0
         ldx compzp+1
        rts

compad0 lda #0
compad1 ldy #selfmod
        iny
compad4 sta (compzp),y
compad3 iny
compad2 tya
compadd clc
        adc compzp+0
        sta compzp+0
        bcc resetvs
        inc compzp+1
resetvs lda #0
        sta validsig
        rts

datzadd clc
        adc datzp+0
        sta datzp+0
        bcc +
        inc datzp+1
+       rts

regvali dec validsig
        sty compad1+1      ;register data-length (info to increase compressed data's pointer)
        rts

adtempz sta inssize
adtmpz2 clc
        adc compzp+0
        sta tempzp+0
        lda compzp+1
        adc #0 ;add Carry
        sta tempzp+1
        rts

validsig .byte 0
inssize .byte 0




;========================== TUNE DEPACKER ==============================

depackworkfile
.if ( PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0 ) ;|| PLAYABLE_IMPORT_SUPPORT>0 )
        lda #packmode_workfile
depacktune ;'tuneendptr' must be set to 1st byte after packed/loaded tune-data
        sta depkmod+1
.fi
        lda tuneendptr+0
.if ( PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0 ) ;|| PLAYABLE_IMPORT_SUPPORT>0 )
depkmod ldy #selfmod ;0:workfile 1:playable tune
        ;cpy #packmode_workfile
        beq + 
        sta compzp+0
        lda tuneendptr+1
        sta compzp+1
        jmp dpkrest ;loader should be able to read and copy the autor-info from players      
.fi
+       sec
        sbc #authorinfo_len
        sta compzp+0
        lda tuneendptr+1
        sbc #0 ;subtract Carry
        sta compzp+1
getauth ldy #authorinfo_len-1
-       lda (compzp),y
        sta authorinfo,y
        dey
        bpl -        
    
dpkrest jsr depttmp
        jsr depkptn
        jsr depkins
        jsr depksub

        rts


;--------------------------------- depack temporary pointers to their place
depttmp ldy tuneheader.ptn_amount
        jsr compsb2
-       cpy #maxptnamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta ptniftmp,y
+       dey
        bpl -
        ldy tuneheader.ptn_amount
        jsr compsb2
-       cpy #maxptnamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta ptniitmp,y
+       dey
        bpl -
        ldy tuneheader.ptn_amount
        jsr compsb2
-       cpy #maxptnamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta ptnphtmp,y
+       dey
        bpl -
        ldy tuneheader.ptn_amount
        jsr compsb2
-       cpy #maxptnamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta ptnpltmp,y
+       dey
        bpl -
        ldy tuneheader.ins_amount
        jsr compsb2
-       cpy #maxinstamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta insphtmp,y
+       dey
        bpl -
        ldy tuneheader.ins_amount
        jsr compsb2
-       cpy #maxinstamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta inspltmp,y
+       dey
        bpl -
        ldy tuneheader.subtune_amount
        jsr compsub
-       cpy #maxsubtuneamount ;+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta seqph2tmp,y
+       dey
        bpl -
        ldy tuneheader.subtune_amount
        jsr compsub
-       cpy #maxsubtuneamount ;+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta seqph1tmp,y
+       dey
        bpl -
        ldy tuneheader.subtune_amount
        jsr compsub
-       cpy #maxsubtuneamount ;+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta seqpl2tmp,y
+       dey
        bpl -
        ldy tuneheader.subtune_amount
        jsr compsub
-       cpy #maxsubtuneamount ;+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta seqpl1tmp,y
+       dey
        bpl -

;correct pointers by the difference to original save-address of loaded tune
        lda #<tuneheader  
        sec
        sbc tuneheader.baseaddress+0
        sta basediff+0
        lda #>tuneheader
        sbc tuneheader.baseaddress+1
        sta basediff+1
corrsub ldy tuneheader.subtune_amount
-       cpy #maxsubtuneamount ;+1 ;omit pointers not fitting into current editor
        bcs +
        lda seqpl1tmp,y
        clc
        adc basediff+0
        sta seqpl1tmp,y
        lda seqph1tmp,y
        adc basediff+1
        sta seqph1tmp,y
        lda seqpl2tmp,y
        clc
        adc basediff+0
        sta seqpl2tmp,y
        lda seqph2tmp,y
        adc basediff+1
        sta seqph2tmp,y
+       dey
        bpl -
corrins ldy tuneheader.ins_amount
-       cpy #maxinstamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda inspltmp,y
        clc
        adc basediff+0
        sta inspltmp,y
        lda insphtmp,y
        adc basediff+1
        sta insphtmp,y
+       dey
        bpl -
corrptn ldy tuneheader.ptn_amount
-       cpy #maxptnamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda ptnpltmp,y
        clc
        adc basediff+0
        sta ptnpltmp,y
        lda ptnphtmp,y
        adc basediff+1
        sta ptnphtmp,y
+       dey
        bpl -
        lda #<tuneheader
        ldx #>tuneheader
        sta tuneheader.baseaddress+0
        stx tuneheader.baseaddress+1
        rts

compsb1 tay
compsb2 iny
compsub sty ystore3+1
        lda compzp+0
        sec
ystore3 sbc #selfmod
        sta compzp+0
        bcs +
        dec compzp+1
+       rts


;------------------------ depack/init patterns
;(as they contain $FF at the end, pointers are not quite necessary to depack'em, but safer)
depkptn ldx #maxptnamount ;compzp must point right after the last patterns last byte
deptnlp lda pattptlo,x
        sta datzp+0
        lda pattpthi,x
        sta datzp+1
        cpx tuneheader.ptn_amount
        beq dpkpatt
        bcs initptn
dpkpatt lda compzp+0
        sec
        sbc ptnpltmp,x
        sec
        sbc ptniftmp,x
        tay
        jsr compsub
        lda fxindexes,x
        jsr dptcolu
        lda ptniftmp,x
        sec
        sbc ptniitmp,x
        tay
        jsr compsub
        lda insindexes,x
        jsr dptcolu
        lda ptnpltmp,x
        sta compzp+0
        lda ptnphtmp,x
        sta compzp+1
        lda #0
        jsr dptcolu
        jmp dnextpt
initptn ldy #0
-       lda #0
        sta (datzp),y
        iny
        cpy #(maxptnlen+1)*3
        bne -
        lda tuneheader.defaultptlen
        sta ptnlen,x
dnextpt dex
        bne deptnlp
        rts
dptcolu ;depacks a pattern-column, including packed NOPs to 'datzp' target address
        stx xstore8+1
        clc
        adc datzp+0
        sta dptargt+1
        lda datzp+1
        adc #0 ;add Carry
        sta dptargt+2
        ldx #0
        stx packcnt
        ldy #0 
-       lda packcnt
        bne wrPkNOP        
        lda (compzp),y 
        iny
        cmp #packNOP_min
        bcc dptargt
        cmp #ptnendval
        beq regplen
depkNOP sec
        sbc #packNOP_min-2
        sta packcnt
wrPkNOP dec packcnt
        lda #0
dptargt sta selfmodA,x
        inx
        bne - ;jmp
regplen txa
xstore8 ldx #selfmod
        sta ptnlen,x
        rts


;------------------------- depack/init instruments
depkins 
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
        lda #<(insnametemp-insnamepos + (maxinstamount-1)*insnamelen)
        ldx #>(insnametemp-insnamepos + (maxinstamount-1)*insnamelen)
        sta inametmptr+0
        stx inametmptr+1
.fi
        ldx #maxinstamount
dpinslp lda insptlo,x
        sta datzp+0
        lda inspthi,x
        sta datzp+1
        cpx tuneheader.ins_amount
        beq dpkinst
        bcs initins
dpkinst lda insphtmp,x
        beq initins ;if packed instrument has zero pointer, init it instead
        sta compzp+1
        lda compzp+0 ;depack loaded instruments
        sec
        sbc inspltmp,x
        sta inssize
        lda inspltmp,x
        sta compzp+0
        jsr dp1inst
        jmp dpnexti
initins ldy #0 ;init instruments above the last loaded instrument
-       lda emptyins,y
        sta (datzp),y
        iny
        cpy #ins_maxsize
        bne -
dpnexti 
.if ( PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0 ) ;|| PLAYABLE_IMPORT_SUPPORT>0 )
        lda inametmptr+0
        sec
        sbc #insnamelen
        sta inametmptr+0
        bcs +
        dec inametmptr+1
.fi
+       dex
        bne dpinslp
retidpk rts

depack1inst
.if ( PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0 ) ;|| PLAYABLE_IMPORT_SUPPORT>0 )
        lda #packmode_workfile ;depack 1 instrument, compzp and datzp are set as base, X holds number of instrument, set inssize!
        sta depkmod+1
.fi
dp1inst ;depack 1 instrument, compzp and datzp are set as base, X holds number of instrument, set dpkmod and inssize!
insthdr ldy #insheadersize-1 ;inst.header-length
.if ( PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0 ) ;|| PLAYABLE_IMPORT_SUPPORT>0 )
        lda depkmod+1
        ;cmp #packmode_workfile
        beq dpkihdr
        ldy #insheadersize-1
-       lda (inametmptr),y
        sta (datzp),y
        dey
        cpy #insmaindatalen-1
        bne -
        ldy #insmaindatalen-1
.fi
dpkihdr lda (compzp),y ;depack instrument-header
        sta (datzp),y
        dey
        bpl dpkihdr
.if ( PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0 ) ;|| PLAYABLE_IMPORT_SUPPORT>0 )
cwfgoff lda depkmod+1
        ;cmp #packmode_workfile
        beq cfrgoff
        ldy #wftbnoteoffindexpos ;correct gateoff-pointers
        lda (compzp),y
        beq cfrgoff ;if zero, nothing to correct
        clc
        adc #insheadersize-insmaindatalen
        sta (datzp),y
.fi
cfrgoff ldy #freqtbstartindexpos
        lda (compzp),y
        sta dpfrqtb+1
        lda #wftbstartindex+maxinstblen+1 ;correct for editor
        sta (datzp),y
        sec
        sbc (compzp),y
        sta cfrgdif+1
        ldy #freqtbnoteoffindexpos
        lda (compzp),y
        beq cvogoff ;if zero, nothing to correct
        clc
cfrgdif adc #selfmod
        sta (datzp),y
cvogoff ldy #voltbstartindexpos
        lda (compzp),y
        sta dpvoltb+1
        lda #wftbstartindex+(maxinstblen+1)*2 ;correct for editor
        sta (datzp),y
        sec
        sbc (compzp),y
        sta cvogdif+1
        ldy #voltbnoteoffindexpos
        lda (compzp),y
        beq dpvoltb ;if zero, nothing to correct
        clc
cvogdif adc #selfmod
        sta (datzp),y
;should start with last table (in-place decompression! after all)
dpvoltb lda #selfmod ;depack volume-table
        sta tblstrt+1
        jsr adtmpz2
        lda inssize
        sec
        sbc dpvoltb+1
        tay
        lda #wftbstartindex+(maxinstblen+1)*2
        jsr dptbcol
dpfrqtb lda #selfmod ;depack freq.table
        sta tblstrt+1
        jsr adtmpz2
        lda dpvoltb+1
        sec
        sbc dpfrqtb+1
        tay
        lda #wftbstartindex+maxinstblen+1
        jsr dptbcol
dpwftbl lda #wftbstartindex ;depack WF-table
.if ( PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0 ) ;|| PLAYABLE_IMPORT_SUPPORT>0 )
        ldy depkmod+1
        ;cmp #packmode_workfile
        beq +
        lda #insmaindatalen
.fi
+       sta tblstrt+1
        jsr adtmpz2
        lda dpfrqtb+1
        sec
        sbc tblstrt+1 ;#wftbstartindex
        tay
        lda #wftbstartindex
;        jsr dptbcol
;        rts
dptbcol sty itbleng+1 ;depack a table-column (tempzp:source-tablebase,datzp:target-tablebase)
        clc
        adc insptlo,x
        sta datzp+0
        lda inspthi,x
        adc #0 ;Add Carry
        sta datzp+1
        ldy #maxinstblen-1
-       lda (tempzp),y
itbleng cpy #selfmod
        bcs +
        cmp #jumpval
        bne wriitbl
        sta (datzp),y
        iny
        lda (datzp),y
        sec
tblstrt sbc #selfmod
        sta (datzp),y
        dey
        jmp nxtbrow
+       lda #0
wriitbl sta (datzp),y
nxtbrow dey
        bpl -
        rts


;---------------------- depack subtune-orderlists (sequences)
depksub ;'compzp' should point right after subtunes' data at entry
        ldx #maxsubtuneamount-1
dpsublp lda seqptrlo+maxsubtuneamount,x
        sta datzp+0
        lda seqptrhi+maxsubtuneamount,x
        sta datzp+1
        cpx tuneheader.subtune_amount
        bcc dpksubt
inisubt ldy #0
-       lda #0
        sta (datzp),y        
        iny
        cpy #maxseqlen+1
        bne -
        jmp dpsubl1 ;dpnexts
dpksubt lda seqph2tmp,x
        beq inisubt ;zero-pointers should be skipped
        sta compzp+1
        lda compzp+0
        sec
        sbc seqpl2tmp,x
        sta seq2len+1
        lda seqpl2tmp,x
        sta compzp+0
        ldy #maxseqlen
-       lda (compzp),y
seq2len cpy #selfmod
        bcc +       
        lda #0 ;clean the rest of the sequence
+       sta (datzp),y
        dey
        bpl -

dpsubl1 lda seqptrlo,x
        sta datzp+0
        lda seqptrhi,x
        sta datzp+1
        cpx tuneheader.subtune_amount
        bcc dpksub1
inisub1 ldy #0
-       lda #0
        sta (datzp),y        
        iny
        cpy #maxseqlen+1
        bne -
        jmp dpnexts
dpksub1 lda seqph1tmp,x
        beq inisub1 ;zero-pointers should be skipped
        sta compzp+1
        lda seqpl1tmp,x
        sta compzp+0
        lda seqpl2tmp,x
        sec
        sbc seqpl1tmp,x
        sta seq1len+1
        ldy #maxseqlen
-       lda (compzp),y
seq1len cpy #selfmod
        bcc +
        lda #0 ;clean the rest of the sequence
+       sta (datzp),y
        dey
        bpl -        
dpnexts dex
        bmi +
        jmp dpsublp
+       rts




;============================= RELOCATION ==============================

.if (RELOCATION_SUPPORT>0)
relocate
        lda relocaddr	;calculate difference
reloca2 sec
		sbc #>PLAYERADDR
		sta relocdiff
		beq retrelo ;if no need for relocation
reloptr
 .if (SUBTUNE_SUPPORT!=0)
relsubp lda tuneheader.subtune_amount 
        asl
        sta twicest+1
        ldy #0  
-       lda (seqpthiadd),y
        clc
        adc relocdiff
        sta (seqpthiadd),y
        iny
twicest cpy #selfmod ;tuneheader.subtune_amount 
        bne -
        jsr compad2
 .fi
relinsp ldy tuneheader.ins_amount
-       lda (inspthiadd),y
        clc
        adc relocdiff
        sta (inspthiadd),y
        dey
        bpl -
relpatp ldy tuneheader.ptn_amount
-       lda (ptnpthiadd),y
        clc
        adc relocdiff
        sta (ptnpthiadd),y
        dey
        bpl -

reloply 
 .if (MACHINE==2)
        lda #$34
        sta banksel ;get reloc-data from RAM under I/O area
 .fi
        lda #>reloctable
        sta reloclp+2
        sta reltadd+2
        ldx #0 ;loop to relocate player-code
reloclp lda reloctable,x ;self-written when needed
        sta datzp+0
        inx
reltadd lda reloctable,x ;self-written when needed
        sta datzp+1
        beq retrelo
		ldy #2	;we modify only 2nd (hi) address-byte of absolute-addressing 6502 instructions in player code
		lda (datzp),y
		clc
		adc relocdiff
		sta (datzp),y
		inx	;go to next relocation-pointer
		bne reloclp
		inc reloclp+2	;in case relocation table would be bigger than 256 bytes
		inc reltadd+2
		bne reloclp
retrelo 
 .if (MACHINE==2)
        lda #$35
        sta banksel
 .fi
        rts

unrelocate	;set everything back to relative of PLAYERADDR (resume relocation, not to affect further exports)
		lda #0	;negate relocation-difference
		sec
		sbc relocdiff	;calculate difference backwards
		beq retrelo
		sta relocdiff	;reset reloc.address
		jmp reloptr ;reloply

relocdiff .byte $00	;hi-address relative to base address
.fi



;=========================== MIDI ROUTINES =============================




.if (HERMIDI_SUPPORT>0)

MIDIcall    ;(A full-blown example can be found in SID-Wizard 1.7 sources/include/midisubs.inc)
        lda #(MACHINE<2)? $11:$0B
        sta bordcol
        lda #0
        sta nOFFcnt+1
        jsr HerMIDI.GetData
EventLp jsr HerMIDI.GetEvent
        bcs rtEvent
        and #$F0 ;eliminate 'channel' info for now
cNoteOn cmp #HerMIDI.MIDI.NoteOn
        bne cNoteOf
        ;lda playmode
        ;bne EventLp
MIDInON inx
        cpx #maxnotenum ;+1
        bcs EventLp
        cpy #0 ;on some keyboards NoteOn vith 0 velocity means Note-Off
        beq NoteOf2
        ;stx jamnote+1
        stx MIDIsig+1
        ;jsr jammer
        jmp EventLp
cNoteOf cmp #HerMIDI.MIDI.NoteOff
        bne chPrChg
        ;lda playmode
        ;bne EventLp
MIDnOFF inx
        cpx #maxnotenum ;+1
        bcs EventLp
NoteOf2 ldy nOFFcnt+1
        txa
        sta nOFFbuf,y
        inc nOFFcnt+1 ;just prescribing it, because new legato-note might come on the same frame
        jmp EventLp
chPrChg cmp #HerMIDI.MIDI.PrgChange
        bne nextEvt
        cpy #1
        bcc EventLp ;nextEvt
        cpy #maxinstamount
        bcs EventLp ;nextEvt
        sty currins
nextEvt jmp EventLp

rtEvent
nOFFcnt ldy #selfmod
        beq doNotON ;diMIDnt
        dey
        lda nOFFbuf,y ;search for noteoff that might arrived for current jamnote
        cmp MIDIsig+1 ;jamnote+1
        bne +
        lda #0
        sta MIDIsig+1
        ;jsr endnote ;done later in 'nokey' part of keyer
+       dec nOFFcnt+1
        bne nOFFcnt
doNotON ldx MIDIsig+1 ;placed AFTER nOFFcnt -> if note is (unlikely) terminated on the same frame, don't start/type it
        beq diMIDnt ;nOFFcnt
        jsr notewr2 ;includes jamming too
diMIDnt ldx MIDIsig+1
        bne +
        ldx #noteoff
+       lda noteCh1,x
        sta VRAM+(instbposy+3)*rowlen+34 ;+VRAM+lastrow*rowlen+34
        lda noteCh2,x
        sta VRAM+(instbposy+3)*rowlen+35 ;VRAM+lastrow*rowlen+35
        lda noteCh3,x
        sta VRAM+(instbposy+3)*rowlen+36 ;VRAM+lastrow*rowlen+36
        lda #bordercolor
        sta bordcol
        rts

nOFFbuf .fill 10,0 ;who has more than 10 fingers that can release on the same 20ms frame? (maybe machines)

HerMIDI .block
INC_SYNCHR = (MACHINE==2) ;if nonzero: synchron-mode READ gets included
INC_ASYNCH = (MACHINE<2)  ;if nonzero: asynchron-mode READ gets included
INC_DIRECT = 0          ;if nonzero:DirectMode READ (DirecRx) gets included
INC_EVENTS = 1          ;if nonzero: 'GetEvent' subroutine gets included
  .include (MACHINE<2)? "HerMIDI-Plus4.asm" : "HerMIDI-C64.asm"
 .bend
.fi


.if (MACHINE==2) 
 #pointertables
end_of_code
 *=$d000 ;data under I/O-area follows for C64
.fi


;============================== HELPTEXT ===============================
.if (HELPTEXT_SUPPORT>0)
;.enc screen
helptxt .block
.text "KEYS: F1/F2/F3: Play: begin/mark/pattern"
.text "----F4/RUNSTOP: Stop/Continue(C=:follow)"
.text "Sh+P/O/I F5-F8: Patt/Orderlist/Inst/Menu"
.text " Shift + SPACE: Put mark / Play from pos"
.text "ESC, C=/Sh+ESC: FastForward,(Auto)Follow"
.text "CONTROL, SPACE: Tabulate , Edit/Jam-mode"
.text "Shift+N , C=+N: Instr.Name, Tbl.NoteMode"
.text "C=+,/. (Sh)+/-: Select SubTune/Ins./Patt"
.text "RETURN in patt: NoteOFF/ON(Sh), Len.(C=)"
.text "RET.in orderl.: Select Patterns to edit "
.text "C=+0..9 Sh+1/2: Select Octave / Mute chn"
.text "C=+F/G, C=+A/J: FrameSpd/AutoAdv/FullJam"
.text "Sh+Q/W, C=+Q/W: Transpose Patt from Curs"
.text "C= + X / C / V: Cut/Copy/Paste from Curs"
.text "Sh/C=+V/U/D/L/T/S:Vib/Sli/Lega/Port/Sync"
.text "---wf-------frq--------vol--fx-0:Duratio"
.text "Xx:X&Wait 0x:Wait   0x:Wait  123:Sli/Por"
.text "2x:Pulse 1x2X:Slide 1x:FadeIn  4:WF.jump"
.text "3x:PSync 3x:Detune  2x:FadeOut 5:NoteVol"
.text "4x:Noise 4x5x:RelUp 3x:PrioVol 6:VOLjump"
.text "5x:NSync 60:IncVibr 4x:LoudVol 7:FRQjump"
.text "6x:NoSnd 7x6x:RelDn 5x:AverVol 8:Vibrato"
.text "80..FE:  80:Vibrato -orderlist-9:Detune-"
.text "   Phase 81..FE:Abs 8,9:Transp,A:MainVol"
.text "FF:Jump(everywh)D:Detun,E:Fade,B:TempoPr"
.bend
helptxt_end
;.enc none
chrmod .var ()
.for i=0,i<helptxt_end-helptxt,i=i+1
 .if (helptxt[i]>=$60)
  chrmod .var chrmod..(helptxt[i]&$1F,)
 .else
  chrmod .var chrmod..(helptxt[i],)
 .fi
.next
*=helptxt
.byte chrmod
.fi ;end of HELPTEXT_SUPPORT

;=========================== EXAMPLE TUNE ==============================
.if (EXAMPLE_TUNE_SUPPORT>0)
demotune
 .if (PLAYERTYPE==0) ;normal?
  .binary "examplnormex.tzw",2
 .elsif (PLAYERTYPE==1) ;medium?
  .binary "examplmedium.tzw",2
 .elsif (PLAYERTYPE==2) ;light?
  .binary "examplelight.tzw",2
 .elsif (PLAYERTYPE==3) ;extra?
  .binary "examplnormex.tzw",2
 .elsif (PLAYERTYPE==4) ;bare?
  .binary "example-bare.tzw",2
 .elsif (PLAYERTYPE==5) ;demo?
  .binary "example-demo.tzw",2
 .fi
demotune_end
.fi

;========================== MISC DATE UNDER I/O ========================
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
 .if (MACHINE==2)
  #relocdata
 .fi
.fi


.if (MACHINE==0)
end_of_code
 .cerror (*>=$4000),"Exceeded Top of C16 memory!",* ;top of C16 memory reached? no way to run :(
.elsif (MACHINE==1)
end_of_code
 .cerror (*>=$FD00),"Exceeded Top Of memory!",*
.else
 *=end_of_code
 .cerror (*>=$FFF8),"Exceeded Top Of memory!",* 
.fi




;=======================================================================
